var fan = {};
fan.sys = {};
fan.sys.Obj = function() {};
fan.sys.Obj.$extend = function(base)
{
function f() { this.$ctor.apply(this, arguments); }
f.prototype = new base;
f.prototype.constructor = f;
return f;
}
fan.sys.Obj.prototype.$ctor = function() {}
fan.sys.Obj.prototype.make$ = function() {}
fan.sys.Obj.prototype.equals = function(that)
{
return this == that;
}
fan.sys.Obj.prototype.compare = function(that)
{
if (this < that) return -1;
if (this > that) return 1;
return 0;
}
fan.sys.Obj.prototype.$with = function(func)
{
func(this);
return this;
}
fan.sys.Obj.prototype.isImmutable = function()
{
return false;
}
fan.sys.Obj.prototype.type = function()
{
return fan.sys.Type.find("sys::Obj")
}
fan.sys.Obj.prototype.toStr = function()
{
return "" + this.type();
}
fan.sys.Obj.prototype.toString = function()
{
return "" + this.toStr();
}
fan.sys.Obj.equals = function(self, that)
{
if (self instanceof fan.sys.Obj) return self.equals(that);
else if (self instanceof Long) return fan.sys.Int.equals(self, that);
else if ((typeof self) == "number") return fan.sys.Int.equals(self, that);
else if (self != null && self.constructor == Array) return fan.sys.List.equals(self, that);
else
{
if (self != null && self.$fanType != null)
return fan.sys.Float.equals(self, that);
else
return self == that;
}
}
fan.sys.Obj.compare = function(self, that)
{
if (self instanceof fan.sys.Obj)
{
if (that == null) return +1;
return self.compare(that);
}
else
{
if (self == null)
{
if (that != null) return -1;
return 0;
}
if (that == null) return 1;
if (self < that) return -1;
if (self > that) return 1;
return 0;
}
}
fan.sys.Obj.is = function(obj, type)
{
if (obj == null) return false;
return fan.sys.Obj.type(obj).is(type);
}
fan.sys.Obj.as = function(obj, type)
{
if (obj == null) return false;
if (fan.sys.Obj.type(obj).is(type)) return obj;
return null;
}
fan.sys.Obj.isImmutable = function(self)
{
if (self instanceof fan.sys.Obj)
return self.isImmutable();
else
{
if ((typeof self) == "boolean") return true;
if ((typeof self) == "number") return true;
if (self != null && self.$fanType != null) return true;
throw new fan.sys.Err("sys::Obj.isImmutable: Not a Fan type: " + self);
}
}
fan.sys.Obj.type = function(self)
{
if (self == null) throw fan.sys.Err.make("fan.sys.Obj.type: self is null");
if (self instanceof fan.sys.Obj)
return self.type();
else
return fan.sys.Type.toFanType(self);
}
fan.sys.Obj.toStr = function(obj)
{
if (obj == null) return "null";
if (typeof obj == "string") return obj;
if (obj.constructor == Array) return fan.sys.List.toStr(obj);
if (obj instanceof Error) return Error.prototype.toString.call(obj);
if (obj.$fanType == fan.sys.Type.find("sys::Float")) return fan.sys.Float.toStr(obj);
return obj.toString();
}
fan.sys.Obj.echo = function(str)
{
var s = fan.sys.Obj.toStr(str);
try { console.log(s); }
catch (e1)
{
try { println(s); }
catch (e2) {}
}
}
fan.sys.Obj.$with = function(self, func)
{
func(self);
return self;
}
fan.sys.Pod = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Pod.prototype.$ctor = function(name)
{
this.m_name  = name;
this.m_types = [];
}
fan.sys.Pod.prototype.name = function()
{
return this.m_name;
}
fan.sys.Pod.prototype.types = function()
{
if (this.$typesArray == null)
{
var arr = [];
for (p in this.m_types) arr.push(this.m_types[p]);
this.$typesArray = fan.sys.List.make(fan.sys.Type.find("sys::Type"), arr);
}
return this.$typesArray;
}
fan.sys.Pod.prototype.findType = function(qname, checked)
{
if (checked == undefined) checked = true;
var t = this.m_types[qname];
if (t == null && checked)
throw fan.sys.UnknownTypeErr.make(qname);
return t;
}
fan.sys.Pod.prototype.loc = function(key, def)
{
if (key == "ok.name") return "OK";
if (key == "cancel.name") return "Cancel";
if (key == "yes.name") return "Yes";
if (key == "no.name") return "No";
if (key == "details.name") return "Details";
if (key == "err.name") return "Error";
if (key == "err.image") return "/sys/pod/icons/x32/err.png";
if (key == "warn.name") return "Warning";
if (key == "warn.image") return "/sys/pod/icons/x32/warn.png";
if (key == "info.name") return "Info";
if (key == "info.image") return "/sys/pod/icons/x32/question.png";
if (key == "question.name") return "Question";
if (key == "question.image") return "/sys/pod/icons/x32/question.png";
return def;
}
fan.sys.Pod.prototype.toStr = function() { return this.m_name; }
fan.sys.Pod.prototype.$at = function(name, baseQname, mixins)
{
var qname = this.m_name + "::" + name;
if (this.m_types[name] != null)
throw fan.sys.Err.make("Type already exists " + qname);
var t = new fan.sys.Type(qname, baseQname, mixins);
this.m_types[name] = t;
return t;
}
fan.sys.Pod.prototype.$am = function(name, baseQname, mixins)
{
var t = this.$at(name, baseQname, mixins);
t.m_isMixin = true;
return t;
}
fan.sys.Pod.list = function()
{
return fan.sys.Pod.$pods;
}
fan.sys.Pod.find = function(name, checked)
{
if (checked == undefined) checked = true;
var p = fan.sys.Pod.$pods[name];
if (p == null && checked)
throw fan.sys.UnknownPodErr.make(name);
return p;
}
fan.sys.Pod.$add = function(name)
{
if (fan.sys.Pod.$pods[name] != null)
throw fan.sys.Err.make("Pod already exists " + name);
var p = new fan.sys.Pod(name);
fan.sys.Pod.$pods[name] = p;
return p;
}
fan.sys.Pod.$pods = [];
fan.sys.Type = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Type.prototype.$ctor = function(qname, base, mixins)
{
if (qname == undefined) return;
if (mixins == undefined) mixins = [];
for (var i=0; i<mixins.length; i++)
mixins[i] = fan.sys.Type.find(mixins[i]);
var s = qname.split("::");
this.m_qname   = qname;
this.m_pod     = fan.sys.Pod.find(s[0]);
this.m_name    = s[1];
this.m_base    = base == null ? null : fan.sys.Type.find(base);
this.m_mixins  = mixins;
this.m_slots   = [];
this.m_$qname  = qname.replace("::", "_");
this.m_$qname  = 'fan.' + this.m_pod + '.' + this.m_name;
this.m_isMixin = false;
}
fan.sys.Type.prototype.base = function()      { return this.m_base; }
fan.sys.Type.prototype.mixins = function()    { return this.m_mixins; }
fan.sys.Type.prototype.isClass = function()   { return !this.m_isMixin && this.m_base.m_qname != "sys::Enum"; }
fan.sys.Type.prototype.isEnum = function()    { return this.m_base != null && this.m_base.m_qname == "sys::Enum"; }
fan.sys.Type.prototype.isMixin = function()   { return this.m_isMixin; }
fan.sys.Type.prototype.log = function()       { return fan.sys.Log.get(this.m_pod.m_name); }
fan.sys.Type.prototype.name = function()      { return this.m_name; }
fan.sys.Type.prototype.qname = function()     { return this.m_qname; }
fan.sys.Type.prototype.pod = function()       { return this.m_pod; }
fan.sys.Type.prototype.signature = function() { return this.m_qname; }
fan.sys.Type.prototype.toStr = function()     { return this.signature(); }
fan.sys.Type.prototype.toLocale = function()  { return this.signature(); }
fan.sys.Type.prototype.type = function()      { return fan.sys.Type.find("sys::Type"); }
fan.sys.Type.prototype.toListOf = function()  { return new fan.sys.ListType(this); }
fan.sys.Type.prototype.emptyList = function() { return new fan.sys.ListType(this); }
fan.sys.Type.prototype.fits = function(that) { return this.is(that); }
fan.sys.Type.prototype.is = function(that)
{
if (this.equals(that)) return true;
var base = this.m_base;
while (base != null)
{
if (base.equals(that)) return true;
base = base.m_base;
}
var m = this.m_mixins;
for (var i=0; i<m.length; i++)
if (fan.sys.Type.isMixin(m[i], that)) return true;
return false;
}
fan.sys.Type.isMixin = function(mixin, that)
{
if (mixin.equals(that)) return true;
var m = mixin.m_mixins;
for (var i=0; i<m.length; i++)
if (fan.sys.Type.isMixin(m[i], that))
return true;
return false;
}
fan.sys.Type.prototype.toNullable = function() { return this; }
fan.sys.Type.prototype.toNonNullable = function() { return this; }
fan.sys.Type.prototype.make = function()
{
if (this.m_$defVal != null) return this.m_$defVal;
var obj = eval(this.m_$qname);
if (obj.defVal != null) { this.$defVal = obj.defVal; return obj.defVal; }
return obj.make();
}
fan.sys.Type.prototype.slots = function()
{
var acc = [];
for (var i in this.m_slots)
acc.push(this.m_slots[i]);
return acc;
}
fan.sys.Type.prototype.methods = function()
{
var acc = [];
for (var i in this.m_slots)
if (this.m_slots[i] instanceof fan.sys.Method)
acc.push(this.m_slots[i]);
return acc;
}
fan.sys.Type.prototype.fields = function()
{
var acc = [];
for (var i in this.m_slots)
if (this.m_slots[i] instanceof fan.sys.Field)
acc.push(this.m_slots[i]);
return acc;
}
fan.sys.Type.prototype.slot = function(name, checked)
{
if (checked == undefined) checked = true;
var s = this.$slot(name);
if (s == null && checked)
throw fan.sys.UnknownSlotErr.make(this.m_qname + "." + name);
return s;
}
fan.sys.Type.prototype.method = function(name, checked)
{
if (checked == undefined) checked = true;
var f = this.$slot(name);
if ((f == null || !(f instanceof fan.sys.Method)) && checked)
throw fan.sys.UnknownSlotErr.make(this.m_qname + "." + name);
return f;
}
fan.sys.Type.prototype.field = function(name, checked)
{
if (checked == undefined) checked = true;
var f = this.$slot(name);
if ((f == null || !(f instanceof fan.sys.Field)) && checked)
throw fan.sys.UnknownSlotErr.make(this.m_qname + "." + name);
return f;
}
fan.sys.Type.prototype.$am = function(name)
{
var m = new fan.sys.Method(this, name);
this.m_slots[name] = m;
return this;
}
fan.sys.Type.prototype.$af = function(name, flags, of)
{
var t = fanx_TypeParser.load(of);
var f = new fan.sys.Field(this, name, flags, t);
this.m_slots[name] = f;
return this;
}
fan.sys.Type.prototype.$slot = function(name)
{
var slot = this.m_slots[name];
if (slot != null) return slot;
var base = this.m_base;
while (base != null)
{
slot = base.m_slots[name];
if (slot != null) return slot;
base = base.m_base;
}
return null;
}
fan.sys.Type.find = function(sig, checked)
{
return fanx_TypeParser.load(sig, checked);
}
fan.sys.Type.toFanType = function(obj)
{
if (obj== null) throw fan.sys.Err.make("sys::Type.toFanType: obj is null");
if (obj.$fanType != undefined) return obj.$fanType;
if ((typeof obj) == "boolean" || obj instanceof Boolean) return fan.sys.Type.find("sys::Bool");
if ((typeof obj) == "number"  || obj instanceof Number)  return fan.sys.Type.find("sys::Int");
if ((typeof obj) == "string"  || obj instanceof String)  return fan.sys.Type.find("sys::Str");
throw fan.sys.Err.make("sys::Type.toFanType: Not a Fan type: " + obj);
}
fan.sys.Type.common = function(objs)
{
if (objs.length == 0) return fan.sys.Type.find("sys::Obj").toNullable();
var nullable = false;
var best = null;
for (var i=0; i<objs.length; i++)
{
var obj = objs[i];
if (obj == null) { nullable = true; continue; }
var t = fan.sys.Obj.type(obj);
if (best == null) { best = t; continue; }
while (!t.is(best))
{
best = best.base();
if (best == null) return nullable ? fan.sys.Type.find("sys::Obj").toNullable() : fan.sys.Type.find("sys::Obj");
}
}
if (best == null) best = fan.sys.Type.find("sys::Obj");
return nullable ? best.toNullable() : best;
}
fan.sys.ListType = fan.sys.Obj.$extend(fan.sys.Type)
fan.sys.ListType.prototype.$ctor = function(v)
{
this.v = v;
this.m_mixins = [];
}
fan.sys.ListType.prototype.signature = function() { return this.v.signature() + '[]'; }
fan.sys.ListType.prototype.equals = function(that)
{
if (that instanceof fan.sys.ListType)
return this.v.equals(that.v);
else
return false;
}
fan.sys.MapType = fan.sys.Obj.$extend(fan.sys.Type);
fan.sys.MapType.prototype.$ctor = function(k, v)
{
this.k = k;
this.v = v;
this.m_mixins = [];
}
fan.sys.MapType.prototype.signature = function()
{
return "[" + this.k.signature() + ':' + this.v.signature() + ']';
}
fan.sys.MapType.prototype.equals = function(that)
{
if (that instanceof fan.sys.MapType)
return this.k.equals(that.k) && this.v.equals(that.v);
else
return false;
}
fan.sys.FuncType = fan.sys.Obj.$extend(fan.sys.Type);
fan.sys.FuncType.prototype.$ctor = function(params, ret)
{
this.params = params;
this.ret = ret;
this.m_mixins = [];
}
fan.sys.FuncType.prototype.signature = function()
{
var s = '|'
for (var i=0; i<this.params.length; i++)
{
if (i > 0) s += ',';
s += this.params[i].signature();
}
s += '->';
s += this.ret.signature();
s += '|';
return s;
}
fan.sys.FuncType.prototype.equals = function(that)
{
if (that instanceof fan.sys.FuncType)
{
if (this.params.length != that.params.length) return false;
for (var i=0; i<this.params.length; i++)
if (!this.params[i].equals(that.params[i])) return false;
return this.ret.equals(that.ret);
}
return false;
}
fan.sys.FuncType.prototype.is = function(that)
{
if (this == that) return true;
if (that instanceof fan.sys.FuncType)
{
if (that.ret.m_qname != "sys::Void" && !this.ret.is(that.ret)) return false;
if (this.params.length > that.params.length) return false;
for (var i=0; i<this.params.length; ++i)
if (!that.params[i].is(this.params[i])) return false;
return true;
}
return this.base().is(that);
}
fan.sys.Slot = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Slot.prototype.$ctor = function()
{
this.m_parent = null;
this.m_qname  = null;
this.m_name   = null;
this.m_flags  = null;
}
fan.sys.Slot.prototype.type = function() { return fan.sys.Type.find("sys::Slot"); }
fan.sys.Slot.prototype.toStr = function() { return this.m_qname; }
fan.sys.Slot.prototype.parent = function() { return this.m_parent; }
fan.sys.Slot.prototype.qname = function() { return this.m_qname; }
fan.sys.Slot.prototype.name = function() { return this.m_name; }
fan.sys.Slot.prototype.isAbstract = function()  { return (this.m_flags & fan.sys.FConst.Abstract)  != 0; }
fan.sys.Slot.prototype.isConst = function()     { return (this.m_flags & fan.sys.FConst.Const)     != 0; }
fan.sys.Slot.prototype.isCtor = function()      { return (this.m_flags & fan.sys.FConst.Ctor)      != 0; }
fan.sys.Slot.prototype.isInternal = function()  { return (this.m_flags & fan.sys.FConst.Internal)  != 0; }
fan.sys.Slot.prototype.isNative = function()    { return (this.m_flags & fan.sys.FConst.Native)    != 0; }
fan.sys.Slot.prototype.isOverride = function()  { return (this.m_flags & fan.sys.FConst.Override)  != 0; }
fan.sys.Slot.prototype.isPrivate = function()   { return (this.m_flags & fan.sys.FConst.Private)   != 0; }
fan.sys.Slot.prototype.isProtected = function() { return (this.m_flags & fan.sys.FConst.Protected) != 0; }
fan.sys.Slot.prototype.isPublic = function()    { return (this.m_flags & fan.sys.FConst.Public)    != 0; }
fan.sys.Slot.prototype.isStatic = function()    { return (this.m_flags & fan.sys.FConst.Static)    != 0; }
fan.sys.Slot.prototype.isSynthetic = function() { return (this.m_flags & fan.sys.FConst.Synthetic) != 0; }
fan.sys.Slot.prototype.isVirtual = function()   { return (this.m_flags & fan.sys.FConst.Virtual)   != 0; }
fan.sys.Slot.prototype.$name = function(n)
{
switch (n)
{
case "char":   return "$char";
case "delete": return "$delete";
case "in":     return "$in";
case "var":    return "$var";
case "with":   return "$with";
}
return n;
}
fan.sys.Err = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Err.prototype.$ctor = function(msg)
{
this.msg = msg;
}
fan.sys.Err.prototype.type = function()
{
return fan.sys.Type.find("sys::Err");
}
fan.sys.Err.prototype.toString = function()
{
return this.type() + ": " + this.msg;
}
fan.sys.Err.prototype.message = function()
{
return this.msg;
}
fan.sys.Err.prototype.traceToStr = function()
{
return this.toString();
}
fan.sys.Err.make = function(cause)
{
if (cause instanceof fan.sys.Err) return cause;
if (cause instanceof TypeError) return new fan.sys.NullErr(cause.message);
if ((typeof cause) == "string") return new fan.sys.Err(cause);
return new fan.sys.Err(''+cause);
}
fan.sys.Err.trace = function(self)
{
fan.sys.Obj.echo(self)
}
fan.sys.ArgErr = fan.sys.Obj.$extend(fan.sys.Err);
fan.sys.ArgErr.prototype.$ctor = function(msg) { fan.sys.Err.prototype.$ctor.call(this, msg); }
fan.sys.ArgErr.prototype.type = function() { return fan.sys.Type.find("sys::ArgErr"); }
fan.sys.ArgErr.make = function(msg) { return new fan.sys.ArgErr(msg); }
fan.sys.NullErr = fan.sys.Obj.$extend(fan.sys.Err);
fan.sys.NullErr.prototype.$ctor = function(msg) { fan.sys.Err.prototype.$ctor.call(this, msg); }
fan.sys.NullErr.prototype.type = function() { return fan.sys.Type.find("sys::NullErr"); }
fan.sys.NullErr.make = function(msg) { return new fan.sys.NullErr(msg); }
fan.sys.IOErr = fan.sys.Obj.$extend(fan.sys.Err);
fan.sys.IOErr.prototype.$ctor = function(msg) { fan.sys.Err.prototype.$ctor.call(this, msg); }
fan.sys.IOErr.prototype.type = function() { return fan.sys.Type.find("sys::IOErr"); }
fan.sys.IOErr.make = function(msg) { return new fan.sys.IOErr(msg); }
fan.sys.IndexErr = fan.sys.Obj.$extend(fan.sys.Err);
fan.sys.IndexErr.prototype.$ctor = function(msg) { fan.sys.Err.prototype.$ctor.call(this, msg); }
fan.sys.IndexErr.prototype.type = function() { return fan.sys.Type.find("sys::IndexErr"); }
fan.sys.IndexErr.make = function(msg) { return new fan.sys.IndexErr(msg); }
fan.sys.ParseErr = fan.sys.Obj.$extend(fan.sys.Err);
fan.sys.ParseErr.prototype.$ctor = function(type, val, more)
{
var msg = type;
if (val != undefined)
{
msg = "Invalid " + type + ": '" + val + "'";
if (more != undefined) msg += ": " + more;
}
fan.sys.Err.prototype.$ctor.call(this, msg)
}
fan.sys.ParseErr.prototype.type = function() { return fan.sys.Type.find("sys::ParseErr"); }
fan.sys.ParseErr.make = function(type, val, more) { return new fan.sys.ParseErr(type,val,more); }
fan.sys.ReadonlyErr = fan.sys.Obj.$extend(fan.sys.Err);
fan.sys.ReadonlyErr.prototype.$ctor = function(msg) { fan.sys.Err.prototype.$ctor.call(this, msg); }
fan.sys.ReadonlyErr.prototype.type = function() { return fan.sys.Type.find("sys::ReadonlyErr"); }
fan.sys.ReadonlyErr.make = function(msg) { return new fan.sys.ReadonlyErr(msg); }
fan.sys.UnknownPodErr = fan.sys.Obj.$extend(fan.sys.Err);
fan.sys.UnknownPodErr.prototype.$ctor = function(msg) { fan.sys.Err.prototype.$ctor.call(this, msg); }
fan.sys.UnknownPodErr.prototype.type = function() { return fan.sys.Type.find("sys::UnknownPodErr"); }
fan.sys.UnknownPodErr.make = function(msg) { return new fan.sys.UnknownPodErr(msg); }
fan.sys.UnknownTypeErr = fan.sys.Obj.$extend(fan.sys.Err);
fan.sys.UnknownTypeErr.prototype.$ctor = function(msg) { fan.sys.Err.prototype.$ctor.call(this, msg); }
fan.sys.UnknownTypeErr.prototype.type = function() { return fan.sys.Type.find("sys::UnknownTypeErr"); }
fan.sys.UnknownTypeErr.make = function(msg) { return new fan.sys.UnknownTypeErr(msg); }
fan.sys.UnknownSlotErr = fan.sys.Obj.$extend(fan.sys.Err);
fan.sys.UnknownSlotErr.prototype.$ctor = function(msg) { fan.sys.Err.prototype.$ctor.call(this, msg); }
fan.sys.UnknownSlotErr.prototype.type = function() { return fan.sys.Type.find("sys::UnknownSlotErr"); }
fan.sys.UnknownSlotErr.make = function(msg) { return new fan.sys.UnknownSlotErr(msg); }
fan.sys.UnsupportedErr = fan.sys.Obj.$extend(fan.sys.Err);
fan.sys.UnsupportedErr.prototype.$ctor = function(msg) { fan.sys.Err.prototype.$ctor.call(this, msg); }
fan.sys.UnsupportedErr.prototype.type = function() { return fan.sys.Type.find("sys::UnsupportedErr"); }
fan.sys.UnsupportedErr.make = function(msg) { return new fan.sys.UnsupportedErr(msg); }
fan.sys.UnresolvedErr = fan.sys.Obj.$extend(fan.sys.Err);
fan.sys.UnresolvedErr.prototype.$ctor = function(msg) { fan.sys.Err.prototype.$ctor.call(this, msg); }
fan.sys.UnresolvedErr.prototype.type = function() { return fan.sys.Type.find("sys::UnresolvedErr"); }
fan.sys.UnresolvedErr.make = function(msg) { return new fan.sys.UnresolvedErr(msg); }
fan.sys.Func = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Func.prototype.$ctor = function() {}
fan.sys.Func.prototype.type = function() { return fan.sys.Type.find("sys::Func"); }
fan.sys.Func.make = function(f, params, ret)
{
var types = [];
for (var i=0; i<params.length; i++)
types.push(params[i].m_of);
f.$fanParams = params;
f.$fanType = new fan.sys.FuncType(types, ret);
return f;
}
fan.sys.Func.params   = function(f) { return f.$fanParams; }
fan.sys.Func.ret      = function(f) { return f.$fanType.ret; }
fan.sys.Func.call     = function(f)
{
var args = Array.prototype.slice.call(arguments).slice(1);
return f.apply(null, args);
}
fan.sys.Func.callList = function(f, args) { return f.apply(null, args); }
fan.sys.Func.callOn   = function(f, obj, args)
{
var acc = args.slice();
acc.unshift(obj);
return f.apply(null, acc);
}
fan.sys.Func.curry = function(f, args)
{
var t = f.$fanType;
if (args.length == 0) return f;
if (args.length > t.params.length)
throw fan.sys.ArgErr.make("args.size > params.size");
var len = t.params.length - args.length;
var newParams = [];
for (var i=0; i<len; i++)
newParams.push(t.params[args.length+i])
return fan.sys.Func.make(function() {
var curried = args.slice();
for (var i=0; i<arguments.length; i++)
curried.push(arguments[i]);
return f.apply(null, curried);
}, newParams, t.ret);
}
fan.sys.Num = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Num.prototype.$ctor = function() {}
fan.sys.Num.prototype.type = function()
{
return fan.sys.Type.find("sys::Num");
}
fan.sys.Num.toDecimal = function(val) { return val; }
fan.sys.Num.toFloat = function(val) { return val; }
fan.sys.Num.toInt = function(val)
{
if (isNaN(val)) return 0;
if (val == Number.POSITIVE_INFINITY) return fan.sys.Int.maxVal;
if (val == Number.NEGATIVE_INFINITY) return fan.sys.Int.minVal;
return Math.floor(val);
}
fan.sys.List = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.List.prototype.$ctor = function() {}
fan.sys.List.prototype.type = function()  { return fan.sys.Type.find("sys::List"); }
fan.sys.List.make = function(type, vals)
{
vals.$fanType = new fan.sys.ListType(type);
return vals;
}
fan.sys.List.equals = function(self, that)
{
if (that != null && that.constructor == Array)
{
if (self.length != that.length) return false;
for (var i=0; i<self.length; i++)
if (!fan.sys.Obj.equals(self[i], that[i]))
return false;
return true;
}
return false;
}
fan.sys.List.toStr = function(self)
{
if (self.length == 0) return "[,]";
var s = "[";
for (var i=0; i<self.length; i++)
{
if (i > 0) s += ", ";
s += self[i];
}
s += "]";
return s;
}
fan.sys.List.isEmpty = function(self)
{
return self.length == 0;
}
fan.sys.List.add = function(self, item)
{
self.push(item);
return self;
}
fan.sys.List.addAll = function(self, list)
{
return fan.sys.List.make(self.$fanType, self.concat(list));
}
fan.sys.List.insert = function(self, index, item)
{
self.splice(index, 0, item);
return self;
}
fan.sys.List.removeSame = function(self, val)
{
var index = fan.sys.List.indexSame(self, val);
if (index == null) return null;
return fan.sys.List.removeAt(self, index);
}
fan.sys.List.removeAt = function(self, index)
{
return self.splice(index, 1);
}
fan.sys.List.clear = function(self)
{
self.splice(0, self.length);
return self;
}
fan.sys.List.fill = function(self, val, times)
{
for (var i=0; i<times; i++) self.push(val);
return self;
}
fan.sys.List.slice = function(self, range)
{
var size = self.length;
var s = range.start(size);
var e = range.end(size);
if (e+1 < s) throw new fan.sys.IndexErr(r);
return self.slice(s, e+1);
}
fan.sys.List.contains = function(self, val)
{
return fan.sys.List.index(self, val) != null;
}
fan.sys.List.sort = function(self, func)
{
if (func != null)
return self.sort(func);
else
return self.sort();
}
fan.sys.List.index = function(self, val, off)
{
if (off == undefined) off = 0;
if (self.length == 0) return null;
var start = off;
if (start < 0) start = self.length + start;
if (start >= self.length) throw fan.sys.IndexErr.make(off);
try
{
if (val == null)
{
for (var i=start; i<sef.length; ++i)
if (self[i] == null)
return i;
}
else
{
for (var i=start; i<self.length; ++i)
{
var obj = self[i];
if (obj != null && fan.sys.Obj.equals(obj, val))
return i;
}
}
return null;
}
catch (err)
{
throw fan.sys.IndexErr.make(off);
}
}
fan.sys.List.indexSame = function(self, val, off)
{
if (off == undefined) off = 0;
if (self.length == 0) return null;
var start = off;
if (start < 0) start = self.length + start;
if (start >= self.length) throw fan.sys.IndexErr.make(off);
try
{
for (var i=start; i<self.length; i++)
if (val == self[i])
return i;
return null;
}
catch (err)
{
throw fan.sys.IndexErr.make(off);
}
}
fan.sys.List.first = function(self)
{
if (self.length == 0) return null;
return self[0];
}
fan.sys.List.last = function(self)
{
if (self.length == 0) return null;
return self[self.length-1];
}
fan.sys.List.dup = function(self)
{
return fan.sys.List.make(self.$fanType, self.slice());
}
fan.sys.List.each = function(self, func)
{
if (func.length == 1)
{
for (var i=0; i<self.length; i++)
func(self[i])
}
else
{
for (var i=0; i<self.length; i++)
func(self[i], i)
}
}
fan.sys.List.eachr = function(self, func)
{
if (func.length == 1)
{
for (var i=self.length-1; i>=0; i--)
func(self[i])
}
else
{
for (var i=self.length-1; i>=0; i--)
func(self[i], i)
}
}
fan.sys.List.eachWhile = function(self, f)
{
if (f.length == 1)
{
for (var i=0; i<self.length; ++i)
{
var r = f(self[i]);
if (r != null) return r;
}
}
else
{
for (var i=0; i<self.length; ++i)
{
var r = f(self[i], i);
if (r != null) return r;
}
}
return null;
}
fan.sys.List.find = function(self, f)
{
if (f.length == 1)
{
for (var i=0; i<self.length; i++)
if (f(self[i]) == true)
return self[i];
}
else
{
for (var i=0; i<self.length; i++)
if (f(self[i], i) == true)
return self[i];
}
return null;
}
fan.sys.List.map = function(self, f)
{
var r = f.$fanType.ret;
var acc = fan.sys.List.make(r, []);
if (f.length == 1)
{
for (var i=0; i<self.length; ++i)
acc.push(f(self[i]));
}
else
{
for (var i=0; i<self.length; ++i)
acc.push(f(self[i], i));
}
return acc;
}
fan.sys.List.max = function(self, f)
{
if (f == undefined) f = null;
if (self.length == 0) return null;
var max = self[0];
for (var i=1; i<self.length; ++i)
{
var s = self[i];
if (f == null)
max = (s != null && s > max) ? s : max;
else
max = (s != null && f(s, max) > 0) ? s : max;
}
return max;
}
fan.sys.List.min = function(self, f)
{
if (f == undefined) f = null;
if (self.length == 0) return null;
var min = self[0];
for (var i=1; i<self.length; ++i)
{
var s = self[i];
if (f == null)
min = (s == null || s < min) ? s : min;
else
min = (s == null || f(s, min) < 0) ? s : min;
}
return min;
}
fan.sys.List.rw = function(self) { return fan.sys.List.make(self.$fanType, self.slice()); }
fan.sys.List.ro = function(self) { return fan.sys.List.make(self.$fanType, self.slice()); }
fan.sys.List.toImmutable = function(self) { return fan.sys.List.make(self.$fanType, self.slice()); }
fan.sys.List.join = function(self, sep, func)
{
if (sep == undefined) sep = ""
if (self.length == 0) return "";
if (self.length == 1)
{
var v = self[0];
if (func != undefined) return func(v, 0);
if (v == null) return "null";
return fan.sys.Obj.toStr(v);
}
var s = ""
for (var i=0; i<self.length; ++i)
{
if (i > 0) s += sep;
if (func == undefined)
s += self[i];
else
s += func(self[i], i);
}
return s;
}
fan.sys.Map = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Map.prototype.$ctor = function(k, v)
{
var mt = null;
if (k != undefined && v == undefined)
{
mt = k;
}
else
{
if (k == undefined) k = fan.sys.Type.find("sys::Obj")
if (v == undefined) v = fan.sys.Type.find("sys::Obj")
mt = new fan.sys.MapType(k, v);
}
this.map = {};
this.$fanType = mt;
}
fan.sys.Map.prototype.equals = function(that)
{
if (that != null)
{
if (!this.$fanType.equals(that.$fanType)) return false;
var selfNum = 0;
for (var k in this.map)
{
if (this.map[k] != that.map[k]) return false;
selfNum++;
}
var thatNum = 0;
for (var k in that.map) thatNum++;
return selfNum == thatNum;
}
return false;
}
fan.sys.Map.prototype.hash = function()
{
return 0;
}
fan.sys.Map.prototype.type = function()
{
return fan.sys.Type.find("sys::Map");
}
fan.sys.Map.prototype.toStr = function()
{
var s = "";
for (var k in this.map)
{
if (s.length > 0) s += ", ";
s += k + ":" + this.map[k];
}
if (s.length == 0) return "[:]";
return "[" + s + "]";
}
fan.sys.Map.prototype.keys = function()
{
var list = [];
for (var k in this.map) list.push(k);
return list;
}
fan.sys.Map.prototype.values = function()
{
var list = [];
for (var k in this.map) list.push(this.map[k]);
return list;
}
fan.sys.Map.prototype.get = function(key, defVal)
{
var val = this.map[key];
if (val == null && defVal != null)
return defVal;
return val;
}
fan.sys.Map.prototype.containsKey = function(key)
{
for (var k in this.map)
if (fan.sys.Obj.equals(k, key))
return true;
return false;
}
fan.sys.Map.prototype.add = function(key, val)
{
if (key == null)
throw fan.sys.NullErr.make("key is null");
if (this.map.hasOwnProperty(key))
throw fan.sys.ArgErr.make("Key already mapped: " + key);
this.map[key] = val;
return this;
}
fan.sys.Map.prototype.set = function(key, val)
{
this.map[key] = val;
return this;
}
fan.sys.Map.prototype.isEmpty = function() { return this.size() == 0; }
fan.sys.Map.prototype.size = function()
{
var sz = 0;
for (var k in this.map) sz++;
return sz;
}
fan.sys.Map.prototype.ordered$get = function() { return this.ordered; }
fan.sys.Map.prototype.ordered$set = function(val)
{
if (this.size() != 0)
throw fan.sys.UnsupportedErr.make("Map not empty");
this.ordered = val;
}
fan.sys.Map.prototype.ordered = false;
fan.sys.Map.prototype.each = function(func)
{
for (var k in this.map)
{
var v = this.map[k];
func(v, k);
}
}
fan.sys.Map.prototype.toImmutable = function()
{
return this;
}
fan.sys.Map.prototype.ro = function()
{
return this;
}
fan.sys.Map.fromLiteral = function(keys, vals, k, v)
{
var map = new fan.sys.Map(k,v);
for (var i=0; i<keys.length; i++)
map.set(keys[i], vals[i]);
return map;
}
fan.sys.Enum = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Enum.prototype.$ctor = function() {}
fan.sys.Enum.prototype.make$ = function(ordinal, name)
{
if (name == null) throw new fan.sys.NullErr();
this.m_ordinal = ordinal;
this.m_name = name;
}
fan.sys.Enum.prototype.equals = function(that)
{
return this == that;
}
fan.sys.Enum.prototype.compare = function(that)
{
if (this.m_ordinal < that.m_ordinal) return -1;
if (this.m_ordinal == that.m_ordinal) return 0;
return +1;
}
fan.sys.Enum.prototype.type = function()
{
return fan.sys.Type.find("sys::Enum");
}
fan.sys.Enum.prototype.toStr = function()
{
return this.m_name;
}
fan.sys.Enum.prototype.ordinal = function()
{
return this.m_ordinal;
}
fan.sys.Enum.prototype.name = function()
{
return this.m_name;
}
fan.sys.Enum.make = function(ordinal, name)
{
throw new Error();
}
function Long(high, low)
{
if (low > 0xffffffff)
{
var diff = (low % Long.Pow32);
high += Math.floor(low / Long.Pow32);
low = diff;
}
else if (low < 0)
{
high--;
low = 0xffffffff + low + 1;
}
if (high > 0xffffffff) high = 0xffffffff;
this.high = high;
this.low  = low;
this.str  = null;
}
Long.prototype = new Number;
Long.prototype.constructor = Number.constructor;
Long.prototype.valueOf = function()
{
if (this.val == null) this.val = (this.high * Long.Pow32) + this.low;
return this.val;
}
Long.fromNumber = function(num)
{
var high = Math.floor(num / Long.Pow32);
var low  = num & 0xffffffff; if (low < 0) low += 0xffffffff+1;
return new Long(high, low);
}
Long.Zero   = new Long(0, 0);
Long.One    = new Long(0, 1);
Long.NegOne = new Long(0xffffffff, 0xffffffff);
Long.Pow32  = Math.pow(2, 32);
Long.prototype.equals = function(that)
{
return this.high == that.high && this.low == that.low;
}
Long.prototype.compare = function(that)
{
if (this.equals(that)) return 0;
if (this.high > that.high) return 1;
if (this.high < that.high) return -1;
if (this.low > that.low) return 1;
if (this.low < that.low) return -1;
}
Long.add = function(a, b)
{
var high = a.high + b.high;
var low  = a.low + b.low;
return new Long(high, low);
}
Long.sub = function(a, b)
{
var high = a.high - b.high;
var low  = a.low - b.low;
return new Long(high, low);
}
Long.mul = function(a, b)
{
if (a.high === 0 && a.low === 0) return Long.Zero;
if (b.high === 0 && b.low === 0) return Long.Zero;
var a4 = a.high & 0xffff0000; if (a4 < 0) a4 += 0xffffffff+1;
var a3 = a.high & 0xffff;
var a2 = a.low  & 0xffff0000; if (a2 < 0) a2 += 0xffffffff+1;
var a1 = a.low  & 0xffff;
var b4 = b.high & 0xffff0000; if (b4 < 0) b4 += 0xffffffff+1;
var b3 = b.high & 0xffff;
var b2 = b.low  & 0xffff0000; if (b2 < 0) b2 += 0xffffffff+1;
var b1 = b.low  & 0xffff;
a4 = a4 * Long.Pow32;
a3 = a3 * Long.Pow32;
b4 = b4 * Long.Pow32;
b3 = b3 * Long.Pow32;
var res = Long.Zero;
res = this.addTimes(res, a4, b1);
res = this.addTimes(res, a3, b2);
res = this.addTimes(res, a3, b1);
res = this.addTimes(res, a2, b3);
res = this.addTimes(res, a2, b2);
res = this.addTimes(res, a2, b1);
res = this.addTimes(res, a1, b4);
res = this.addTimes(res, a1, b3);
res = this.addTimes(res, a1, b2);
res = this.addTimes(res, a1, b1);
return res;
}
Long.addTimes = function(acc, a, b)
{
if (a === 0) return acc;
if (b === 0) return acc;
return Long.add(acc, Long.fromNumber(a*b));
}
Long.div = function(a, b)
{
if (a === 0) return acc;
if (b === 0) throw fan.sys.Err.make("/ by zero");
var res = Long.Zero;
var rem = a;
var bup = Long.roundUp(b);
while (rem.compare(b) >= 0)
{
var num = Math.floor(Long.roundDown(rem) / bup);
var deltaRes = Long.fromNumber(num);
if (deltaRes.high === 0 && deltaRes.low === 0) deltaRes = Long.One;
var deltaRem = Long.mul(deltaRes, b);
res = Long.add(res, deltaRes);
rem = Long.sub(rem, deltaRem);
}
return res;
}
Long.roundDown = function(a)
{
var high = a.high * Long.Pow32;
var mag = Math.floor(Math.log(high) / Long.Ln2);
if (mag <= Long.PrecisionBits)
{
return high + a.low;
}
else
{
var diff  = mag - Long.PrecisionBits;
var toSub = (1 << diff) - 1;
return high + (a.low - toSub);
}
}
Long.roundUp = function(a)
{
var high = a.high * Long.Pow32;
var mag = Math.floor(Math.log(high) / Long.Ln2);
if (mag <= Long.PrecisionBits)
{
return high + a.low;
}
else
{
var diff  = mag - Long.PrecisionBits;
var toAdd = (1 << diff) - 1;
return high + (a.low + toAdd);
}
}
Long.PrecisionBits = 48;
Long.Ln2 = Math.log(2);
Long.mod = function(a, b)
{
return Long.sub(a, Long.mul(Long.div(a, b), b));
}
Long.prototype.toString = function(radix)
{
if (this.str == null)
{
if (radix == undefined) radix = 10;
var s = "";
var val = this;
var rad = Long.fromNumber(radix);
var neg = (val.high & 0x80000000) != 0 && radix != 16;
while (true)
{
s = "0123456789abcdef".charAt(Long.mod(val, rad)) + s;
val = Long.div(val, rad);
if (val.equals(Long.Zero)) break
}
if (neg) s = '-' + s;
this.str = s;
}
return this.str;
}
Long.fromStr = function(s, radix)
{
if (radix == 10) return Long.fromStr10(s);
if (radix == 16) return Long.fromStr16(s);
throw new Error("Unsupported radix " + radix);
}
Long.fromStr10 = function(s)
{
var neg = false;
if (s.charAt(0) == '-')
{
s = s.substring(1);
neg = true;
}
var num = Long.Zero;
var ten = 0;
for (var i=s.length-1; i>=0; --i)
{
var ch = s.charCodeAt(i);
if (ch < 48 || ch > 57) throw new Error("Illegal decimal character " + s.charAt(i));
num = Long.add(num, lookup[ten][ch - 48]);
ten += 1
}
if (neg) num *= -1;
return num;
}
Long.fromStr16 = function(s)
{
if (s.length <= 8)
{
var lo = Long.parseHex(s);
return new Long(0, lo);
}
else
{
var i  = s.length - 8;
var hi = Long.parseHex(s.substring(0, i));
var lo = Long.parseHex(s.substring(i));
return new Long(hi, lo);
}
}
Long.parseHex = function(s)
{
for (var i=0; i<s.length; i++)
{
ch = s.charCodeAt(i);
if (ch >= 48 && ch <= 57) continue;
if (ch >= 65 && ch <= 70) continue;
if (ch >= 97 && ch <= 102) continue;
throw new Error("Illegal hex char " + s.charAt(i));
}
return parseInt(s, 16);
}
var lookup =
[
[
new Long(0x0, 0x0),
new Long(0x0, 0x1),
new Long(0x0, 0x2),
new Long(0x0, 0x3),
new Long(0x0, 0x4),
new Long(0x0, 0x5),
new Long(0x0, 0x6),
new Long(0x0, 0x7),
new Long(0x0, 0x8),
new Long(0x0, 0x9),
],
[
new Long(0x0, 0x0),
new Long(0x0, 0xa),
new Long(0x0, 0x14),
new Long(0x0, 0x1e),
new Long(0x0, 0x28),
new Long(0x0, 0x32),
new Long(0x0, 0x3c),
new Long(0x0, 0x46),
new Long(0x0, 0x50),
new Long(0x0, 0x5a),
],
[
new Long(0x0, 0x0),
new Long(0x0, 0x64),
new Long(0x0, 0xc8),
new Long(0x0, 0x12c),
new Long(0x0, 0x190),
new Long(0x0, 0x1f4),
new Long(0x0, 0x258),
new Long(0x0, 0x2bc),
new Long(0x0, 0x320),
new Long(0x0, 0x384),
],
[
new Long(0x0, 0x0),
new Long(0x0, 0x3e8),
new Long(0x0, 0x7d0),
new Long(0x0, 0xbb8),
new Long(0x0, 0xfa0),
new Long(0x0, 0x1388),
new Long(0x0, 0x1770),
new Long(0x0, 0x1b58),
new Long(0x0, 0x1f40),
new Long(0x0, 0x2328),
],
[
new Long(0x0, 0x0),
new Long(0x0, 0x2710),
new Long(0x0, 0x4e20),
new Long(0x0, 0x7530),
new Long(0x0, 0x9c40),
new Long(0x0, 0xc350),
new Long(0x0, 0xea60),
new Long(0x0, 0x11170),
new Long(0x0, 0x13880),
new Long(0x0, 0x15f90),
],
[
new Long(0x0, 0x0),
new Long(0x0, 0x186a0),
new Long(0x0, 0x30d40),
new Long(0x0, 0x493e0),
new Long(0x0, 0x61a80),
new Long(0x0, 0x7a120),
new Long(0x0, 0x927c0),
new Long(0x0, 0xaae60),
new Long(0x0, 0xc3500),
new Long(0x0, 0xdbba0),
],
[
new Long(0x0, 0x0),
new Long(0x0, 0xf4240),
new Long(0x0, 0x1e8480),
new Long(0x0, 0x2dc6c0),
new Long(0x0, 0x3d0900),
new Long(0x0, 0x4c4b40),
new Long(0x0, 0x5b8d80),
new Long(0x0, 0x6acfc0),
new Long(0x0, 0x7a1200),
new Long(0x0, 0x895440),
],
[
new Long(0x0, 0x0),
new Long(0x0, 0x989680),
new Long(0x0, 0x1312d00),
new Long(0x0, 0x1c9c380),
new Long(0x0, 0x2625a00),
new Long(0x0, 0x2faf080),
new Long(0x0, 0x3938700),
new Long(0x0, 0x42c1d80),
new Long(0x0, 0x4c4b400),
new Long(0x0, 0x55d4a80),
],
[
new Long(0x0, 0x0),
new Long(0x0, 0x5f5e100),
new Long(0x0, 0xbebc200),
new Long(0x0, 0x11e1a300),
new Long(0x0, 0x17d78400),
new Long(0x0, 0x1dcd6500),
new Long(0x0, 0x23c34600),
new Long(0x0, 0x29b92700),
new Long(0x0, 0x2faf0800),
new Long(0x0, 0x35a4e900),
],
[
new Long(0x0, 0x0),
new Long(0x0, 0x3b9aca00),
new Long(0x0, 0x77359400),
new Long(0x0, 0xb2d05e00),
new Long(0x0, 0xee6b2800),
new Long(0x1, 0x2a05f200),
new Long(0x1, 0x65a0bc00),
new Long(0x1, 0xa13b8600),
new Long(0x1, 0xdcd65000),
new Long(0x2, 0x18711a00),
],
[
new Long(0x0, 0x0),
new Long(0x2, 0x540be400),
new Long(0x4, 0xa817c800),
new Long(0x6, 0xfc23ac00),
new Long(0x9, 0x502f9000),
new Long(0xb, 0xa43b7400),
new Long(0xd, 0xf8475800),
new Long(0x10, 0x4c533c00),
new Long(0x12, 0xa05f2000),
new Long(0x14, 0xf46b0400),
],
[
new Long(0x0, 0x0),
new Long(0x17, 0x4876e800),
new Long(0x2e, 0x90edd000),
new Long(0x45, 0xd964b800),
new Long(0x5d, 0x21dba000),
new Long(0x74, 0x6a528800),
new Long(0x8b, 0xb2c97000),
new Long(0xa2, 0xfb405800),
new Long(0xba, 0x43b74000),
new Long(0xd1, 0x8c2e2800),
],
[
new Long(0x0, 0x0),
new Long(0xe8, 0xd4a51000),
new Long(0x1d1, 0xa94a2000),
new Long(0x2ba, 0x7def3000),
new Long(0x3a3, 0x52944000),
new Long(0x48c, 0x27395000),
new Long(0x574, 0xfbde6000),
new Long(0x65d, 0xd0837000),
new Long(0x746, 0xa5288000),
new Long(0x82f, 0x79cd9000),
],
[
new Long(0x0, 0x0),
new Long(0x918, 0x4e72a000),
new Long(0x1230, 0x9ce54000),
new Long(0x1b48, 0xeb57e000),
new Long(0x2461, 0x39ca8000),
new Long(0x2d79, 0x883d2000),
new Long(0x3691, 0xd6afc000),
new Long(0x3faa, 0x25226000),
new Long(0x48c2, 0x73950000),
new Long(0x51da, 0xc207a000),
],
[
new Long(0x0, 0x0),
new Long(0x5af3, 0x107a4000),
new Long(0xb5e6, 0x20f48000),
new Long(0x110d9, 0x316ec000),
new Long(0x16bcc, 0x41e90000),
new Long(0x1c6bf, 0x52634000),
new Long(0x221b2, 0x62dd8000),
new Long(0x27ca5, 0x7357c000),
new Long(0x2d798, 0x83d20000),
new Long(0x3328b, 0x944c4000),
],
[
new Long(0x0, 0x0),
new Long(0x38d7e, 0xa4c68000),
new Long(0x71afd, 0x498d0000),
new Long(0xaa87b, 0xee538000),
new Long(0xe35fa, 0x931a0000),
new Long(0x11c379, 0x37e08000),
new Long(0x1550f7, 0xdca70000),
new Long(0x18de76, 0x816d8000),
new Long(0x1c6bf5, 0x26340000),
new Long(0x1ff973, 0xcafa8000),
],
[
new Long(0x0, 0x0),
new Long(0x2386f2, 0x6fc10000),
new Long(0x470de4, 0xdf820000),
new Long(0x6a94d7, 0x4f430000),
new Long(0x8e1bc9, 0xbf040000),
new Long(0xb1a2bc, 0x2ec50000),
new Long(0xd529ae, 0x9e860000),
new Long(0xf8b0a1, 0xe470000),
new Long(0x11c3793, 0x7e080000),
new Long(0x13fbe85, 0xedc90000),
],
[
new Long(0x0, 0x0),
new Long(0x1634578, 0x5d8a0000),
new Long(0x2c68af0, 0xbb140000),
new Long(0x429d069, 0x189e0000),
new Long(0x58d15e1, 0x76280000),
new Long(0x6f05b59, 0xd3b20000),
new Long(0x853a0d2, 0x313c0000),
new Long(0x9b6e64a, 0x8ec60000),
new Long(0xb1a2bc2, 0xec500000),
new Long(0xc7d713b, 0x49da0000),
],
[
new Long(0x0, 0x0),
new Long(0xde0b6b3, 0xa7640000),
new Long(0x1bc16d67, 0x4ec80000),
new Long(0x29a2241a, 0xf62c0000),
new Long(0x3782dace, 0x9d900000),
new Long(0x45639182, 0x44f40000),
new Long(0x53444835, 0xec580000),
new Long(0x6124fee9, 0x93bc0000),
new Long(0x6f05b59d, 0x3b200000),
new Long(0x7ce66c50, 0xe2840000),
],
[
new Long(0x0, 0x0),
new Long(0x8ac72304, 0x89e80000),
new Long(0x158e4609, 0x13d00000),
new Long(0xa055690d, 0x9db80000),
new Long(0x2b1c8c12, 0x27a00000),
new Long(0xb5e3af16, 0xb1880000),
new Long(0x40aad21b, 0x3b700000),
new Long(0xcb71f51f, 0xc5580000),
new Long(0x56391824, 0x4f400000),
new Long(0xe1003b28, 0xd9280000),
]
];
fan.sys.Int = fan.sys.Obj.$extend(fan.sys.Num);
fan.sys.Int.prototype.$ctor = function() {}
fan.sys.Int.prototype.type = function() { return fan.sys.Type.find("sys::Int"); }
fan.sys.Int.make = function(val)
{
if (val instanceof Long) return val;
if (typeof(val) == "string") return new Long.fromStr(val);
if (val <= fan.sys.Int.maxInt) val;
return Long.fromNumber(val);
}
fan.sys.Int.maxInt = 9007199254740992;
fan.sys.Int.fromStr = function(s, radix, checked)
{
if (radix == undefined) radix = 10;
if (checked == undefined) checked = true;
try
{
var num = Long.fromStr(s, radix);
return num;
}
catch (err) {}
if (checked) throw new fan.sys.ParseErr("Int", s);
return null;
}
fan.sys.Int.toStr = function(self)
{
return ""+self;
}
fan.sys.Int.equals = function(self, obj)
{
var sis = self instanceof Long;
var ois = obj instanceof Long;
if (sis || ois)
{
if (!sis) self = Long.fromNumber(self);
if (!ois) obj = Long.fromNumber(obj);
return self.equals(obj);
}
else return self == obj;
}
fan.sys.Int.abs = function(self) { return self < 0 ? -self : self; }
fan.sys.Int.min = function(self, val) { return self < val ? self : val; }
fan.sys.Int.max = function(self, val) { return self > val ? self : val; }
fan.sys.Int.isEven  = function(self) { return self % 2 == 0; }
fan.sys.Int.isOdd   = function(self) { return self % 2 != 0; }
fan.sys.Int.isSpace = function(self) { return self == 32 || self == 9 || self == 10 || self == 13; }
fan.sys.Int.isDigit = function(self, radix)
{
if (radix == null || radix == 10) return self >= 48 && self <= 57;
if (radix == 16)
{
if (self >= 48 && self <= 57) return true;
if (self >= 65 && self <= 70) return true;
if (self >= 97 && self <= 102) return true;
return false;
}
if (radix <= 10) return 48 <= self && self <= (48+radix);
var x = self-10;
if (97 <= self && self <= 97+x) return true;
if (65 <= self && self <= 65+x) return true;
return false;
}
fan.sys.Int.toDigit = function(self, radix)
{
if (radix == null || radix == 10) return 0 <= self && self <= 9 ? 48+self : null;
if (self < 0 || self >= radix) return null;
if (self < 10) return 48+self;
return self-10+97;
}
fan.sys.Int.fromDigit = function(self, radix)
{
if (self < 0 || self >= 128) return null;
var ten = radix < 10 ? radix : 10;
if (48 <= self && self < 48+ten) return self-48;
if (radix > 10)
{
var alpha = radix-10;
if (97 <= self && self < 97+alpha) return self+10-97;
if (65 <= self && self < 65+alpha) return self+10-65;
}
return null;
}
fan.sys.Int.toChar = function(self)
{
if (self < 0 || self > 0xFFFF) throw new Err("Invalid unicode char: " + self);
return String.fromCharCode(self);
}
fan.sys.Int.toHex = function(self, width)
{
var x = (self instanceof Long) ? self : Long.fromNumber(self);
var s = Long.fromNumber(self).toString(16);
if (width != null && s.length < width)
{
if (fan.sys.Int.$zeros == null)
{
fan.sys.Int.$zeros = [""];
for (var i=1; i<16; i++)
fan.sys.Int.$zeros[i] = fan.sys.Int.$zeros[i-1] + "0";
}
s = fan.sys.Int.$zeros[width-s.length] + s;
}
return s;
}
fan.sys.Int.$zeros = null;
fan.sys.Int.isUpper    = function(self) { return self >= 65 && self <= 90; }
fan.sys.Int.isLower    = function(self) { return self >= 97 && self <= 122; }
fan.sys.Int.upper      = function(self) { return fan.sys.Int.isLower(self) ? self-32 : self; }
fan.sys.Int.lower      = function(self) { return fan.sys.Int.isUpper(self) ? self+32 : self; }
fan.sys.Int.isAlpha    = function(self) { return fan.sys.Int.isUpper(self) || fan.sys.Int.isLower(self); }
fan.sys.Int.isAlphaNum = function(self) { return fan.sys.Int.isAlpha(self) || fan.sys.Int.isDigit(self); }
fan.sys.Int.equalsIgnoreCase = function(self, ch) { return (self|0x20) == (ch|0x20); }
fan.sys.Int.times = function(self, func)
{
for (var i=0; i<self; i++)
func(i);
}
fan.sys.Int.plus = function(a, b)
{
if (!(a instanceof Long)) a = Long.fromNumber(a);
if (!(b instanceof Long)) b = Long.fromNumber(b);
return Long.add(a, b);
}
fan.sys.Int.minus = function(a, b)
{
if (!(a instanceof Long)) a = Long.fromNumber(a);
if (!(b instanceof Long)) b = Long.fromNumber(b);
return Long.sub(a, b);
}
fan.sys.Int.mult = function(a, b)
{
if (!(a instanceof Long)) a = Long.fromNumber(a);
if (!(b instanceof Long)) b = Long.fromNumber(b);
return Long.mul(a, b);
}
fan.sys.Int.div = function(a, b)
{
if (!(a instanceof Long)) a = Long.fromNumber(a);
if (!(b instanceof Long)) b = Long.fromNumber(b);
return Long.div(a, b);
}
fan.sys.Int.mod = function(a, b)
{
if (!(a instanceof Long)) a = Long.fromNumber(a);
if (!(b instanceof Long)) b = Long.fromNumber(b);
return Long.mod(a, b);
}
fan.sys.Int.and    = function(a, b) { var x = a & b;  if (x<0) x += 0xffffffff+1; return x; }
fan.sys.Int.or     = function(a, b) { var x = a | b;  if (x<0) x += 0xffffffff+1; return x; }
fan.sys.Int.shl = function(a, b) { var x = a << b; if (x<0) x += 0xffffffff+1; return x; }
fan.sys.Int.shr = function(a, b) { var x = a >> b; if (x<0) x += 0xffffffff+1; return x; }
fan.sys.InStream = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.InStream.prototype.$ctor = function() { this.$in = null; }
fan.sys.InStream.prototype.make$ = function($in) { this.$in = $in; }
fan.sys.InStream.prototype.read = function()
{
try
{
return this.$in.read();
}
catch (err)
{
if (this.$in == null)
throw fan.sys.UnsupportedErr.make(this.type().qname() + " wraps null InStream");
else
throw fan.sys.Err.make(err);
}
}
fan.sys.InStream.prototype.skip = function(n)
{
if (this.$in != null) return this.$in.skip(n);
for (var i=0; i<n; ++i)
if (this.read() == 0) return i;
return n;
}
fan.sys.InStream.prototype.readChar = function()
{
try
{
return this.$in.readChar();
}
catch (err)
{
if (this.$in == null)
throw fan.sys.UnsupportedErr.make(this.type().qname() + " wraps null InStream");
else
throw fan.sys.Err.make(err);
}
}
fan.sys.InStream.prototype.unreadChar = function(c)
{
try
{
return this.$in.unreadChar(c);
}
catch (err)
{
if (this.$in == null)
throw fan.sys.UnsupportedErr.make(this.type().qname() + " wraps null InStream");
else
throw fan.sys.Err.make(err);
}
}
fan.sys.InStream.prototype.readLine = function(max)
{
if (max == undefined) max = fan.sys.Int.Chunk;
var maxChars = (max != null) ? max.valueOf() : fan.sys.Int.maxVal;
if (maxChars <= 0) return "";
var c = this.readChar();
if (c == null) return null;
var buf = "";
while (true)
{
if (c == 10) break;
if (c == 13)
{
c = this.readChar();
if (c >= 0 && c != 10) this.unreadChar(c);
break;
}
buf += String.fromCharCode(c);
if (buf.length >= maxChars) break;
c = this.readChar();
if (c == null) break;
}
return buf;
}
fan.sys.InStream.prototype.readAllLines = function()
{
try
{
var list = fan.sys.List.make(fan.sys.Type.find("sys::Str"), []);
var line = "";
while ((line = this.readLine()) != null)
list.push(line);
return list;
}
catch (err) { fan.sys.Obj.echo(err); }
finally
{
try { this.close(); } catch (err) { fan.sys.Obj.echo(err); }
}
}
fan.sys.InStream.prototype.readAllStr = function(normalizeNewlines)
{
if (normalizeNewlines == undefined) normalizeNewlines = true;
try
{
var s = "";
var normalize = normalizeNewlines;
var last = -1;
while (true)
{
var c = this.rChar();
if (c < 0) break;
if (normalize)
{
if (c == 13) buf[n++] = 10;
else if (last == 13 && c == 10) {}
else s += String.fromCharCode(c);
last = c;
}
else
{
s += String.fromCharCode(c);
}
}
return s;
}
finally
{
try { this.close(); } catch (err) { fan.sys.Obj.echo(err); }
}
}
fan.sys.InStream.prototype.readObj = function(options)
{
if (options == undefined) options = null;
return new fanx_ObjDecoder(this, options).readObj();
}
fan.sys.InStream.prototype.close = function()
{
if (this.$in != null) return this.$in.close();
return true;
}
fan.sys.InStream.prototype.type = function()
{
return fan.sys.Type.find("sys::InStream");
}
fan.sys.InStream.make = function($in)
{
var s = new fan.sys.InStream();
s.make$($in);
return s;
}
fan.sys.InStream.makeForStr = function(s)
{
return new fan.sys.StrInStream(s);
}
fan.sys.OutStream = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.OutStream.prototype.$ctor = function() { this.out = null; }
fan.sys.OutStream.prototype.make$ = function(out) { this.out = out; }
fan.sys.OutStream.prototype.type = function() { return fan.sys.Type.find("sys::OutStream"); }
fan.sys.OutStream.prototype.w = function(b)
{
return this.write(b);
}
fan.sys.OutStream.prototype.write = function(x)
{
try
{
this.out.write(x);
return this;
}
catch (err)
{
if (this.out == null)
throw fan.sys.UnsupportedErr.make(this.type().qname() + " wraps null OutStream");
else
throw err;
}
}
fan.sys.OutStream.prototype.writeBuf = function(buf, n)
{
if (n == undefined) b = buf.remaining();
try
{
this.out.writeBuf(buf, n);
return this;
}
catch (err)
{
if (this.out == null)
throw fan.sys.UnsupportedErr.make(this.type().qname() + " wraps null OutStream");
else
throw err;
}
}
fan.sys.OutStream.prototype.writeChar = function(c)
{
return this.w(c);
}
fan.sys.OutStream.prototype.writeChars = function(s, off, len)
{
if (off == undefined) off = 0;
if (len == undefined) len = s.length-off;
var end = off+len;
for (var i=off; i<end; i++)
this.w(s.charCodeAt(i));
return this;
}
fan.sys.OutStream.prototype.print = function(obj)
{
var s = obj == null ? "null" : fan.sys.Obj.toStr(obj);
return this.writeChars(s, 0, s.length);
}
fan.sys.OutStream.prototype.close = function()
{
if (this.out != null) return this.out.close();
return true;
}
fan.sys.Buf_Md5 = function(buf, key)
{
var chrsz = 8;
function core_md5(x, len)
{
x[len >> 5] |= 0x80 << ((len) % 32);
x[(((len + 64) >>> 9) << 4) + 14] = len;
var a =  1732584193;
var b = -271733879;
var c = -1732584194;
var d =  271733878;
for(var i=0; i<x.length; i+=16)
{
var olda = a;
var oldb = b;
var oldc = c;
var oldd = d;
a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
c = md5_ff(c, d, a, b, x[i+ 2], 17,  606105819);
b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
d = md5_ff(d, a, b, c, x[i+ 5], 12,  1200080426);
c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
a = md5_ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
a = md5_ff(a, b, c, d, x[i+12], 7 ,  1804603682);
d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
b = md5_ff(b, c, d, a, x[i+15], 22,  1236535329);
a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
c = md5_gg(c, d, a, b, x[i+11], 14,  643717713);
b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
d = md5_gg(d, a, b, c, x[i+10], 9 ,  38016083);
c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
a = md5_gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
b = md5_gg(b, c, d, a, x[i+ 8], 20,  1163531501);
a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
c = md5_gg(c, d, a, b, x[i+ 7], 14,  1735328473);
b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);
a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
c = md5_hh(c, d, a, b, x[i+11], 16,  1839030562);
b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
d = md5_hh(d, a, b, c, x[i+ 4], 11,  1272893353);
c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
a = md5_hh(a, b, c, d, x[i+13], 4 ,  681279174);
d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
b = md5_hh(b, c, d, a, x[i+ 6], 23,  76029189);
a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
c = md5_hh(c, d, a, b, x[i+15], 16,  530742520);
b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);
a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
d = md5_ii(d, a, b, c, x[i+ 7], 10,  1126891415);
c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
a = md5_ii(a, b, c, d, x[i+12], 6 ,  1700485571);
d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
a = md5_ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
b = md5_ii(b, c, d, a, x[i+13], 21,  1309151649);
a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
c = md5_ii(c, d, a, b, x[i+ 2], 15,  718787259);
b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);
a = safe_add(a, olda);
b = safe_add(b, oldb);
c = safe_add(c, oldc);
d = safe_add(d, oldd);
}
return Array(a, b, c, d);
}
function md5_cmn(q, a, b, x, s, t) { return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b); }
function md5_ff(a, b, c, d, x, s, t) { return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t); }
function md5_gg(a, b, c, d, x, s, t) { return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t); }
function md5_hh(a, b, c, d, x, s, t) { return md5_cmn(b ^ c ^ d, a, b, x, s, t); }
function md5_ii(a, b, c, d, x, s, t) { return md5_cmn(c ^ (b | (~d)), a, b, x, s, t); }
function core_hmac_md5(key, data)
{
var bkey = bytesToWords(key);
if(bkey.length > 16) bkey = core_md5(bkey, key.length * chrsz);
var ipad = Array(16), opad = Array(16);
for(var i = 0; i < 16; i++)
{
ipad[i] = bkey[i] ^ 0x36363636;
opad[i] = bkey[i] ^ 0x5C5C5C5C;
}
var hash = core_md5(ipad.concat(bytesToWords(data)), 512 + data.length * chrsz);
return core_md5(opad.concat(hash), 512 + 128);
}
function safe_add(x, y)
{
var lsw = (x & 0xFFFF) + (y & 0xFFFF);
var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
return (msw << 16) | (lsw & 0xFFFF);
}
function bit_rol(num, cnt)
{
return (num << cnt) | (num >>> (32 - cnt));
}
function bytesToWords(bytes)
{
var words = new Array();
var size = bytes.length;
for (var i=0; size>3 && (i+4)<=size; i+=4)
{
words.push((bytes[i+3]<<24) | (bytes[i+2]<<16) | (bytes[i+1]<<8) | bytes[i]);
}
var rem = bytes.length % 4;
if (rem > 0)
{
if (rem == 3) words.push((bytes[size-1]<<16) | (bytes[size-2]<<8) | bytes[size-3]);
if (rem == 2) words.push((bytes[size-1]<<8) | bytes[size-2]);
if (rem == 1) words.push(bytes[size-1]);
}
return words;
}
var dw = (key == undefined)
? core_md5(bytesToWords(buf), buf.length * chrsz)
: core_hmac_md5(key, buf);
var db = new Array();
for (var i=0; i<dw.length; i++)
{
db.push(0xff & dw[i]);
db.push(0xff & (dw[i] >> 8));
db.push(0xff & (dw[i] >> 16));
db.push(0xff & (dw[i] >> 24));
}
return db;
}
fan.sys.Buf_Sha1 = function(buf, key)
{
var chrsz = 8;
function core_sha1(x, len)
{
x[len >> 5] |= 0x80 << (24 - len % 32);
x[((len + 64 >> 9) << 4) + 15] = len;
var w = Array(80);
var a =  1732584193;
var b = -271733879;
var c = -1732584194;
var d =  271733878;
var e = -1009589776;
for(var i = 0; i < x.length; i += 16)
{
var olda = a;
var oldb = b;
var oldc = c;
var oldd = d;
var olde = e;
for(var j = 0; j < 80; j++)
{
if(j < 16) w[j] = x[i + j];
else w[j] = rol(w[j-3] ^ w[j-8] ^ w[j-14] ^ w[j-16], 1);
var t = safe_add(safe_add(rol(a, 5), sha1_ft(j, b, c, d)),
safe_add(safe_add(e, w[j]), sha1_kt(j)));
e = d;
d = c;
c = rol(b, 30);
b = a;
a = t;
}
a = safe_add(a, olda);
b = safe_add(b, oldb);
c = safe_add(c, oldc);
d = safe_add(d, oldd);
e = safe_add(e, olde);
}
return Array(a, b, c, d, e);
}
function sha1_ft(t, b, c, d)
{
if(t < 20) return (b & c) | ((~b) & d);
if(t < 40) return b ^ c ^ d;
if(t < 60) return (b & c) | (b & d) | (c & d);
return b ^ c ^ d;
}
function sha1_kt(t)
{
return (t < 20) ?  1518500249 : (t < 40) ?  1859775393 :
(t < 60) ? -1894007588 : -899497514;
}
function core_hmac_sha1(key, data)
{
var bkey = bytesToWords(key);
if(bkey.length > 16) bkey = core_sha1(bkey, key.length * chrsz);
var ipad = Array(16), opad = Array(16);
for(var i = 0; i < 16; i++)
{
ipad[i] = bkey[i] ^ 0x36363636;
opad[i] = bkey[i] ^ 0x5C5C5C5C;
}
var hash = core_sha1(ipad.concat(bytesToWords(data)), 512 + data.length * chrsz);
return core_sha1(opad.concat(hash), 512 + 160);
}
function safe_add(x, y)
{
var lsw = (x & 0xFFFF) + (y & 0xFFFF);
var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
return (msw << 16) | (lsw & 0xFFFF);
}
function rol(num, cnt)
{
return (num << cnt) | (num >>> (32 - cnt));
}
function bytesToWords(bytes)
{
var words = new Array();
var size = bytes.length;
for (var i=0; size>3 && (i+4)<=size; i+=4)
{
words.push((bytes[i]<<24) | (bytes[i+1]<<16) | (bytes[i+2]<<8) | bytes[i+3]);
}
var rem = bytes.length % 4;
if (rem > 0)
{
if (rem == 3) words.push((bytes[size-3]<<24) | (bytes[size-2]<<16) | bytes[size-1]<<8);
if (rem == 2) words.push((bytes[size-2]<<24) | bytes[size-1]<<16);
if (rem == 1) words.push(bytes[size-1]<<24);
}
return words;
}
var dw = (key == undefined)
? core_sha1(bytesToWords(buf), buf.length * chrsz)
: core_hmac_sha1(key, buf);
var db = new Array();
for (var i=0; i<dw.length; i++)
{
db.push(0xff & (dw[i] >> 24));
db.push(0xff & (dw[i] >> 16));
db.push(0xff & (dw[i] >> 8));
db.push(0xff & dw[i]);
}
return db;
}
fan.sys.Actor = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Actor.prototype.$ctor = function() {}
fan.sys.Actor.prototype.type = function() { return fan.sys.Type.find("sys::Actor"); }
fan.sys.Actor.locals = function()
{
if (fan.sys.Actor.$locals == null)
{
var k = fan.sys.Type.find("sys::Str");
var v = fan.sys.Type.find("sys::Obj?")
fan.sys.Actor.$locals = new fan.sys.Map(k, v);
}
return fan.sys.Actor.$locals;
}
fan.sys.Actor.$locals = null;
fan.sys.Bool = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Bool.prototype.$ctor = function() {}
fan.sys.Bool.prototype.type = function()
{
return fan.sys.Type.find("sys::Bool");
}
fan.sys.Bool.fromStr = function(s, checked)
{
if (s == "true") return true;
if (s == "false") return false;
if (checked != null && !checked) return null;
throw new fan.sys.ParseErr("Bool", s);
}
fan.sys.Bool.toStr  = function(self) { return self ? "true" : "false"; }
fan.sys.Bool.toCode = function(self) { return self ? "true" : "false"; }
fan.sys.Bool.defVal = false;
fan.sys.Buf = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Buf.prototype.$ctor = function() {}
fan.sys.Buf.make = function(capacity) { return new fan.sys.MemBuf(); }
fan.sys.Buf.prototype.equals = function(that)
{
return this == that;
}
fan.sys.Buf.prototype.toStr = function()
{
return this.type().name() + "(pos=" + this.pos() + " size=" + this.size() + ")";
}
fan.sys.Buf.prototype.type = function()
{
return fan.sys.Type.find("sys::Buf");
}
fan.sys.Buf.prototype.empty = function() { return this.size() == 0; }
fan.sys.Buf.prototype.capacity = function() { return fan.sys.Int.maxVal; }
fan.sys.Buf.prototype.remaining = function() { return this.size()-this.pos(); }
fan.sys.Buf.prototype.more = function() { return this.size()-this.pos() > 0; }
fan.sys.Buf.prototype.seek = function(pos)
{
var size = this.size();
if (pos < 0) pos = size + pos;
if (pos < 0 || pos > size) throw fan.sys.IndexErr.make(pos);
pos(pos);
return this;
}
fan.sys.Buf.prototype.flip = function()
{
this.size(this.pos());
this.pos(0);
return this;
}
fan.sys.Buf.prototype.get = function(pos)
{
var size = this.size();
if (pos < 0) pos = size + pos;
if (pos < 0 || pos >= size) throw fan.sys.IndexErr.make(pos);
return this.getByte(pos);
}
fan.sys.Buf.prototype.slice = function(range)
{
var size = this.size();
var s = range.start(size);
var e = range.end(size);
var n = (e - s + 1);
if (n < 0) throw fan.sys.IndexErr.make(range);
var slice = [];
this.getBytes(s, slice, 0, n);
var result = new fan.sys.MemBuf(slice, n);
return result;
}
fan.sys.Buf.prototype.dup = function()
{
var size = this.size();
var copy = [];
this.getBytes(0, copy, 0, size);
var result = new MemBuf(copy, size);
return result;
}
fan.sys.Buf.prototype.set = function(pos, b)
{
var size = this.size();
if (pos < 0) pos = size + pos;
if (pos < 0 || pos >= size) throw fan.sys.IndexErr.make(pos);
this.setByte(pos, b);
return this;
}
fan.sys.Buf.prototype.trim = function()
{
return this;
}
fan.sys.Buf.prototype.clear = function()
{
this.pos(0);
this.size(0);
return this;
}
fan.sys.Buf.prototype.flush = function()
{
return this;
}
fan.sys.Buf.prototype.close = function()
{
return true;
}
fan.sys.Buf.prototype.charset = function()
{
return this.m_out.charset();
}
fan.sys.Buf.prototype.charset = function(charset)
{
this.m_out.charset(charset);
this.m_in.charset(charset);
}
fan.sys.Buf.prototype.fill = function(b, times)
{
if (this.capacity() < this.size()+times) this.capacity(this.size()+times);
for (var i=0; i<times; ++i) this.m_out.write(b);
return this;
}
fan.sys.Buf.prototype.out = function() { return this.m_out; }
fan.sys.Buf.prototype.write = function(b) { this.m_out.write(b); return this; }
fan.sys.Buf.prototype.writeI2 = function(x) { this.m_out.writeI2(x); return this; }
fan.sys.Buf.prototype.writeI4 = function(x) { this.m_out.writeI4(x); return this; }
fan.sys.Buf.prototype.writeI8 = function(x) { this.m_out.writeI8(x); return this; }
fan.sys.Buf.prototype.writeF4 = function(x) { this.m_out.writeF4(x); return this; }
fan.sys.Buf.prototype.writeF8 = function(x) { this.m_out.writeF8(x); return this; }
fan.sys.Buf.prototype.writeDecimal = function(x) { this.m_out.writeDecimal(x); return this; }
fan.sys.Buf.prototype.writeBool = function(x) { this.m_out.writeBool(x); return this; }
fan.sys.Buf.prototype.writeUtf = function(x) { this.m_out.writeUtf(x); return this; }
fan.sys.Buf.prototype.writeChar = function(c) { this.m_out.writeChar(c); return this; }
fan.sys.Buf.prototype.print = function(obj) { this.m_out.print(obj); return this; }
fan.sys.Buf.prototype.$in = function() { return this.m_in; }
fan.sys.Buf.prototype.read = function() {  return this.m_in.read(); }
fan.sys.Buf.prototype.readBuf = function(other, n) { return this.m_in.readBuf(other, n); }
fan.sys.Buf.prototype.unread = function(n) { this.m_in.unread(n); return this; }
fan.sys.Buf.prototype.readBufFully = function(buf, n) { return this.m_in.readBufFully(buf, n); }
fan.sys.Buf.prototype.readAllBuf = function() { return this.m_in.readAllBuf(); }
fan.sys.Buf.prototype.peek = function() { return this.m_in.peek(); }
fan.sys.Buf.prototype.readU1 = function() { return this.m_in.readU1(); }
fan.sys.Buf.prototype.readS1 = function() { return this.m_in.readS1(); }
fan.sys.Buf.prototype.readU2 = function() { return this.m_in.readU2(); }
fan.sys.Buf.prototype.readS2 = function() { return this.m_in.readS2(); }
fan.sys.Buf.prototype.readU4 = function() { return this.m_in.readU4(); }
fan.sys.Buf.prototype.readS4 = function() { return this.m_in.readS4(); }
fan.sys.Buf.prototype.readS8 = function() { return this.m_in.readS8(); }
fan.sys.Buf.prototype.readF4 = function() { return this.m_in.readF4(); }
fan.sys.Buf.prototype.readF8 = function() { return this.m_in.readF8(); }
fan.sys.Buf.prototype.readDecimal = function() { return this.m_in.readDecimal(); }
fan.sys.Buf.prototype.readBool = function() { return this.m_in.readBool(); }
fan.sys.Buf.prototype.readUtf = function() { return this.m_in.readUtf(); }
fan.sys.Buf.prototype.readChar = function() { return this.m_in.readChar(); }
fan.sys.Buf.prototype.unreadChar = function(c) { this.m_in.unreadChar(c); return this; }
fan.sys.Buf.prototype.peekChar = function() { return this.m_in.peekChar(); }
fan.sys.Buf.prototype.readAllLines = function() { return this.m_in.readAllLines(); }
fan.sys.Buf.prototype.eachLine = function(f) { this.m_in.eachLine(f); }
fan.sys.Buf.prototype.readAllStr = function(normalizeNewlines)
{
if (normalizeNewlines == undefined) normalizeNewlines = true;
return this.m_in.readAllStr(normalizeNewlines);
}
fan.sys.Buf.fromHex = function(s)
{
var slen = s.length;
var buf = [];
var hexInv = fan.sys.Buf.hexInv;
var size = 0;
for (var i=0; i<slen; ++i)
{
var c0 = s.charCodeAt(i);
var n0 = c0 < 128 ? hexInv[c0] : -1;
if (n0 < 0) continue;
var n1 = -1;
if (++i < slen)
{
var c1 = s.charCodeAt(i);
n1 = c1 < 128 ? hexInv[c1] : -1;
}
if (n1 < 0) throw fan.sys.IOErr.make("Invalid hex str");
buf[size++] = (n0 << 4) | n1;
}
return fan.sys.MemBuf.makeBytes(buf);
}
fan.sys.Buf.hexChars = [
48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102];
fan.sys.Buf.hexInv = [];
for (var i=0; i<128; ++i) fan.sys.Buf.hexInv[i] = -1;
for (var i=0; i<10; ++i)  fan.sys.Buf.hexInv[48+i] = i;
for (var i=10; i<16; ++i) fan.sys.Buf.hexInv[97+i-10] = fan.sys.Buf.hexInv[65+i-10] = i;
fan.sys.Buf.base64chars = [
65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,
97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,
48,49,50,51,52,53,54,55,56,57,43,47];
fan.sys.Charset = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Charset.prototype.$ctor = function() {}
fan.sys.Charset.prototype.type = function() { return fan.sys.Type.find("sys::Charset"); }
fan.sys.Charset.utf16BE = function() { return null; }
fan.sys.Charset.utf16LE = function() { return null; }
fan.sys.Charset.utf8    = function() { return null; }
fan.sys.Date = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Date.prototype.$ctor = function(year, month, day)
{
this.m_year = year;
this.m_month = month;
this.m_day = day;
}
fan.sys.Date.prototype.equals = function(that)
{
if (that instanceof fan.sys.Date)
{
return this.m_year.valueOf() == that.m_year.valueOf() &&
this.m_month.valueOf() == that.m_month.valueOf() &&
this.m_day.valueOf() == that.m_day.valueOf();
}
return false;
}
fan.sys.Date.prototype.compare = function(that)
{
if (this.m_year.valueOf() == that.m_year.valueOf())
{
if (this.m_month.valueOf() == that.m_month.valueOf())
{
if (this.m_day.valueOf() == that.m_day.valueOf()) return 0;
return this.m_day < that.m_day ? -1 : +1;
}
return this.m_month < that.m_month ? -1 : +1;
}
return this.m_year < that.m_year ? -1 : +1;
}
fan.sys.Date.prototype.type = function()
{
return fan.sys.Type.find("sys::Date");
}
fan.sys.Date.prototype.toIso = function()
{
return this.toStr();
}
fan.sys.Date.prototype.toLocale = function(pattern)
{
var s = "" + this.m_day + "-";
switch (this.m_month)
{
case 0:  s += "Jan"; break;
case 1:  s += "Feb"; break;
case 2:  s += "Mar"; break;
case 3:  s += "Apr"; break;
case 4:  s += "May"; break;
case 5:  s += "Jun"; break;
case 6:  s += "Jul"; break;
case 7:  s += "Aug"; break;
case 8:  s += "Sep"; break;
case 9:  s += "Oct"; break;
case 10: s += "Nov"; break;
case 11: s += "Dec"; break;
}
s += "-" + this.m_year;
return s;
}
fan.sys.Date.prototype.toStr = function()
{
var y = this.m_year;
var m = this.m_month+1;
var d = this.m_day;
return y + "-" + (m < 10 ? "0"+m : m) + "-" + (d < 10 ? "0"+d : d);
}
fan.sys.Date.prototype.year  = function() { return this.m_year; }
fan.sys.Date.prototype.month = function() { return fan.sys.Month.values[this.m_month]; }
fan.sys.Date.prototype.day   = function() { return this.m_day; }
fan.sys.Date.prototype.weekday = function()
{
var weekday = (fan.sys.DateTime.firstWeekday(this.m_year, this.m_month) + this.m_day - 1) % 7;
return fan.sys.Weekday.values[weekday];
}
fan.sys.Date.prototype.dayOfYear = function()
{
return fan.sys.DateTime.dayOfYear(this.year(), this.m_month, this.day()+1);
}
fan.sys.Date.prototype.plus = function(d)
{
var ticks = d.m_ticks;
if (ticks % fan.sys.Duration.nsPerDay != 0)
throw new fan.sys.ArgErr("Duration must be even num of days");
var year = this.m_year;
var month = this.m_month;
var day = this.m_day;
var numDays = Math.floor(ticks / fan.sys.Duration.nsPerDay);
var dayIncr = numDays < 0 ? +1 : -1;
while (numDays != 0)
{
if (numDays > 0)
{
day++;
if (day > this.numDays(year, month))
{
day = 1;
month++;
if (month >= 12) { month = 0; year++; }
}
numDays--;
}
else
{
day--;
if (day <= 0)
{
month--;
if (month < 0) { month = 11; year--; }
day = this.numDays(year, month);
}
numDays++;
}
}
return new fan.sys.Date(year, month, day);
}
fan.sys.Date.prototype.minus = function(that)
{
if (this.equals(that)) return fan.sys.Duration.defVal;
var a = this;
var b = that;
if (a.compare(b) > 0) { b = this; a = that; }
var days = 0;
if (a.m_year == b.m_year)
{
days = b.dayOfYear() - a.dayOfYear();
}
else
{
days = (fan.sys.DateTime.isLeapYear(a.m_year) ? 366 : 365) - a.dayOfYear();
days += b.dayOfYear();
for (var i=a.m_year+1; i<b.m_year; ++i)
days += fan.sys.DateTime.isLeapYear(i) ? 366 : 365;
}
if (a == this) days = -days;
return fan.sys.Duration.make(days * fan.sys.Duration.nsPerDay);
}
fan.sys.Date.prototype.numDays = function(year, mon)
{
if (fan.sys.DateTime.isLeapYear(year))
return fan.sys.DateTime.daysInMonLeap[mon];
else
return fan.sys.DateTime.daysInMon[mon];
}
fan.sys.Date.make = function(year, month, day)
{
return new fan.sys.Date(year, month.m_ordinal, day);
}
fan.sys.Date.today = function()
{
var d = new Date();
return new fan.sys.Date(d.getFullYear(), d.getMonth(), d.getDate());
}
fan.sys.Date.fromStr = function(s, checked)
{
try
{
var num = function(x, index) { return x.charCodeAt(index) - 48; }
var year  = num(s, 0)*1000 + num(s, 1)*100 + num(s, 2)*10 + num(s, 3);
var month = num(s, 5)*10   + num(s, 6) - 1;
var day   = num(s, 8)*10   + num(s, 9);
if (s.charAt(4) != '-' || s.charAt(7) != '-' || s.length != 10)
throw new Error();
return new fan.sys.Date(year, month, day);
}
catch (err)
{
if (checked != null && !checked) return null;
throw new fan.sys.ParseErr("Date", s);
}
}
fan.sys.Date.fromIso = function(s, checked)
{
return fan.sys.Date.fromStr(s, checked);
}
fan.sys.Date.prototype.isYesterday = function() { return this.equals(fan.sys.Date.today().plus(fan.sys.Duration.negOneDay)); }
fan.sys.Date.prototype.isToday     = function() { return this.equals(fan.sys.Date.today()); }
fan.sys.Date.prototype.isTomorrow  = function() { return this.equals(fan.sys.Date.today().plus(fan.sys.Duration.oneDay)); }
fan.sys.Date.prototype.toDateTime = function(t, tz)
{
if (tz == undefined) tz = fan.sys.TimeZone.current();
return fan.sys.DateTime.makeDT(this, t, tz);
}
fan.sys.Date.prototype.midnight = function(tz)
{
if (tz == undefined) tz = fan.sys.TimeZone.current();
return fan.sys.DateTime.makeDT(this, fan.sys.Time.defVal, tz);
}
fan.sys.Date.prototype.toCode = function()
{
if (this.equals(fan.sys.Date.defVal)) return "Date.defVal";
return "Date(\"" + this.toString() + "\")";
}
fan.sys.Date.defVal = new fan.sys.Date(2000, 0, 1);
fan.sys.DateTime = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.DateTime.diffJs     = 946684800000;
fan.sys.DateTime.nsPerYear  = 365*24*60*60*1000000000;
fan.sys.DateTime.nsPerDay   = 24*60*60*1000000000;
fan.sys.DateTime.nsPerHour  = 60*60*1000000000;
fan.sys.DateTime.nsPerMin   = 60*1000000000;
fan.sys.DateTime.nsPerSec   = 1000000000;
fan.sys.DateTime.nsPerMilli = 1000000;
fan.sys.DateTime.minTicks   = -3124137600000000000;
fan.sys.DateTime.maxTicks   = 3155760000000000000;
fan.sys.DateTime.now = function(tolerance)
{
if (tolerance == undefined)
{
if (fan.sys.DateTime.toleranceDefault == null)
fan.sys.DateTime.toleranceDefault = fan.sys.Duration.makeMillis(250);
tolerance = fan.sys.DateTime.toleranceDefault;
}
var now = (new Date().getTime() - fan.sys.DateTime.diffJs) * fan.sys.DateTime.nsPerMilli;
if (fan.sys.DateTime.cached == null)
fan.sys.DateTime.cached = fan.sys.DateTime.makeTicks(0, fan.sys.TimeZone.current());
var c = fan.sys.DateTime.cached;
if (tolerance != null && now - c.m_ticks <= tolerance.m_ticks)
return c;
fan.sys.DateTime.cached = fan.sys.DateTime.makeTicks(now, fan.sys.TimeZone.current());
return fan.sys.DateTime.cached;
}
fan.sys.DateTime.nowUtc = function(tolerance)
{
if (tolerance == undefined)
{
if (fan.sys.DateTime.toleranceDefault == null)
fan.sys.DateTime.toleranceDefault = fan.sys.Duration.makeMillis(250);
tolerance = fan.sys.DateTime.toleranceDefault;
}
var now = (new Date().getTime() - fan.sys.DateTime.diffJs) * fan.sys.DateTime.nsPerMilli;
if (fan.sys.DateTime.cachedUtc == null)
fan.sys.DateTime.cachedUtc = fan.sys.DateTime.makeTicks(0, fan.sys.TimeZone.utc());
var c = fan.sys.DateTime.cachedUtc;
if (tolerance != null && now - c.m_ticks <= tolerance.m_ticks)
return c;
fan.sys.DateTime.cachedUtc = fan.sys.DateTime.makeTicks(now, fan.sys.TimeZone.utc());
return fan.sys.DateTime.cachedUtc;
}
fan.sys.DateTime.prototype.$ctor = function() {}
fan.sys.DateTime.make = function(year, month, day, hour, min, sec, ns, tz)
{
if (sec == undefined) sec = 0;
if (ns  == undefined) ns = 0;
if (tz  == undefined) tz = fan.sys.TimeZone.current();
month = month.ordinal();
if (year < 1901 || year > 2099) throw fan.sys.ArgErr.make("year " + year);
if (month < 0 || month > 11)    throw fan.sys.ArgErr.make("month " + month);
if (day < 1 || day > fan.sys.DateTime.numDaysInMonth(year, month)) throw fan.sys.ArgErr.make("day " + day);
if (hour < 0 || hour > 23)      throw fan.sys.ArgErr.make("hour " + hour);
if (min < 0 || min > 59)        throw fan.sys.ArgErr.make("min " + min);
if (sec < 0 || sec > 59)        throw fan.sys.ArgErr.make("sec " + sec);
if (ns < 0 || ns > 999999999)   throw fan.sys.ArgErr.make("ns " + ns);
var dayOfYear = fan.sys.DateTime.dayOfYear(year, month, day);
var timeInSec = hour*3600 + min*60 + sec;
var ticks = fan.sys.Int.plus(fan.sys.DateTime.yearTicks[year-1900],
fan.sys.Int.plus(dayOfYear * fan.sys.DateTime.nsPerDay,
fan.sys.Int.plus(timeInSec * fan.sys.DateTime.nsPerSec, ns)));
var rule = tz.rule(year);
var dst;
ticks -= rule.offset * fan.sys.DateTime.nsPerSec;
var dstOffset = fan.sys.TimeZone.dstOffset(rule, year, month, day, timeInSec);
if (dstOffset != 0) ticks -= dstOffset * fan.sys.DateTime.nsPerSec;
dst = dstOffset != 0;
var weekday = (fan.sys.DateTime.firstWeekday(year, month) + day - 1) % 7;
var fields = 0;
fields |= ((year-1900) & 0xff) << 0;
fields |= (month & 0xf) << 8;
fields |= (day & 0x1f)  << 12;
fields |= (hour & 0x1f) << 17;
fields |= (min  & 0x3f) << 22;
fields |= (weekday & 0x7) << 28;
fields |= (dst ? 1 : 0) << 31;
var instance = new fan.sys.DateTime();
instance.m_ticks    = ticks;
instance.m_timeZone = tz;
instance.m_fields   = fields;
return instance;
}
fan.sys.DateTime.makeDT = function(d, t, tz)
{
if (tz == undefined) tz = TimeZone.current();
return fan.sys.DateTime.make(
d.year(), d.month(), d.day(),
t.hour(), t.min(), t.sec(), t.nanoSec(), tz);
}
fan.sys.DateTime.makeTicks = function(ticks, tz)
{
if (tz == undefined) tz = fan.sys.TimeZone.current();
if (ticks < fan.sys.DateTime.minTicks || ticks >= fan.sys.DateTime.maxTicks)
throw fan.sys.ArgErr.make("Ticks out of range 1901 to 2099");
var instance = new fan.sys.DateTime();
instance.m_ticks = ticks;
instance.m_timeZone = tz;
var year = fan.sys.DateTime.ticksToYear(ticks);
var rule = tz.rule(year);
ticks += rule.offset * fan.sys.DateTime.nsPerSec;
var month = 0, day = 0, dstOffset = 0;
var rem;
while (true)
{
year = fan.sys.DateTime.ticksToYear(ticks);
rem = ticks - fan.sys.DateTime.yearTicks[year-1900];
if (rem < 0) rem += fan.sys.DateTime.nsPerYear;
var dayOfYear = Math.floor(rem/fan.sys.DateTime.nsPerDay);
rem %= fan.sys.DateTime.nsPerDay;
if (fan.sys.DateTime.isLeapYear(year))
{
month = fan.sys.DateTime.monForDayOfYearLeap[dayOfYear];
day   = fan.sys.DateTime.dayForDayOfYearLeap[dayOfYear];
}
else
{
month = fan.sys.DateTime.monForDayOfYear[dayOfYear];
day   = fan.sys.DateTime.dayForDayOfYear[dayOfYear];
}
if (fan.sys.Int.equals(dstOffset, fan.sys.Int.maxVal)) { dstOffset = 0; break; }
if (dstOffset != 0)
{
if (rule.isWallTime() && fan.sys.TimeZone.dstOffset(rule, year, month, day, Math.floor(rem/fan.sys.DateTime.nsPerSec)) == 0)
{
ticks -= dstOffset * sysDateTime.nsPerSec;
dstOffset = fan.sys.Int.maxVal;
continue;
}
break;
}
dstOffset = fan.sys.TimeZone.dstOffset(rule, year, month, day, Math.floor(rem/fan.sys.DateTime.nsPerSec));
if (dstOffset == 0) break;
ticks += dstOffset * fan.sys.DateTime.nsPerSec;
}
var hour = Math.floor(rem / fan.sys.DateTime.nsPerHour);  rem %= fan.sys.DateTime.nsPerHour;
var min  = Math.floor(rem / fan.sys.DateTime.nsPerMin);   rem %= fan.sys.DateTime.nsPerMin;
var weekday = (fan.sys.DateTime.firstWeekday(year, month) + day - 1) % 7;
var fields = 0;
fields |= ((year-1900) & 0xff) << 0;
fields |= (month & 0xf) << 8;
fields |= (day & 0x1f)  << 12;
fields |= (hour & 0x1f) << 17;
fields |= (min  & 0x3f) << 22;
fields |= (weekday & 0x7) << 28;
fields |= (dstOffset != 0 ? 1 : 0) << 31;
instance.m_fields = fields;
return instance;
}
fan.sys.DateTime.fromStr = function(s, checked, iso)
{
if (checked == undefined) checked = true;
if (iso == undefined) iso = false;
try
{
var num = function(s, index) { return s.charCodeAt(index) - 48; }
var year  = num(s, 0)*1000 + num(s, 1)*100 + num(s, 2)*10 + num(s, 3);
var month = num(s, 5)*10   + num(s, 6) - 1;
var day   = num(s, 8)*10   + num(s, 9);
var hour  = num(s, 11)*10  + num(s, 12);
var min   = num(s, 14)*10  + num(s, 15);
var sec   = num(s, 17)*10  + num(s, 18);
if (s.charAt(4)  != '-' || s.charAt(7)  != '-' ||
s.charAt(10) != 'T' || s.charAt(13) != ':' ||
s.charAt(16) != ':')
throw new Error();
var i = 19;
var ns = 0;
var tenth = 100000000;
if (s.charAt(i) == '.')
{
++i;
while (true)
{
var c = s.charCodeAt(i);
if (c < 48 || c > 57) break;
ns += (c - 48) * tenth;
tenth /= 10;
++i;
}
}
var offset = 0;
var c = s.charAt(i++);
if (c != 'Z')
{
var offHour = num(s, i++)*10 + num(s, i++);
if (s.charAt(i++) != ':') throw new Error();
var offMin  = num(s, i++)*10 + num(s, i++);
offset = offHour*3600 + offMin*60;
if (c == '-') offset = -offset;
else if (c != '+') throw new Error();
}
var tz;
if (iso)
{
if (i < s.length) throw new Error();
if (offset == 0)
tz = fan.sys.TimeZone.utc();
else
tz = fan.sys.TimeZone.fromStr("GMT" + (offset < 0 ? "+" : "-") + Math.abs(offset)/3600);
}
else
{
if (s.charAt(i++) != ' ') throw new Error();
tz = fan.sys.TimeZone.fromStr(s.substring(i), true);
}
return fan.sys.DateTime.make(year, fan.sys.Month.values[month], day, hour, min, sec, ns, tz);
}
catch (err)
{
if (!checked) return null;
throw fan.sys.ParseErr.make("DateTime", s);
}
}
fan.sys.DateTime.prototype.equals = function(obj)
{
if (obj instanceof fan.sys.DateTime)
{
return this.m_ticks == obj.m_ticks;
}
return false;
}
fan.sys.DateTime.prototype.hash = function()
{
return this.m_ticks;
}
fan.sys.DateTime.prototype.compare = function(obj)
{
var that = obj.m_ticks;
if (this.m_ticks < that) return -1; return this.m_ticks  == that ? 0 : +1;
}
fan.sys.DateTime.prototype.type = function()
{
return fan.sys.Type.find("sys::DateTime");
}
fan.sys.DateTime.prototype.ticks = function() { return this.m_ticks; }
fan.sys.DateTime.prototype.date = function() { return fan.sys.Date.make(this.year(), this.month(), this.day()); }
fan.sys.DateTime.prototype.time = function() { return fan.sys.Time.make(this.hour(), this.min(), this.sec(), this.nanoSec()); }
fan.sys.DateTime.prototype.year = function() { return (this.m_fields & 0xff) + 1900; }
fan.sys.DateTime.prototype.month = function() { return fan.sys.Month.values[(this.m_fields >> 8) & 0xf]; }
fan.sys.DateTime.prototype.day = function() { return (this.m_fields >> 12) & 0x1f; }
fan.sys.DateTime.prototype.hour = function() { return (this.m_fields >> 17) & 0x1f; }
fan.sys.DateTime.prototype.min = function() { return (this.m_fields >> 22) & 0x3f; }
fan.sys.DateTime.prototype.sec = function()
{
var rem = this.m_ticks >= 0 ? this.m_ticks : this.m_ticks - fan.sys.DateTime.yearTicks[0];
return Math.floor((rem % fan.sys.DateTime.nsPerMin) / fan.sys.DateTime.nsPerSec);
}
fan.sys.DateTime.prototype.nanoSec = function()
{
var rem = this.m_ticks >= 0 ? this.m_ticks : this.m_ticks - fan.sys.DateTime.yearTicks[0];
return rem % fan.sys.DateTime.nsPerSec;
}
fan.sys.DateTime.prototype.weekday = function() { return fan.sys.Weekday.values[(this.m_fields >> 28) & 0x7]; }
fan.sys.DateTime.prototype.timeZone = function() { return this.m_timeZone; }
fan.sys.DateTime.prototype.dst = function() { return ((this.m_fields >> 31) & 0x1) != 0; }
fan.sys.DateTime.prototype.timeZoneAbbr = function() { return this.dst() ? this.m_timeZone.dstAbbr(this.year()) : this.m_timeZone.stdAbbr(this.year()); }
fan.sys.DateTime.prototype.dayOfYear = function() { return fan.sys.DateTime.dayOfYear(this.year(), this.month().m_ordinal, this.day())+1; }
fan.sys.DateTime.prototype.toLocale = function(pattern, locale)
{
if (pattern == undefined) pattern = null;
if (locale == undefined) locale = null;
if (pattern == null)
{
pattern = "D-MMM-YYYY WWW hh:mm:ss zzz";
}
var s = '';
var len = pattern.length;
for (var i=0; i<len; ++i)
{
var c = pattern.charAt(i);
if (c == '\'')
{
while (true)
{
++i;
if (i >= len) throw fan.sys.ArgErr.make("Invalid pattern: unterminated literal");
c = pattern.charAt(i);
if (c == '\'') break;
s += c;
}
continue;
}
var n = 1;
while (i+1<len && pattern.charAt(i+1) == c) { ++i; ++n; }
var invalidNum = false;
switch (c)
{
case 'Y':
var year = this.year();
switch (n)
{
case 2:  year %= 100; if (year < 10) s += '0';
case 4:  s += year; break;
default: invalidNum = true;
}
break;
case 'M':
var mon = this.month();
switch (n)
{
case 4:
if (locale == null) locale = fan.sys.Locale.current();
s += mon.full(locale);
break;
case 3:
if (locale == null) locale = fan.sys.Locale.current();
s += mon.abbr(locale);
break;
case 2:  if (mon.m_ordinal+1 < 10) s += '0';
case 1:  s += mon.m_ordinal+1; break;
default: invalidNum = true;
}
break;
case 'D':
var day = this.day();
switch (n)
{
case 2:  if (day < 10) s += '0';
case 1:  s += day; break;
default: invalidNum = true;
}
break;
case 'W':
var weekday = this.weekday();
switch (n)
{
case 4:
if (locale == null) locale = fan.sys.Locale.current();
s += weekday.full(locale);
break;
case 3:
if (locale == null) locale = fan.sys.Locale.current();
s += weekday.abbr(locale);
break;
default: invalidNum = true;
}
break;
case 'h':
case 'k':
var hour = this.hour();
if (c == 'k')
{
if (hour == 0) hour = 12;
else if (hour > 12) hour -= 12;
}
switch (n)
{
case 2:  if (hour < 10) s += '0';
case 1:  s += hour; break;
default: invalidNum = true;
}
break;
case 'm':
var min = this.min();
switch (n)
{
case 2:  if (min < 10) s += '0';
case 1:  s += min; break;
default: invalidNum = true;
}
break;
case 's':
var sec = this.sec();
switch (n)
{
case 2:  if (sec < 10) s += '0';
case 1:  s += sec; break;
default: invalidNum = true;
}
break;
case 'a':
switch (n)
{
case 1:  s += this.hour() < 12 ? "AM" : "PM"; break;
default: invalidNum = true;
}
break;
case 'f':
case 'F':
var req = 0, opt = 0;
if (c == 'F') opt = n;
else
{
req = n;
while (i+1<len && pattern.charAt(i+1) == 'F') { ++i; ++opt; }
}
var frac = this.nanoSec();
for (var x=0, tenth=100000000; x<9; ++x)
{
if (req > 0) req--;
else
{
if (frac == 0 || opt <= 0) break;
opt--;
}
s += Math.floor(frac/tenth);
frac %= tenth;
tenth /= 10;
}
break;
case 'z':
var rule = this.m_timeZone.rule(this.year());
var dst = this.dst();
switch (n)
{
case 1:
var offset = rule.offset;
if (dst) offset += rule.dstOffset;
if (offset == 0) { s += 'Z'; break; }
if (offset < 0) { s += '-'; offset = -offset; }
else { s += '+'; }
var zh = offset / 3600;
var zm = (offset % 3600) / 60;
if (zh < 10) s += '0'; s += zh + ':';
if (zm < 10) s += '0'; s += zm;
break;
case 3:
s += dst ? rule.dstAbbr : rule.stdAbbr;
break;
case 4:
s += this.m_timeZone.name();
break;
default:
invalidNum = true;
break;
}
break;
default:
if (fan.sys.Int.isAlpha(c.charCodeAt(0)))
throw ArgErr.make("Invalid pattern: unsupported char '" + c + "'").val;
if (i+1<len && pattern.charAt(i+1) == 'F' && this.nanoSec() == 0)
break;
s += c;
}
if (invalidNum)
throw fan.sys.ArgErr.make("Invalid pattern: unsupported num of '" + c + "' (x" + n + ")");
}
return s;
}
fan.sys.DateTime.prototype.toStr = function()
{
return this.toLocale("YYYY-MM-DD'T'hh:mm:ss.FFFFFFFFFz zzzz");
}
fan.sys.DateTime.isLeapYear = function(year)
{
if ((year & 3) != 0) return false;
return (year % 100 != 0) || (year % 400 == 0);
}
fan.sys.DateTime.weekdayInMonth = function(year, mon, weekday, pos)
{
mon = mon.m_ordinal;
weekday = weekday.m_ordinal;
fan.sys.DateTime.checkYear(year);
if (pos == 0) throw fan.sys.ArgErr.make("Pos is zero");
var firstWeekday = fan.sys.DateTime.firstWeekday(year, mon);
var numDays = fan.sys.DateTime.numDaysInMonth(year, mon);
if (pos > 0)
{
var day = weekday - firstWeekday + 1;
if (day <= 0) day = 8 - firstWeekday + weekday;
day += (pos-1)*7;
if (day > numDays) throw fan.sys.ArgErr.make("Pos out of range " + pos);
return day;
}
else
{
var lastWeekday = (firstWeekday + numDays - 1) % 7;
var off = lastWeekday - weekday;
if (off < 0) off = 7 + off;
off -= (pos+1)*7;
var day = numDays - off;
if (day < 1) throw fan.sys.ArgErr.make("Pos out of range " + pos);
return day;
}
}
fan.sys.DateTime.dayOfYear = function(year, mon, day)
{
return fan.sys.DateTime.isLeapYear(year) ?
fan.sys.DateTime.dayOfYearForFirstOfMonLeap[mon] + day - 1 :
fan.sys.DateTime.dayOfYearForFirstOfMon[mon] + day - 1;
}
fan.sys.DateTime.numDaysInMonth = function(year, month)
{
if (month == 1 && fan.sys.DateTime.isLeapYear(year))
return 29;
else
return fan.sys.DateTime.daysInMon[month];
}
fan.sys.DateTime.ticksToYear = function(ticks)
{
var year = Math.floor(ticks/fan.sys.DateTime.nsPerYear) + 2000;
if (fan.sys.DateTime.yearTicks[year-1900] > ticks) year--;
return year;
}
fan.sys.DateTime.firstWeekday = function(year, mon)
{
var firstDayOfYear = fan.sys.DateTime.isLeapYear(year)
? fan.sys.DateTime.dayOfYearForFirstOfMonLeap[mon]
: fan.sys.DateTime.dayOfYearForFirstOfMon[mon];
return (fan.sys.DateTime.firstWeekdayOfYear[year-1900] + firstDayOfYear) % 7;
}
fan.sys.DateTime.checkYear = function(year)
{
if (year < 1901 || year > 2099)
throw fan.sys.ArgErr.make("Year out of range " + year);
}
fan.sys.DateTime.prototype.toIso = function()
{
return this.toLocale("YYYY-MM-DD'T'hh:mm:ss.FFFz");
}
fan.sys.DateTime.fromIso = function(s, checked)
{
if (checked == undefined) checked = true;
return fan.sys.DateTime.fromStr(s, checked, true);
}
fan.sys.DateTime.yearTicks = [];
fan.sys.DateTime.firstWeekdayOfYear = [];
fan.sys.DateTime.yearTicks[0] = -3155673600000000000;
fan.sys.DateTime.firstWeekdayOfYear[0] = 1;
for (var i=1; i<202; ++i)
{
var daysInYear = 365;
if (fan.sys.DateTime.isLeapYear(i+1900-1)) daysInYear = 366;
fan.sys.DateTime.yearTicks[i] = fan.sys.DateTime.yearTicks[i-1] + daysInYear * fan.sys.DateTime.nsPerDay;
fan.sys.DateTime.firstWeekdayOfYear[i] = (fan.sys.DateTime.firstWeekdayOfYear[i-1] + daysInYear) % 7;
}
fan.sys.DateTime.daysInMon     = [ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ];
fan.sys.DateTime.daysInMonLeap = [ 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ];
fan.sys.DateTime.dayOfYearForFirstOfMon     = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
fan.sys.DateTime.dayOfYearForFirstOfMonLeap = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
for (var i=1; i<12; ++i)
{
fan.sys.DateTime.dayOfYearForFirstOfMon[i] =
fan.sys.DateTime.dayOfYearForFirstOfMon[i-1] + fan.sys.DateTime.daysInMon[i-1];
fan.sys.DateTime.dayOfYearForFirstOfMonLeap[i] =
fan.sys.DateTime.dayOfYearForFirstOfMonLeap[i-1] + fan.sys.DateTime.daysInMonLeap[i-1];
}
fan.sys.DateTime.monForDayOfYear     = [];
fan.sys.DateTime.dayForDayOfYear     = [];
fan.sys.DateTime.monForDayOfYearLeap = [];
fan.sys.DateTime.dayForDayOfYearLeap = [];
fan.sys.DateTime.fillInDayOfYear = function(mon, days, daysInMon, len)
{
var m = 0, d = 1;
for (var i=0; i<len; ++i)
{
mon[i] = m; days[i] = d++;
if (d > daysInMon[m]) { m++; d = 1; }
}
}
fan.sys.DateTime.fillInDayOfYear(fan.sys.DateTime.monForDayOfYear, fan.sys.DateTime.dayForDayOfYear, fan.sys.DateTime.daysInMon, 365);
fan.sys.DateTime.fillInDayOfYear(fan.sys.DateTime.monForDayOfYearLeap, fan.sys.DateTime.dayForDayOfYearLeap, fan.sys.DateTime.daysInMonLeap, 366);
fan.sys.Decimal = fan.sys.Obj.$extend(fan.sys.Num);
fan.sys.Decimal.prototype.$ctor = function() {}
fan.sys.Decimal.make = function(val)
{
var x = new Number(val);
x.$fanType = fan.sys.Type.find("sys::Decimal");
return x;
}
fan.sys.Decimal.toFloat = function(self)
{
return fan.sys.Float.make(self);
}
fan.sys.Duration = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Duration.prototype.$ctor = function(ticks)
{
this.m_ticks = ticks;
}
fan.sys.Duration.prototype.equals = function(that)
{
if (that instanceof fan.sys.Duration)
return this.m_ticks == that.m_ticks;
else
return false;
}
fan.sys.Duration.prototype.compare = function(that)
{
if (this.m_ticks < that.m_ticks) return -1;
if (this.m_ticks == that.m_ticks) return 0;
return +1;
}
fan.sys.Duration.prototype.type = function()
{
return fan.sys.Type.find("sys::Duration");
}
fan.sys.Duration.prototype.ticks = function()
{
return this.m_ticks;
}
fan.sys.Duration.prototype.negate = function() { return fan.sys.Duration.make(-this.m_ticks); }
fan.sys.Duration.prototype.plus = function(x)  { return fan.sys.Duration.make(this.m_ticks + x.m_ticks); }
fan.sys.Duration.prototype.minus = function(x) { return fan.sys.Duration.make(this.m_ticks - x.m_ticks); }
fan.sys.Duration.prototype.mult = function(x)  { return fan.sys.Duration.make(this.m_ticks * x); }
fan.sys.Duration.prototype.div = function(x)   { return fan.sys.Duration.make(this.m_ticks / x); }
fan.sys.Duration.prototype.floor = function(accuracy)
{
if (this.m_ticks % accuracy.m_ticks == 0) return this;
return fan.sys.Duration.make(this.m_ticks - (this.m_ticks % accuracy.m_ticks));
}
fan.sys.Duration.prototype.abs = function()
{
if (this.m_ticks >= 0) return this;
return new fan.sys.Duration(-this.m_ticks);
}
fan.sys.Duration.prototype.toStr = function()
{
if (this.m_ticks == 0) return "0ns";
var ns = this.m_ticks;
if (ns % fan.sys.Duration.nsPerMilli == 0)
{
if (ns % fan.sys.Duration.nsPerDay == 0) return ns/fan.sys.Duration.nsPerDay + "day";
if (ns % fan.sys.Duration.nsPerHr  == 0) return ns/fan.sys.Duration.nsPerHr  + "hr";
if (ns % fan.sys.Duration.nsPerMin == 0) return ns/fan.sys.Duration.nsPerMin + "min";
if (ns % fan.sys.Duration.nsPerSec == 0) return ns/fan.sys.Duration.nsPerSec + "sec";
return ns/fan.sys.Duration.nsPerMilli + "ms";
}
return ns + "ns";
}
fan.sys.Duration.prototype.toCode = function() { return this.toStr(); }
fan.sys.Duration.prototype.toMillis = function() { return Math.floor(this.m_ticks / fan.sys.Duration.nsPerMilli); }
fan.sys.Duration.prototype.toSec    = function() { return Math.floor(this.m_ticks / fan.sys.Duration.nsPerSec); }
fan.sys.Duration.prototype.toMin    = function() { return Math.floor(this.m_ticks / fan.sys.Duration.nsPerMin); }
fan.sys.Duration.prototype.toHour   = function() { return Math.floor(this.m_ticks / fan.sys.Duration.nsPerHr); }
fan.sys.Duration.prototype.toDay    = function() { return Math.floor(this.m_ticks / fan.sys.Duration.nsPerDay); }
fan.sys.Duration.make = function(ticks)
{
return new fan.sys.Duration(ticks);
}
fan.sys.Duration.makeMillis = function(ms)
{
return fan.sys.Duration.make(ms*1000000);
}
fan.sys.Duration.fromStr = function(s, checked)
{
try
{
var len = s.length;
var x1  = s.charAt(len-1);
var x2  = s.charAt(len-2);
var x3  = s.charAt(len-3);
var dot = s.indexOf('.') > 0;
var mult = -1;
var suffixLen  = -1;
switch (x1)
{
case 's':
if (x2 == 'n') { mult=1; suffixLen=2; }
if (x2 == 'm') { mult=1000000; suffixLen=2; }
break;
case 'c':
if (x2 == 'e' && x3 == 's') { mult=1000000000; suffixLen=3; }
break;
case 'n':
if (x2 == 'i' && x3 == 'm') { mult=60000000000; suffixLen=3; }
break;
case 'r':
if (x2 == 'h') { mult=3600000000000; suffixLen=2; }
break;
case 'y':
if (x2 == 'a' && x3 == 'd') { mult=86400000000000; suffixLen=3; }
break;
}
if (mult < 0) throw new Error();
s = s.substring(0, len-suffixLen);
if (dot)
{
var num = parseFloat(s);
if (isNaN(num)) throw new Error();
return new fan.sys.Duration(Math.floor(num*mult));
}
else
{
var num = fan.sys.Int.fromStr(s);
return new fan.sys.Duration(num*mult);
}
}
catch (err)
{
if (checked != null && !checked) return null;
throw new fan.sys.ParseErr("Duration", s);
}
}
fan.sys.Duration.now = function()
{
var ms = new Date().getTime();
return new fan.sys.Duration(ms * fan.sys.Duration.nsPerMilli);
}
fan.sys.Duration.nsPerDay   = 86400000000000;
fan.sys.Duration.nsPerHr    = 3600000000000;
fan.sys.Duration.nsPerMin   = 60000000000;
fan.sys.Duration.nsPerSec   = 1000000000;
fan.sys.Duration.nsPerMilli = 1000000;
fan.sys.Duration.secPerDay  = 86400;
fan.sys.Duration.secPerHr   = 3600;
fan.sys.Duration.secPerMin  = 60;
fan.sys.Duration.defVal    = new fan.sys.Duration(0);
fan.sys.Duration.minVal    = new fan.sys.Duration(fan.sys.Int.minVal);
fan.sys.Duration.maxVal    = new fan.sys.Duration(fan.sys.Int.maxVal);
fan.sys.Duration.oneDay    = new fan.sys.Duration(fan.sys.Duration.nsPerDay);
fan.sys.Duration.negOneDay = new fan.sys.Duration(-fan.sys.Duration.nsPerDay);
fan.sys.FConst = function() {};
fan.sys.FConst.Abstract   = 0x00000001;
fan.sys.FConst.Const      = 0x00000002;
fan.sys.FConst.Ctor       = 0x00000004;
fan.sys.FConst.Enum       = 0x00000008;
fan.sys.FConst.Final      = 0x00000010;
fan.sys.FConst.Getter     = 0x00000020;
fan.sys.FConst.Internal   = 0x00000040;
fan.sys.FConst.Mixin      = 0x00000080;
fan.sys.FConst.Native     = 0x00000100;
fan.sys.FConst.Override   = 0x00000200;
fan.sys.FConst.Private    = 0x00000400;
fan.sys.FConst.Protected  = 0x00000800;
fan.sys.FConst.Public     = 0x00001000;
fan.sys.FConst.Setter     = 0x00002000;
fan.sys.FConst.Static     = 0x00004000;
fan.sys.FConst.Storage    = 0x00008000;
fan.sys.FConst.Synthetic  = 0x00010000;
fan.sys.FConst.Virtual    = 0x00020000;
fan.sys.FConst.FlagsMask  = 0x0003ffff;
fan.sys.Field = fan.sys.Obj.$extend(fan.sys.Slot);
fan.sys.Field.prototype.$ctor = function(parent, name, flags, of)
{
this.m_parent = parent;
this.m_name   = name;
this.m_qname  = parent.qname() + "." + name;
this.m_flags  = flags;
this.m_of     = of;
this.m_$name  = this.$name(name);
this.m_$qname = 'fan.' + parent.pod() + '.' + parent.name() + '.' + this.m_$name;
}
fan.sys.Field.prototype.of = function() { return this.m_of; }
fan.sys.Field.prototype.get = function(instance)
{
if (this.isStatic())
{
return eval(this.m_$qname);
}
else
{
var target = instance;
if ((this.m_flags & fan.sys.FConst.Native) != 0)
target = instance.peer;
var getter = target[this.m_$name + "$get"];
return getter.call(target);
}
}
fan.sys.Field.prototype.set = function(instance, value, checkConst)
{
if (checkConst == undefined) checkConst = true;
if ((this.m_flags & fan.sys.FConst.Const) != 0)
{
if (checkConst)
throw fan.sys.ReadonlyErr.make("Cannot set const field " + this.m_qname);
else if (value != null && !isImmutable(value))
throw fan.sys.ReadonlyErr.make("Cannot set const field " + this.m_qname + " with mutable value");
}
if (value != null)
{
if (!fan.sys.Obj.type(value).is(this.m_of))
throw fan.sys.ArgErr.make("Wrong type for field " + this.m_qname + ": " + this.m_of + " != " + fan.sys.Obj.type(value));
}
if ((this.m_flags & fan.sys.FConst.Native) != 0)
{
var peer = instance.peer;
var setter = peer[this.m_$name + "$set"];
return setter.call(peer, instance, value);
}
else
{
var setter = instance[this.m_$name + "$set"];
return setter.call(instance, value);
}
}
fan.sys.Field.prototype.type = function() { return fan.sys.Type.find("sys::Field"); }
fan.sys.File = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.File.prototype.$ctor = function() {}
fan.sys.File.prototype.type = function() { return fan.sys.Type.find("sys::File"); }
fan.sys.File.prototype.exists = function() { return true; }
fan.sys.File.make = function()
{
return new fan.sys.File();
}
fan.sys.Float = fan.sys.Obj.$extend(fan.sys.Num);
fan.sys.Float.prototype.$ctor = function() {}
fan.sys.Float.make = function(val)
{
var x = new Number(val);
x.$fanType = fan.sys.Type.find("sys::Float");
return x;
}
fan.sys.Float.prototype.type = function()
{
return fan.sys.Type.find("sys::Float");
}
fan.sys.Float.equals = function(self, that)
{
if (that != null && self.$fanType == that.$fanType)
{
if (isNaN(self) || isNaN(that)) return false;
return self.valueOf() == that.valueOf();
}
return false;
}
fan.sys.Float.compare = function(self, that)
{
if (self == null) return that == null ? 0 : -1;
if (that == null) return 1;
if (isNaN(self)) return isNaN(that) ? 0 : -1;
if (isNaN(that)) return 1;
if (self < that) return -1; return self.valueOf() == that.valueOf() ? 0 : 1;
}
fan.sys.Float.abs = function(self) { return Math.abs(self); }
fan.sys.Float.approx = function(self, that, tolerance)
{
if (fan.sys.Float.equals(self, that)) return true;
var t = tolerance == null
? Math.min(Math.abs(self/1e6), Math.abs(that/1e6))
: tolerance;
return Math.abs(self - that) <= t;
}
fan.sys.Float.ceil  = function(self) { return Math.ceil(self); }
fan.sys.Float.exp   = function(self) { return Math.exp(self); }
fan.sys.Float.floor = function(self) { return Math.floor(self); }
fan.sys.Float.log   = function(self) { return Math.log(self); }
fan.sys.Float.min   = function(self, that) { return Math.min(self, that); }
fan.sys.Float.max   = function(self, that) { return Math.max(self, that); }
fan.sys.Float.pow   = function(self, exp) { return Math.pow(self, exp); }
fan.sys.Float.round = function(self) { return Math.round(self); }
fan.sys.Float.sqrt  = function(self) { return Math.sqrt(self); }
fan.sys.Float.acos  = function(self) { return Math.acos(self); }
fan.sys.Float.asin  = function(self) { return Math.asin(self); }
fan.sys.Float.atan  = function(self) { return Math.atan(self); }
fan.sys.Float.atan2 = function(y, x) { return Math.atan2(y, x); }
fan.sys.Float.cos   = function(self) { return Math.cos(self); }
fan.sys.Float.sin   = function(self) { return Math.sin(self); }
fan.sys.Float.tan   = function(self) { return Math.tan(self); }
fan.sys.Float.toDegrees = function(self) { return self * 180 / Math.PI; }
fan.sys.Float.toRadians = function(self) { return self * Math.PI / 180; }
fan.sys.Float.fromStr = function(s, checked)
{
if (s == "NaN") return fan.sys.Float.nan;
if (s == "INF") return fan.sys.Float.posInf;
if (s == "-INF") return fan.sys.Float.negInf;
var num = parseFloat(s);
if (isNaN(num))
{
if (checked != null && !checked) return null;
throw new fan.sys.ParseErr("Float", s);
}
return num;
}
fan.sys.Float.toStr = function(self)
{
if (isNaN(self)) return "NaN";
if (self == fan.sys.Float.posInf) return "INF";
if (self == fan.sys.Float.negInf) return "-INF";
return ""+self;
}
fan.sys.Locale = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Locale.prototype.$ctor = function() {}
fan.sys.Locale.prototype.type = function() { return fan.sys.Type.find("sys::Locale"); }
fan.sys.Locale.current = function() { return null; }
fan.sys.Log = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Log.prototype.$ctor = function() {}
fan.sys.Log.prototype.type = function() { return fan.sys.Type.find("sys::Log"); }
fan.sys.Log.prototype.error = function(msg, err) { this.log(msg, err); }
fan.sys.Log.prototype.info = function(msg, err) { this.log(msg, err); }
fan.sys.Log.prototype.warn = function(msg, err) { this.log(msg, err); }
fan.sys.Log.prototype.log = function(msg, err)
{
try
{
console.log(msg);
}
catch (err) {}
}
fan.sys.Log.make = function(name, register)
{
var log = new fan.sys.Log();
log.name = name;
log.register = register;
return log;
}
fan.sys.Log.get = function(name)
{
var log = fan.sys.Log.$cache[name];
if (log == null)
{
log = fan.sys.Log.make(name, true);
fan.sys.Log.$cache[name] = log;
}
return log;
}
fan.sys.Log.$cache = [];
fan.sys.LogLevel = fan.sys.Obj.$extend(fan.sys.Enum);
fan.sys.LogLevel.prototype.$ctor = function(ordinal, name)
{
this.make$(ordinal, name);
}
fan.sys.LogLevel.prototype.type = function()
{
return fan.sys.Type.find("sys::LogLevel");
}
fan.sys.LogLevel.debug  = new fan.sys.LogLevel(0, "debug");
fan.sys.LogLevel.info   = new fan.sys.LogLevel(1, "info");
fan.sys.LogLevel.warn   = new fan.sys.LogLevel(2, "warn");
fan.sys.LogLevel.error  = new fan.sys.LogLevel(3, "error");
fan.sys.LogLevel.silent = new fan.sys.LogLevel(4, "silent");
fan.sys.LogLevel.values =
[
fan.sys.LogLevel.debug,
fan.sys.LogLevel.info,
fan.sys.LogLevel.warn,
fan.sys.LogLevel.error,
fan.sys.LogLevel.silent
]
fan.sys.LogRecord = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.LogRecord.prototype.$ctor = function() {}
fan.sys.LogRecord.prototype.type = function() { return fan.sys.Type.find("sys::LogRecord"); }
fan.sys.LogRecord.make = function(time, level, logName, msg, err)
{
if (err == undefined) err = null;
var self = new fan.sys.LogRecord();
self.m_time    = time;
self.m_level   = level;
self.m_logName = logName;
self.m_message = msg;
self.m_err     = err;
return self;
}
fan.sys.LogRecord.prototype.toStr = function()
{
var ts = "todo";
return '[' + ts + '] [' + this.m_level + '] [' + this.m_logName + '] ' + this.m_message;
}
fan.sys.LogRecord.prototype.print = function(out)
{
try
{
console.log(this.toStr());
if (err != null) err.trace();
}
catch (err) {}
}
fan.sys.MemBuf = fan.sys.Obj.$extend(fan.sys.Buf);
fan.sys.MemBuf.prototype.$ctor = function(buf, size)
{
this.m_buf  = [];
this.m_pos  = 0;
this.m_size = 0;
this.m_out  = new fan.sys.MemBufOutStream(this);
this.m_in   = new fan.sys.MemBufInStream(this);
}
fan.sys.MemBuf.makeBytes = function(bytes)
{
var buf = new fan.sys.MemBuf();
buf.m_buf = bytes;
buf.m_size = bytes.length;
return buf;
}
fan.sys.MemBuf.prototype.type = function() { return fan.sys.Type.find("sys::MemBuf"); }
fan.sys.MemBuf.prototype.size = function()
{
return this.m_size;
}
fan.sys.MemBuf.prototype.pos = function()
{
return this.m_pos;
}
fan.sys.MemBuf.prototype.pos = function(x)
{
this.m_pos = x;
}
fan.sys.MemBuf.prototype.capacity = function()
{
return this.m_buf.length;
}
fan.sys.MemBuf.prototype.trim = function()
{
if (this.m_size == this.m_buf.length) return this;
this.m_buf = this.m_buf.slice(0, size);
return this;
}
fan.sys.MemBuf.prototype.toHex = function()
{
var buf = this.m_buf;
var size = this.m_size;
var hexChars = fan.sys.Buf.hexChars;
var s = '';
for (var i=0; i<size; ++i)
{
var b = buf[i] & 0xff;
s += String.fromCharCode(hexChars[b>>4])
s += String.fromCharCode(hexChars[b&0xf]);
}
return s;
}
fan.sys.MemBuf.prototype.toBase64 = function()
{
var buf = this.m_buf;
var size = this.m_size;
var s = '';
var base64chars = fan.sys.Buf.base64chars;
var i = 0;
var end = size-2;
for (; i<end; i += 3)
{
var n = ((buf[i] & 0xff) << 16) + ((buf[i+1] & 0xff) << 8) + (buf[i+2] & 0xff);
s += String.fromCharCode(base64chars[(n >>> 18) & 0x3f]);
s += String.fromCharCode(base64chars[(n >>> 12) & 0x3f]);
s += String.fromCharCode(base64chars[(n >>> 6) & 0x3f]);
s += String.fromCharCode(base64chars[n & 0x3f]);
}
var rem = size - i;
if (rem > 0)
{
var n = ((buf[i] & 0xff) << 10) | (rem == 2 ? ((buf[size-1] & 0xff) << 2) : 0);
s += String.fromCharCode(base64chars[(n >>> 12) & 0x3f]);
s += String.fromCharCode(base64chars[(n >>> 6) & 0x3f]);
s += rem == 2 ? String.fromCharCode(base64chars[n & 0x3f]) : '=';
s += '=';
}
return s;
}
fan.sys.MemBuf.prototype.toDigest = function(algorithm)
{
var digest = null;
switch (algorithm)
{
case "MD5":   digest = fan.sys.Buf_Md5(this.m_buf);  break;
case "SHA1":
case "SHA-1": digest = fan.sys.Buf_Sha1(this.m_buf); break;
default: throw fan.sys.Err.make("Unknown digest algorithm " + algorithm);
}
return fan.sys.MemBuf.makeBytes(digest);
}
fan.sys.MemBuf.prototype.hmac = function(algorithm, keyBuf)
{
var digest = null;
switch (algorithm)
{
case "MD5":   digest = fan.sys.Buf_Md5(this.m_buf, keyBuf.m_buf);  break;
case "SHA1":
case "SHA-1": digest = fan.sys.Buf_Sha1(this.m_buf, keyBuf.m_buf); break;
default: throw fan.sys.Err.make("Unknown digest algorithm " + algorithm);
}
return fan.sys.MemBuf.makeBytes(digest);
}
fan.sys.MemBufOutStream = fan.sys.Obj.$extend(fan.sys.OutStream);
fan.sys.MemBufOutStream.prototype.$ctor = function(buf) { this.buf = buf; }
fan.sys.MemBufOutStream.prototype.write = function(v)
{
return this.w(v);
}
fan.sys.MemBufOutStream.prototype.w = function(v)
{
this.buf.m_buf[this.buf.m_pos++] =  (0xff & v);
if (this.buf.m_pos > this.buf.m_size) this.buf.m_size = this.buf.m_pos;
return this;
}
fan.sys.MemBufInStream = fan.sys.Obj.$extend(fan.sys.InStream);
fan.sys.MemBufInStream.prototype.$ctor = function(buf) { this.buf = buf; }
fan.sys.MemBufInStream.prototype.read = function() { var n = this.r(); return n<0 ? null : n; }
fan.sys.MemBufInStream.prototype.r = function()
{
if (this.buf.m_pos >= this.buf.m_size) return -1;
return this.buf.m_buf[this.buf.m_pos++] & 0xff;
}
fan.sys.MemBufInStream.prototype.readChar = function() { var c = this.rChar(); return c<0 ? null : c; }
fan.sys.MemBufInStream.prototype.rChar = function() { return this.r(); }
fan.sys.Method = fan.sys.Obj.$extend(fan.sys.Slot);
fan.sys.Method.prototype.$ctor = function(parent, name)
{
this.m_parent = parent;
this.m_name   = name;
this.m_qname  = parent.qname() + "." + name;
this.m_$name  = this.$name(name);
this.m_$qname = 'fan.' + parent.pod() + '.' + parent.name() + '.' + this.m_$name;
}
fan.sys.Method.prototype.invoke = function(instance, args)
{
instance[this.m_$name].apply(instance, args)
}
fan.sys.Method.prototype.type = function()
{
return fan.sys.Type.find("sys::Method");
}
fan.sys.MimeType = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.MimeType.prototype.$ctor = function() {}
fan.sys.MimeType.prototype.type = function() { return fan.sys.Type.find("sys::MimeType"); }
fan.sys.MimeType.fromStr = function(s, checked)
{
if (checked == undefined) checked = true;
try
{
switch (s.charAt(0))
{
case 'i':
if (s == "image/png")  return fan.sys.MimeType.imagePng;
if (s == "image/jpeg") return fan.sys.MimeType.imageJpeg;
if (s == "image/gif")  return fan.sys.MimeType.imageGif;
break;
case 't':
if (s == "text/plain") return fan.sys.MimeType.textPlain;
if (s == "text/html")  return fan.sys.MimeType.textHtml;
if (s == "text/xml")   return fan.sys.MimeType.textXml;
break;
case 'x':
if (s == "x-directory/normal") return fan.sys.MimeType.dir;
break;
}
var slash = s.indexOf('/');
var media = s.substring(0, slash);
var sub = s.substring(slash+1, s.length);
var params = fan.sys.MimeType.emptyParams();
var semi = sub.indexOf(';');
if (semi > 0)
{
console.log("#### MIME TYPE - PARAMS NOT IMPLEMENTED!!! ####");
}
var r = new fan.sys.MimeType();
r.str = s;
r.mediaType = fan.sys.Str.lower(media);
r.subType   = fan.sys.Str.lower(sub);
r.params    = params.ro();
return r;
}
catch (err)
{
if (!checked) return null;
throw fan.sys.ParseErr.make("MimeType",  s);
}
}
fan.sys.MimeType.prototype.equals = function(obj)
{
if (!(obj instanceof MimeType)) return false;
return this.mediaType == obj.mediaType &&
this.subType == obj.subType &&
this.params == obj.params;
}
fan.sys.MimeType.prototype.hash = function()
{
return 0;
}
fan.sys.MimeType.prototype.toStr = function() { return this.str; }
fan.sys.MimeType.prototype.type = function() { return fan.sys.Type.find("sys::MimeType"); }
fan.sys.MimeType.prototype.mediaType = function() { return this.mediaType; }
fan.sys.MimeType.prototype.subType = function() { return this.subType; }
fan.sys.MimeType.prototype.params = function() { return this.params; }
fan.sys.MimeType.emptyParams = function()
{
var q = fan.sys.MimeType.emptyQuery;
if (q == null)
{
q = new fan.sys.Map(fan.sys.Type.find("sys::Str"), fan.sys.Type.find("sys::Str"));
fan.sys.MimeType.emptyQuery = q;
}
return q;
}
fan.sys.MimeType.emptyQuery = null;
fan.sys.MimeType.predefined = function(media, sub)
{
var t = new fan.sys.MimeType();
t.mediaType = media;
t.subType = sub;
t.params = fan.sys.MimeType.emptyParams();
t.str = media + "/" + sub;
return t;
}
fan.sys.Month = fan.sys.Obj.$extend(fan.sys.Enum);
fan.sys.Month.prototype.$ctor = function(ordinal, name)
{
this.make$(ordinal, name);
}
fan.sys.Month.prototype.increment = function()
{
var arr = fan.sys.Month.values;
return arr[(this.m_ordinal+1) % arr.length];
}
fan.sys.Month.prototype.decrement = function()
{
var arr = fan.sys.Month.values;
return this.m_ordinal == 0 ? arr[arr.length-1] : arr[this.m_ordinal-1];
}
fan.sys.Month.prototype.numDays = function(year)
{
if (fan.sys.DateTime.isLeapYear(year))
return fan.sys.DateTime.daysInMonLeap[this.m_ordinal];
else
return fan.sys.DateTime.daysInMon[this.m_ordinal];
}
fan.sys.Month.prototype.type = function()
{
return fan.sys.Type.find("sys::Month");
}
fan.sys.Month.prototype.abbr = function(locale)
{
switch (this.m_ordinal)
{
case 0:  return "Jan";
case 1:  return "Feb";
case 2:  return "Mar";
case 3:  return "Apr";
case 4:  return "May";
case 5:  return "Jun";
case 6:  return "Jul";
case 7:  return "Aug";
case 8:  return "Sep";
case 9:  return "Oct";
case 10: return "Nov";
case 11: return "Dec";
}
}
fan.sys.Month.prototype.full = function(locale)
{
switch (this.m_ordinal)
{
case 0:  return "January";
case 1:  return "February";
case 2:  return "March";
case 3:  return "April";
case 4:  return "May";
case 5:  return "June";
case 6:  return "July";
case 7:  return "August";
case 8:  return "September";
case 9:  return "October";
case 10: return "November";
case 11: return "December";
}
}
fan.sys.Month.jan = new fan.sys.Month(0,  "jan");
fan.sys.Month.feb = new fan.sys.Month(1,  "feb");
fan.sys.Month.mar = new fan.sys.Month(2,  "mar");
fan.sys.Month.apr = new fan.sys.Month(3,  "apr");
fan.sys.Month.may = new fan.sys.Month(4,  "may");
fan.sys.Month.jun = new fan.sys.Month(5,  "jun");
fan.sys.Month.jul = new fan.sys.Month(6,  "jul");
fan.sys.Month.aug = new fan.sys.Month(7,  "aug");
fan.sys.Month.sep = new fan.sys.Month(8,  "sep");
fan.sys.Month.oct = new fan.sys.Month(9,  "oct");
fan.sys.Month.nov = new fan.sys.Month(10, "nov");
fan.sys.Month.dec = new fan.sys.Month(11, "dec");
fan.sys.Namespace = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Namespace.prototype.$ctor = function() {}
fan.sys.Namespace.prototype.type = function() { return fan.sys.Type.find("sys::Namespace"); }
fan.sys.Param = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Param.prototype.$ctor = function(name, of, hasDefault)
{
this.m_name = name;
this.m_of = fan.sys.Type.find(of);
this.m_hasDefault = hasDefault;
}
fan.sys.Param.prototype.name = function() { return this.m_name; }
fan.sys.Param.prototype.of = function() { return this.m_of; }
fan.sys.Param.prototype.hasDefault = function() { return this.m_hasDefault; }
fan.sys.Param.prototype.type = function()
{
return fan.sys.Type.find("sys::Param");
}
fan.sys.Range = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Range.prototype.$ctor = function(start, end, exclusive)
{
this.m_start = start;
this.m_end = end;
this.m_exclusive = (exclusive == undefined) ? false : exclusive;
}
fan.sys.Range.prototype.type = function()
{
return fan.sys.Type.find("sys::Range")
}
fan.sys.Range.prototype.start = function(size)
{
if (size == null) return this.m_start;
var x = this.m_start;
if (x < 0) x = size + x;
if (x > size) throw new fan.sys.IndexErr(this);
return x;
}
fan.sys.Range.prototype.end = function(size)
{
if (size == null) return this.m_end;
var x = this.m_end;
if (x < 0) x = size + x;
if (this.m_exclusive) x--;
if (x >= size) throw new fan.sys.IndexErr(this);
return x;
}
fan.sys.Range.prototype.toString = function()
{
if (this.m_exclusive)
return this.m_start + "..." + this.m_end;
else
return this.m_start + ".." + this.m_end;
}
fan.sys.Range.make = function(start, end, exclusive)
{
return new fan.sys.Range(start, end, exclusive);
}
fan.sys.Str = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Str.prototype.$ctor = function() {}
fan.sys.Str.prototype.type = function()
{
return fan.sys.Type.find("sys::Str");
}
fan.sys.Str.compareIgnoreCase = function(self, that)
{
var a = self.toLowerCase();
var b = that.toLowerCase();
if (a < b) return -1;
if (a == b) return 0;
return 1;
}
fan.sys.Str.contains = function(self, arg)
{
return self.indexOf(arg) != -1
}
fan.sys.Str.containsChar = function(self, arg)
{
return self.indexOf(fan.sys.Int.toChar(arg)) != -1
}
fan.sys.Str.each = function(self, func)
{
for (var i=0; i<self.length; i++)
func(self.charCodeAt(i), i);
}
fan.sys.Str.endsWith = function(self, test)
{
if (self.length < test.length) return false;
for (var i=0; i<test.length; i++)
if (self[self.length-i-1] != test[test.length-i-1])
return false;
return true;
}
fan.sys.Str.equalsIgnoreCase = function(self, that)
{
return self.toLowerCase() == that.toLowerCase();
}
fan.sys.Str.get = function(self, index)
{
if (index < 0) index += self.length;
return self.charCodeAt(index);
}
fan.sys.Str.index = function(self, s, off)
{
var i = 0;
if (off != null) i = off;
if (i < 0) i = self.length+i;
var r = self.indexOf(s, i);
if (r < 0) return null;
return r;
}
fan.sys.Str.indexr = function(self, s, off)
{
var i = -1;
if (off != null) i = off;
if (i < 0) i = self.length+i;
var r = self.lastIndexOf(s, i);
if (r < 0) return null;
return r;
}
fan.sys.Str.indexIgnoreCase = function(self, s, off)
{
return fan.sys.Str.index(self.toLowerCase(), s.toLowerCase(), off);
}
fan.sys.Str.indexrIgnoreCase = function(self, s, off)
{
return fan.sys.Str.indexr(self.toLowerCase(), s.toLowerCase(), off);
}
fan.sys.Str.intern = function(self)
{
return self;
}
fan.sys.Str.isAscii = function(self)
{
for (var i=0; i<self.length; i++)
if (self.charCodeAt(i) > 127)
return false;
return true;
}
fan.sys.Str.isEmpty = function(self)
{
return self.length == 0;
}
fan.sys.Str.isLower = function(self)
{
for (var i=0; i<self.length; i++)
{
var ch = self.charCodeAt(i);
if (ch < 97 || ch > 122) return false;
}
return true;
}
fan.sys.Str.isSpace = function(self)
{
for (var i=0; i<self.length; i++)
{
var ch = self.charCodeAt(i);
if (ch != 32 && ch != 9 && ch != 10 && ch != 12 && ch != 13)
return false;
}
return true;
}
fan.sys.Str.isUpper = function(self)
{
for (var i=0; i<self.length; i++)
{
var ch = self.charCodeAt(i);
if (ch < 65 || ch > 90) return false;
}
return true;
}
fan.sys.Str.lower = function(self)
{
return self.toLowerCase();
}
fan.sys.Str.replace = function(self, oldstr, newstr)
{
return self.replace(oldstr, newstr);
}
fan.sys.Str.justl = function(self, width)
{
return fan.sys.Str.padr(self, width, 32);
}
fan.sys.Str.justr = function(self, width)
{
return fan.sys.Str.padl(self, width, 32);
}
fan.sys.Str.padl = function(self, w, ch)
{
if (ch == undefined) ch = 32;
if (self.length >= w) return self;
var c = String.fromCharCode(ch);
var s = '';
for (var i=self.length; i<w; ++i) s += c;
s += self;
return s;
}
fan.sys.Str.padr = function(self, w, ch)
{
if (ch == undefined) ch = 32;
if (self.length >= w) return self;
var c = String.fromCharCode(ch);
var s = '';
s += self;
for (var i=self.length; i<w; ++i) s += c;
return s;
}
fan.sys.Str.reverse = function(self)
{
var rev = "";
for (var i=self.length-1; i>=0; i--)
rev += self[i];
return rev;
}
fan.sys.Str.size = function(self)
{
return self.length;
}
fan.sys.Str.slice = function(self, range)
{
var size = self.length;
var s = range.start(size);
var e = range.end(size);
if (e+1 < s) throw new fan.sys.IndexErr(range);
return self.substr(s, (e-s)+1);
}
fan.sys.Str.spaces = function(n)
{
if (fan.sys.Str.$spaces == null)
{
fan.sys.Str.$spaces = new Array();
var s = "";
for (var i=0; i<20; i++)
{
fan.sys.Str.$spaces[i] = s;
s += " ";
}
}
if (n < 20) return fan.sys.Str.$spaces[n];
var s = "";
for (var i=0; i<n; i++) s += " ";
return s;
}
fan.sys.Str.$spaces = null;
fan.sys.Str.capitalize = function(self)
{
if (self.length > 0)
{
var ch = self.charCodeAt(0);
if (97 <= ch && ch <= 122)
return String.fromCharCode(ch & ~0x20) + self.substring(1);
}
return self;
}
fan.sys.Str.toDisplayName = function(self)
{
if (self.length == 0) return "";
var s = '';
var c = self.charCodeAt(0);
if (97 <= c && c <= 122) c &= ~0x20;
s += String.fromCharCode(c);
var last = c;
for (var i=1; i<self.length; ++i)
{
c = self.charCodeAt(i);
if (65 <= c && c <= 90 && last != 95)
{
var next = i+1 < self.length ? self.charCodeAt(i+1) : 81;
if (!(65 <= last && last <= 90) || !(65 <= next && next <= 90))
s += ' ';
}
else if (97 <= c && c <= 122)
{
if ((48 <= last && last <= 57)) { s += ' '; c &= ~0x20; }
else if (last == 95) c &= ~0x20;
}
else if (48 <= c && c <= 57)
{
if (!(48 <= last && last <= 57)) s += ' ';
}
else if (c == 95)
{
s += ' ';
last = c;
continue;
}
s += String.fromCharCode(c);
last = c;
}
return s;
}
fan.sys.Str.startsWith = function(self, test)
{
if (self.length < test.length) return false;
for (var i=0; i<test.length; i++)
if (self[i] != test[i])
return false;
return true;
}
fan.sys.Str.toBool = function(self, checked) { return fan.sys.Bool.fromStr(self, checked); }
fan.sys.Str.toFloat = function(self, checked) { return fan.sys.Float.fromStr(self, checked); }
fan.sys.Str.toInt = function(self, radix, checked) { return fan.sys.Int.fromStr(self, radix, checked); }
fan.sys.Str.trim = function(self, trimStart, trimEnd)
{
if (self.length == 0) return self;
if (trimStart == null) trimStart = true;
if (trimEnd == null) trimEnd = true;
var s = 0;
var e = self.length-1;
while (trimStart && s<self.length && self.charCodeAt(s) <= 32) s++;
while (trimEnd && e>=s && self.charCodeAt(e) <= 32) e--;
return self.substr(s, (e-s)+1);
}
fan.sys.Str.trimStart = function(self) { return fan.sys.Str.trim(self, true, false); }
fan.sys.Str.trimEnd   = function(self) { return fan.sys.Str.trim(self, false, true); }
fan.sys.Str.split = function(self, sep, trimmed)
{
if (sep == null) return fan.sys.Str.splitws(self);
var toks = new Array();
var trim = (trimmed != null) ? trimmed : true;
var len = self.length;
var x = 0;
for (var i=0; i<len; ++i)
{
if (self.charCodeAt(i) != sep) continue;
if (x <= i) toks.push(fan.sys.Str.splitStr(self, x, i, trim));
x = i+1;
}
if (x <= len) toks.push(fan.sys.Str.splitStr(self, x, len, trim));
return toks;
}
fan.sys.Str.splitStr = function(val, s, e, trim)
{
if (trim == true)
{
while (s < e && val.charCodeAt(s) <= 32) ++s;
while (e > s && val.charCodeAt(e-1) <= 32) --e;
}
return val.substring(s, e);
}
fan.sys.Str.splitws = function(val)
{
var toks = new Array();
var len = val.length;
while (len > 0 && val.charCodeAt(len-1) <= 32) --len;
var x = 0;
while (x < len && val.charCodeAt(x) <= 32) ++x;
for (var i=x; i<len; ++i)
{
if (val.charCodeAt(i) > 32) continue;
toks.push(val.substring(x, i));
x = i + 1;
while (x < len && val.charCodeAt(x) <= 32) ++x;
i = x;
}
if (x <= len) toks.push(val.substring(x, len));
if (toks.length == 0) toks.push("");
return toks;
}
fan.sys.Str.splitLines = function(self)
{
var lines = fan.sys.List.make(fan.sys.Type.find("sys::Str"), []);
var len = self.length;
var s = 0;
for (var i=0; i<len; ++i)
{
var c = self.charAt(i);
if (c == '\n' || c == '\r')
{
lines.push(self.substring(s, i));
s = i+1;
if (c == '\r' && s < len && self.charAt(s) == '\n') { i++; s++; }
}
}
lines.push(self.substring(s, len));
return lines;
}
fan.sys.Str.upper = function(self) { return self.toUpperCase(); }
fan.sys.Str.$in = function(self) { return fan.sys.InStream.makeForStr(self); }
fan.sys.Str.toUri = function(self) { return fan.sys.Uri.make(self); }
fan.sys.Str.toBuf = function(self)
{
var buf = new fan.sys.MemBuf();
buf.print(self);
return buf.flip();
}
fan.sys.Str.toCode = function(self, quote, escu)
{
if (quote == undefined) quote = 34;
if (escu == undefined) escu = false;
var s = "";
var q = 0;
if (quote != null)
{
q = String.fromCharCode(quote);
s += q;
}
var len = self.length;
for (var i=0; i<len; ++i)
{
var c = self.charAt(i);
switch (c)
{
case '\n': s += '\\' + 'n'; break;
case '\r': s += '\\' + 'r'; break;
case '\f': s += '\\' + 'f'; break;
case '\t': s += '\\' + 't'; break;
case '\\': s += '\\' + '\\'; break;
case '"':  if (q == '"')  s += '\\' + '"';  else s += c; break;
case '`':  if (q == '`')  s += '\\' + '`';  else s += c; break;
case '\'': if (q == '\'') s += '\\' + '\''; else s += c; break;
case '$':  s += '\\' + '$'; break;
default:
var hex  = function(x) { return "0123456789abcdef".charAt(x); }
var code = c.charCodeAt(0);
if (escu && code > 127)
{
s += '\\' + 'u'
+ hex((code>>12)&0xf)
+ hex((code>>8)&0xf)
+ hex((code>>4)&0xf)
+ hex(code & 0xf);
}
else
{
s += c;
}
}
}
if (q != 0) s += q;
return s;
}
fan.sys.StrBuf = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.StrBuf.prototype.$ctor = function()
{
this.m_str = "";
}
fan.sys.StrBuf.prototype.type = function()
{
return fan.sys.Type.find("sys::StrBuf");
}
fan.sys.StrBuf.prototype.add = function(obj)
{
this.m_str += obj==null ? "null" : fan.sys.Obj.toStr(obj);
return this;
}
fan.sys.StrBuf.prototype.addChar = function(ch)
{
this.m_str += String.fromCharCode(ch);
return this;
}
fan.sys.StrBuf.prototype.isEmpty = function()
{
return this.m_str.length == 0;
}
fan.sys.StrBuf.prototype.size = function()
{
return this.m_str.length;
}
fan.sys.StrBuf.prototype.toStr = function()
{
return this.m_str;
}
fan.sys.StrBuf.make = function() { return new fan.sys.StrBuf(); }
fan.sys.StrInStream = fan.sys.Obj.$extend(fan.sys.InStream);
fan.sys.StrInStream.prototype.$ctor = function(str)
{
this.str  = str;
this.size = str.length;
this.pos  = 0;
this.pushback = null;
}
fan.sys.StrInStream.prototype.read = function()
{
var b = this.readChar();
return (b < 0) ? null : (b & 0xff);
}
fan.sys.StrInStream.prototype.readBuf = function(buf, n)
{
var nval = n;
for (var i=0; i<nval; ++i)
{
var c = this.readChar();
if (c < 0) return i;
buf.out.w(c);
}
return n;
}
fan.sys.StrInStream.prototype.unread = function(c)
{
return unreadChar(c);
}
fan.sys.StrInStream.prototype.readChar = function()
{
if (this.pushback != null && this.pushback.length > 0)
return this.pushback.pop();
if (this.pos >= this.size) return null;
return this.str.charCodeAt(this.pos++);
}
fan.sys.StrInStream.prototype.unreadChar = function(c)
{
if (this.pushback == null) this.pushback = [];
this.pushback.push(c);
return this;
}
fan.sys.StrInStream.prototype.close = function()
{
return true;
}
fan.sys.Test = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Test.prototype.$ctor = function()
{
this.verifyCount = 0;
}
fan.sys.Test.prototype.verify = function(cond, msg)
{
if (!cond) this.fail(msg);
this.verifyCount++;
}
fan.sys.Test.prototype.verifyFalse = function(cond, msg)
{
if (cond) this.fail(msg);
this.verifyCount++;
}
fan.sys.Test.prototype.verifyEq = function(expected, actual, msg)
{
if (!fan.sys.Obj.equals(expected, actual))
{
if (msg == null) msg = fan.sys.Obj.toStr(expected) + " != " + fan.sys.Obj.toStr(actual);
this.fail(msg);
}
this.verifyCount++;
}
fan.sys.Test.prototype.verifyNotEq = function(expected, actual, msg)
{
if (fan.sys.Obj.equals(expected, actual))
{
if (msg == null) msg = fan.sys.Obj.toStr(expected) + " == " + fan.sys.Obj.toStr(actual);
this.fail(msg);
}
this.verifyCount++;
}
fan.sys.Test.prototype.verifySame = function(expected, actual, msg)
{
if (!fan.sys.Obj.equals(expected, actual))
{
if (msg == null) msg = fan.sys.Obj.toStr(expected) + " !== " + fan.sys.Obj.toStr(actual);
this.fail(msg);
}
this.verifyCount++;
}
fan.sys.Test.prototype.verifyNotSame = function(expected, actual, msg)
{
if (fan.sys.Obj.equals(expected == actual))
{
if (msg == null) msg = fan.sys.Obj.toStr(expected) + " === " + fan.sys.Obj.toStr(actual);
this.fail(msg);
}
this.verifyCount++;
}
fan.sys.Test.prototype.verifyErr = function(errType, f)
{
try
{
f();
}
catch (err)
{
var e = fan.sys.Err.make(err);
if (e.type() == errType) { this.verifyCount++; return; }
println("  verifyErr: " + e);
this.fail(e.type() + " thrown, expected " + errType);
}
this.fail("No err thrown, expected " + errType);
}
fan.sys.Test.prototype.fail = function(msg)
{
throw this.err(msg);
}
fan.sys.Test.prototype.err = function(msg)
{
if (msg == null)
return new fan.sys.Err("Test failed");
else
return new fan.sys.Err("Test failed: " + msg);
}
fan.sys.Test.prototype.type = function()
{
return fan.sys.Type.find("sys::Test")
}
function TestException(msg)
{
this.message = msg;
this.name = "TestException";
}
TestException.prototype.toString = function()
{
return this.name + ": " + this.message;
}
fan.sys.Time = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Time.prototype.$ctor = function(hour, min, sec, ns)
{
if (hour < 0 || hour > 23)     throw fan.sys.ArgErr.make("hour " + hour);
if (min < 0 || min > 59)       throw fan.sys.ArgErr.make("min " + min);
if (sec < 0 || sec > 59)       throw fan.sys.ArgErr.make("sec " + sec);
if (ns < 0 || ns > 999999999)  throw fan.sys.ArgErr.make("ns " + ns);
this.m_hour = hour;
this.m_min  = min;
this.m_sec  = sec;
this.m_ns   = ns;
}
fan.sys.Time.make = function(hour, min, sec, ns)
{
if (sec == undefined) sec = 0;
if (ns == undefined)  ns = 0;
return new fan.sys.Time(hour, min, sec, ns);
}
fan.sys.Time.now = function()
{
var d = new Date();
return new fan.sys.Time(d.getHours(), d.getMinutes(), d.getSeconds());
}
fan.sys.Time.fromStr = function(s, checked)
{
if (checked == undefined) checked = true;
try
{
var num = function(x,index) { return x.charCodeAt(index) - 48; }
var hour  = num(s, 0)*10  + num(s, 1);
var min   = num(s, 3)*10  + num(s, 4);
var sec   = num(s, 6)*10  + num(s, 7);
if (s.charAt(2) != ':' || s.charAt(5) != ':')
throw new Error();
var i = 8;
var ns = 0;
var tenth = 100000000;
var len = s.length;
if (i < len && s.charAt(i) == '.')
{
++i;
while (i < len)
{
var c = s.charCodeAt(i);
if (c < 48 || c > 57) break;
ns += (c - 48) * tenth;
tenth /= 10;
++i;
}
}
if (i < s.length) throw new Error();
return new fan.sys.Time(hour, min, sec, ns);
}
catch (err)
{
if (!checked) return null;
throw fan.sys.ParseErr.make("Time", s).val;
}
}
fan.sys.Time.prototype.equals = function(that)
{
if (that instanceof fan.sys.Time)
{
return this.m_hour.valueOf() == that.m_hour.valueOf() &&
this.m_min.valueOf() == that.m_min.valueOf() &&
this.m_sec.valueOf() == that.m_sec.valueOf() &&
this.m_ns.valueOf() == that.m_ns.valueOf();
}
return false;
}
fan.sys.Time.prototype.compare = function(that)
{
if (this.m_hour.valueOf() == that.m_hour.valueOf())
{
if (this.m_min.valueOf() == that.m_min.valueOf())
{
if (this.m_sec.valueOf() == that.m_sec.valueOf())
{
if (this.m_ns.valueOf() == that.m_ns.valueOf()) return 0;
return this.m_ns < that.m_ns ? -1 : +1;
}
return this.m_sec < that.m_sec ? -1 : +1;
}
return this.m_min < that.m_min ? -1 : +1;
}
return this.m_hour < that.m_hour ? -1 : +1;
}
fan.sys.Time.prototype.toStr = function()
{
return this.toLocale("hh:mm:ss.FFFFFFFFF");
}
fan.sys.Time.prototype.type = function()
{
return fan.sys.Type.find("sys::Time");
}
fan.sys.Time.prototype.hour = function() { return this.m_hour; }
fan.sys.Time.prototype.min = function() { return this.m_min; }
fan.sys.Time.prototype.sec = function() { return this.m_sec; }
fan.sys.Time.prototype.nanoSec = function() { return this.m_ns; }
fan.sys.Time.prototype.toLocale = function(pattern)
{
if (pattern == undefined) pattern = null;
var locale = null;
if (pattern == null)
{
pattern = "hh:mm:ss";
}
var s = '';
var len = pattern.length;
for (var i=0; i<len; ++i)
{
var c = pattern.charAt(i);
if (c == '\'')
{
while (true)
{
++i;
if (i >= len) throw fan.sys.ArgErr.make("Invalid pattern: unterminated literal");
c = pattern.charAt(i);
if (c == '\'') break;
s += c;
}
continue;
}
var n = 1;
while (i+1<len && pattern.charAt(i+1) == c) { ++i; ++n; }
var invalidNum = false;
switch (c)
{
case 'h':
case 'k':
var hour = this.hour();
if (c == 'k')
{
if (hour == 0) hour = 12;
else if (hour > 12) hour -= 12;
}
switch (n)
{
case 2:  if (hour < 10) s += '0';
case 1:  s += hour; break;
default: invalidNum = true;
}
break;
case 'm':
var min = this.min();
switch (n)
{
case 2:  if (min < 10) s += '0';
case 1:  s += min; break;
default: invalidNum = true;
}
break;
case 's':
var sec = this.sec();
switch (n)
{
case 2:  if (sec < 10) s += '0';
case 1:  s += sec; break;
default: invalidNum = true;
}
break;
case 'a':
switch (n)
{
case 1:  s += this.hour() < 12 ? "AM" : "PM"; break;
default: invalidNum = true;
}
break;
case 'f':
case 'F':
var req = 0, opt = 0;
if (c == 'F') opt = n;
else
{
req = n;
while (i+1<len && pattern.charAt(i+1) == 'F') { ++i; ++opt; }
}
var frac = this.nanoSec();
for (var x=0, tenth=100000000; x<9; ++x)
{
if (req > 0) req--;
else
{
if (frac == 0 || opt <= 0) break;
opt--;
}
s += Math.floor(frac / tenth);
frac %= tenth;
tenth /= 10;
}
break;
default:
if (fan.sys.Int.isAlpha(c.charCodeAt(0)))
throw fan.sys.ArgErr.make("Invalid pattern: unsupported char '" + c + "'");
if (i+1<len && pattern.charAt(i+1) == 'F' && this.nanoSec() == 0)
break;
s += c;
}
if (invalidNum)
throw fan.sys.ArgErr.make("Invalid pattern: unsupported num '" + c + "' (x" + n + ")");
}
return s;
}
fan.sys.Time.defVal = new fan.sys.Time(0, 0, 0, 0);
fan.sys.TimeZone = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.TimeZone.prototype.$ctor = function()
{
this.m_name = null;
this.m_fullName = null;
this.m_rules = null;
}
fan.sys.TimeZone.listNames = function()
{
return fan.sys.List.ro(fan.sys.TimeZone.names);
}
fan.sys.TimeZone.listFullNames = function()
{
return fan.sys.List.ro(fan.sys.TimeZone.fullNames);
}
fan.sys.TimeZone.fromStr = function(name, checked)
{
if (checked == undefined) checked = true;
var tz = fan.sys.TimeZone.cache[name];
if (tz != null) return tz;
if (checked) throw fan.sys.ParseErr.make("TimeZone not found: " + name);
return null;
}
fan.sys.TimeZone.defVal = function()
{
return fan.sys.TimeZone.utc();
}
fan.sys.TimeZone.utc = function()
{
if (fan.sys.TimeZone.m_utc == null)
fan.sys.TimeZone.m_utc = fan.sys.TimeZone.fromStr("UTC");
return fan.sys.TimeZone.m_utc;
}
fan.sys.TimeZone.current = function()
{
return fan.sys.TimeZone.utc();
}
fan.sys.TimeZone.prototype.toStr = function () { return this.m_name; }
fan.sys.TimeZone.prototype.type = function() { return fan.sys.Type.find("sys::TimeZone"); }
fan.sys.TimeZone.prototype.name = function () { return this.m_name; }
fan.sys.TimeZone.prototype.fullName = function() { return this.m_fullName; }
fan.sys.TimeZone.prototype.offset = function(year)
{
return fan.sys.Duration.make(this.rule(year).offset * fan.sys.Duration.nsPerSec);
}
fan.sys.TimeZone.prototype.dstOffset = function(year)
{
var r = this.rule(year);
if (r.dstOffset == 0) return null;
return fan.sys.Duration.make(r.dstOffset * fan.sys.Duration.nsPerSec);
}
fan.sys.TimeZone.prototype.stdAbbr = function(year)
{
return this.rule(year).stdAbbr;
}
fan.sys.TimeZone.prototype.dstAbbr = function(year)
{
return this.rule(year).dstAbbr;
}
fan.sys.TimeZone.prototype.abbr = function(year, inDST)
{
return inDST ? this.rule(year).dstAbbr : this.rule(year).stdAbbr;
}
fan.sys.TimeZone.prototype.rule = function(year)
{
var rule = this.m_rules[0];
if (year >= rule.startYear) return rule;
for (var i=1; i<this.m_rules.length; ++i)
if (year >= (rule = this.m_rules[i]).startYear) return rule;
return this.m_rules[this.m_rules.length-1];
}
fan.sys.TimeZone.dstOffset = function(rule, year, mon, day, time)
{
var start = rule.dstStart;
var end   = rule.dstEnd;
if (start == null) return 0;
var s = fan.sys.TimeZone.compare(rule, start, year, mon, day, time);
var e = fan.sys.TimeZone.compare(rule, end,   year, mon, day, time);
if (end.mon < start.mon)
{
if (e > 0 || s <= 0) return rule.dstOffset;
}
else
{
if (s <= 0 && e > 0) return rule.dstOffset;
}
return 0;
}
fan.sys.TimeZone.compare = function(rule, x, year, mon, day, time)
{
var c = fan.sys.TimeZone.compareMonth(x, mon);
if (c != 0) return c;
c = fan.sys.TimeZone.compareOnDay(rule, x, year, mon, day);
if (c != 0) return c;
return fan.sys.TimeZone.compareAtTime(rule, x, time);
}
fan.sys.TimeZone.compareMonth = function(x, mon)
{
if (x.mon < mon) return -1;
if (x.mon > mon) return +1;
return 0;
}
fan.sys.TimeZone.compareOnDay = function(rule, x, year, mon, day)
{
if (x.atMode == 'u' && rule.offset + x.atTime < 0)
++day;
switch (x.onMode)
{
case 'd':
if (x.onDay < day) return -1;
if (x.onDay > day) return +1;
return 0;
case 'l':
var last = fan.sys.DateTime.weekdayInMonth(year, fan.sys.Month.values[mon], fan.sys.Weekday.values[x.onWeekday], -1);
if (last < day) return -1;
if (last > day) return +1;
return 0;
case '>':
var start = fan.sys.DateTime.weekdayInMonth(year, fan.sys.Month.values[mon], fan.sys.Weekday.values[x.onWeekday], 1);
while (start < x.onDay) start += 7;
if (start < day) return -1;
if (start > day) return +1;
return 0;
default:
throw new Error('' + x.onMode);
}
}
fan.sys.TimeZone.compareAtTime = function(rule, x, time)
{
var atTime = x.atTime;
if (x.atMode == 'u')
{
if (rule.offset + x.atTime < 0)
atTime = 24*60*60 + rule.offset + x.atTime;
else
atTime += rule.offset;
}
if (atTime < time) return -1;
if (atTime > time) return +1;
return 0;
}
fan.sys.TimeZone.cache = [];
fan.sys.TimeZone.names = [];
fan.sys.TimeZone.fullNames = [];
fan.sys.TimeZone.m_utc = null;
fan.sys.TimeZone.m_current = null;
fan.sys.TimeZone$Rule = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.TimeZone$Rule.prototype.$ctor = function()
{
this.startYear = null;
this.offset = null;
this.stdAbbr = null;
this.dstOffset = null;
this.dstAbbr = null;
this.dstStart = null;
this.dstEnd = null;
}
fan.sys.TimeZone$Rule.prototype.isWallTime = function()
{
return this.dstStart.atMode == 'w';
}
fan.sys.TimeZone$DstTime = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.TimeZone$DstTime.prototype.$ctor = function(mon, onMode, onWeekday, onDay, atTime, atMode)
{
this.mon = mon;
this.onMode = String.fromCharCode(onMode);
this.onWeekday = onWeekday;
this.onDay = onDay;
this.atTime = atTime;
this.atMode = String.fromCharCode(atMode);
}
fan.sys.Uri = fan.sys.Obj.$extend(fan.sys.Obj);
fan.sys.Uri.prototype.$ctor = function(uri)
{
this.m_uri = uri;
}
fan.sys.Uri.prototype.type = function()
{
return fan.sys.Type.find("sys::Uri");
}
fan.sys.Uri.prototype.equals = function(that)
{
return this.m_uri == that.m_uri;
}
fan.sys.Uri.prototype.toCode = function()
{
return '`' + this.m_str + '`';
}
fan.sys.Uri.prototype.toStr = function()
{
return this.m_uri;
}
fan.sys.Uri.prototype.get = function()
{
return fan.sys.File.make();
}
fan.sys.Uri.make = function(uri)
{
return new fan.sys.Uri(uri);
}
fan.sys.Uri.fromStr = function(s)
{
return new fan.sys.Uri(s);
}
fan.sys.Weekday = fan.sys.Obj.$extend(fan.sys.Enum);
fan.sys.Weekday.prototype.$ctor = function(ordinal, name)
{
this.make$(ordinal, name);
}
fan.sys.Weekday.prototype.increment = function()
{
var arr = fan.sys.Weekday.values;
return arr[(this.m_ordinal+1) % arr.length];
}
fan.sys.Weekday.prototype.decrement = function()
{
var arr = fan.sys.Weekday.values;
return this.m_ordinal == 0 ? arr[arr.length-1] : arr[this.m_ordinal-1];
}
fan.sys.Weekday.prototype.type = function()
{
return fan.sys.Type.find("sys::Weekday");
}
fan.sys.Weekday.prototype.abbr = function(locale)
{
switch (this.m_ordinal)
{
case 0:  return "Sun";
case 1:  return "Mon";
case 2:  return "Tue";
case 3:  return "Wed";
case 4:  return "Thu";
case 5:  return "Fri";
case 6:  return "Sat";
}
}
fan.sys.Weekday.prototype.full = function(locale)
{
switch (this.m_ordinal)
{
case 0:  return "Sundary";
case 1:  return "Monday";
case 2:  return "Tuesday";
case 3:  return "Wednesday";
case 4:  return "Thursday";
case 5:  return "Friday";
case 6:  return "Saturday";
}
}
fan.sys.Weekday.sun = new fan.sys.Weekday(0,  "sun");
fan.sys.Weekday.mon = new fan.sys.Weekday(1,  "mon");
fan.sys.Weekday.tue = new fan.sys.Weekday(2,  "tue");
fan.sys.Weekday.wed = new fan.sys.Weekday(3,  "wed");
fan.sys.Weekday.thu = new fan.sys.Weekday(4,  "thu");
fan.sys.Weekday.fri = new fan.sys.Weekday(5,  "fri");
fan.sys.Weekday.sat = new fan.sys.Weekday(6,  "sat");
fan.sys.Weekday.values =
[
fan.sys.Weekday.sun,
fan.sys.Weekday.mon,
fan.sys.Weekday.tue,
fan.sys.Weekday.wed,
fan.sys.Weekday.thu,
fan.sys.Weekday.fri,
fan.sys.Weekday.sat
];
function fanx_ObjDecoder(input, options)
{
this.tokenizer = new fanx_Tokenizer(input);
this.options = options;
this.curt = null;
this.usings = [];
this.numUsings = 0;
this.consume();
fanx_ObjDecoder.defaultMapType =
new fan.sys.MapType(fan.sys.Type.find("sys::Obj"), fan.sys.Type.find("sys::Obj"));
}
fanx_ObjDecoder.prototype.readObj = function()
{
this.readHeader();
return this.$readObj(null, null, true);
}
fanx_ObjDecoder.prototype.readHeader = function()
{
while (this.curt == fanx_Token.USING)
this.usings[this.numUsings++] = this.readUsing();
}
fanx_ObjDecoder.prototype.readUsing = function()
{
var line = this.tokenizer.line;
this.consume();
var podName = this.consumeId("Expecting pod name");
var pod = fan.sys.Pod.find(podName, false);
if (pod == null) throw this.err("Unknown pod: " + podName);
if (this.curt != fanx_Token.DOUBLE_COLON)
{
this.endOfStmt(line);
return new fanx_UsingPod(pod);
}
this.consume();
var typeName = this.consumeId("Expecting type name");
var t = pod.findType(typeName, false);
if (t == null) throw this.err("Unknown type: " + podName + "::" + typeName);
if (this.curt == fanx_Token.AS)
{
this.consume();
typeName = consumeId("Expecting using as name");
}
this.endOfStmt(line);
return new UsingType(t, typeName);
}
fanx_ObjDecoder.prototype.$readObj = function(curField, peekType, root)
{
if (fanx_Token.isLiteral(this.curt))
{
var val = this.tokenizer.val;
this.consume();
return val;
}
if (this.curt == fanx_Token.LBRACKET)
return this.readCollection(curField, peekType);
var line = this.tokenizer.line;
var t = (peekType != null) ? peekType : this.readType();
if (this.curt == fanx_Token.LPAREN)
return this.readSimple(line, t);
else if (this.curt == fanx_Token.POUND)
return this.readTypeLiteral(line, t);
else if (this.curt == fanx_Token.LBRACKET)
return this.readCollection(curField, t);
else
return this.readComplex(line, t, root);
}
fanx_ObjDecoder.prototype.readTypeLiteral = function(line, t)
{
this.consume(fanx_Token.POUND, "Expected '#' for type literal");
return t;
}
fanx_ObjDecoder.prototype.readSimple = function(line, t)
{
this.consume(fanx_Token.LPAREN, "Expected ( in simple");
var str = this.consumeStr("Expected string literal for simple");
this.consume(fanx_Token.RPAREN, "Expected ) in simple");
var script = "fan." + t.pod().name() + "." + t.name() + ".fromStr('" + str + "')";
return eval(script);
}
fanx_ObjDecoder.prototype.readComplex = function(line, t, root)
{
var obj = null;
try
{
var args = null;
if (root && this.options != null)
args = this.options.get("makeArgs");
obj = t.make(args);
}
catch (e)
{
throw fan.sys.IOErr.make("Cannot make " + t + ": " + e + " [Line " + line + "]", e);
}
if (this.curt != fanx_Token.LBRACE) return obj;
this.consume();
while (this.curt != fanx_Token.RBRACE)
{
line = this.tokenizer.line;
var readField = false;
if (this.curt == fanx_Token.ID)
{
var name = this.consumeId("Expected field name");
if (this.curt == fanx_Token.EQ)
{
this.consume();
this.readComplexField(t, obj, line, name);
readField = true;
}
else
{
this.tokenizer.undo(this.tokenizer.type, this.tokenizer.val, this.tokenizer.line);
this.curt = this.tokenizer.reset(fanx_Token.ID, name, line);
}
}
if (!readField) this.readComplexAdd(t, obj, line);
if (this.curt == fanx_Token.COMMA) this.consume();
else this.endOfStmt(line);
}
this.consume(fanx_Token.RBRACE, "Expected '}'");
return obj;
}
fanx_ObjDecoder.prototype.readComplexAdd = function(t, obj, line)
{
var val = this.$readObj(null, null, false);
var m = t.method("add", false);
if (m == null) throw this.err("Method not found: " + t.qname() + ".add", line);
try
{
m.invoke(obj, [val]);
}
catch (err)
{
throw fan.sys.IOErr.make("Cannot call " + t.qname() + ".add: " + err + " [Line " + line + "]", err);
}
}
fanx_ObjDecoder.prototype.readComplexField = function(t, obj, line, name)
{
var field = t.field(name, false);
if (field == null) throw this.err("Field not found: " + t.qname() + "." + name, line);
var val = this.$readObj(field, null, false);
try
{
if (field.isConst())
field.set(obj, OpUtil.toImmutable(val), false);
else
field.set(obj, val);
}
catch (err)
{
throw fan.sys.IOErr.make("Cannot set field " + t.qname() + "." + name + ": " + err + " [Line " + line + "]", err);
}
}
fanx_ObjDecoder.prototype.readCollection = function(curField, t)
{
this.consume(fanx_Token.LBRACKET, "Expecting '['");
var peekType = null;
if (this.curt == fanx_Token.ID && t == null)
{
peekType = this.readType();
if (this.curt == fanx_Token.RBRACKET && peekType instanceof fan.sys.MapType)
{
t = peekType; peekType = null;
this.consume();
while (this.curt == fanx_Token.LRBRACKET) { this.consume(); t = t.toListOf(); }
this.consume(fanx_Token.LBRACKET, "Expecting '['");
}
}
if (this.curt == fanx_Token.COMMA && peekType == null)
{
this.consume();
this.consume(fanx_Token.RBRACKET, "Expecting ']'");
return fan.sys.List.make(this.toListOfType(t, curField, false), []);
}
if (this.curt == fanx_Token.COLON && peekType == null)
{
this.consume();
this.consume(fanx_Token.RBRACKET, "Expecting ']'");
return new fan.sys.Map(this.toMapType(t, curField, false));
}
var first = this.$readObj(null, peekType, false);
if (this.curt == fanx_Token.COLON)
return this.readMap(this.toMapType(t, curField, true), first);
else
return this.readList(this.toListOfType(t, curField, true), first);
}
fanx_ObjDecoder.prototype.readList = function(of, first)
{
var acc = [];
acc.push(first)
while (this.curt != fanx_Token.RBRACKET)
{
this.consume(fanx_Token.COMMA, "Expected ','");
if (this.curt == fanx_Token.RBRACKET) break;
acc.push(this.$readObj(null, null, false));
}
this.consume(fanx_Token.RBRACKET, "Expected ']'");
if (of == null) of = fan.sys.Type.common(acc);
return fan.sys.List.make(of, acc);
}
fanx_ObjDecoder.prototype.toListOfType = function(t, curField, infer)
{
if (t != null) return t;
if (curField != null)
{
var ft = curField.of().toNonNullable();
if (ft instanceof fan.sys.ListType) return ft.v;
}
if (infer) return null;
return fan.sys.Type.find("sys::Obj").toNullable();
}
fanx_ObjDecoder.prototype.toMapType = function(t, curField, infer)
{
if (t instanceof fan.sys.MapType)
return t;
if (curField != null)
{
var ft = curField.of().toNonNullable();
if (ft instanceof fan.sys.MapType) return ft;
}
if (infer) return null;
return fanx_ObjDecoder.defaultMapType;
}
fanx_ObjDecoder.prototype.readType = function(lbracket)
{
if (lbracket == undefined) lbracket = false;
var t = this.readSimpleType();
if (this.curt == fanx_Token.QUESTION)
{
this.consume();
t = t.toNullable();
}
if (this.curt == fanx_Token.COLON)
{
this.consume();
t = new fan.sys.MapType(t, this.readType());
}
while (this.curt == fanx_Token.LRBRACKET)
{
this.consume();
t = t.toListOf();
}
if (this.curt == fanx_Token.QUESTION)
{
this.consume();
t = t.toNullable();
}
return t;
}
fanx_ObjDecoder.prototype.readSimpleType = function()
{
var line = this.tokenizer.line;
var n = this.consumeId("Expected type signature");
if (this.curt != fanx_Token.DOUBLE_COLON)
{
for (var i=0; i<this.numUsings; ++i)
{
var t = this.usings[i].resolve(n);
if (t != null) return t;
}
throw this.err("Unresolved type name: " + n);
}
this.consume(fanx_Token.DOUBLE_COLON, "Expected ::");
var typeName = this.consumeId("Expected type name");
var pod = fan.sys.Pod.find(n, false);
if (pod == null) throw this.err("Pod not found: " + n, line);
var type = pod.findType(typeName, false);
if (type == null) throw fanx_ObjDecoder.err("Type not found: " + n + "::" + typeName, line);
return type;
}
fanx_ObjDecoder.prototype.err = function(msg)
{
return fanx_ObjDecoder.err(msg, this.tokenizer.line);
}
fanx_ObjDecoder.prototype.consumeId = function(expected)
{
this.verify(fanx_Token.ID, expected);
var id = this.tokenizer.val;
this.consume();
return id;
}
fanx_ObjDecoder.prototype.consumeStr = function(expected)
{
this.verify(fanx_Token.STR_LITERAL, expected);
var id = this.tokenizer.val;
this.consume();
return id;
}
fanx_ObjDecoder.prototype.consume = function(type, expected)
{
if (type != undefined)
this.verify(type, expected);
this.curt = this.tokenizer.next();
}
fanx_ObjDecoder.prototype.verify = function(type, expected)
{
if (this.curt != type)
throw this.err(expected + ", not '" + fanx_Token.toString(this.curt) + "'");
}
fanx_ObjDecoder.prototype.endOfStmt = function(lastLine)
{
if (this.curt == fanx_Token.SEMICOLON) { this.consume(); return; }
if (lastLine < this.tokenizer.line) return;
if (this.curt == fanx_Token.RBRACE) return;
throw this.err("Expected end of statement: semicolon, newline, or end of block; not '" + fanx_Token.toString(this.curt) + "'");
}
fanx_ObjDecoder.decode = function(s)
{
return new fanx_ObjDecoder(InStream.makeForStr(s), null).readObj();
}
fanx_ObjDecoder.err = function(msg, line)
{
return fan.sys.IOErr.make(msg + " [Line " + line + "]");
}
fanx_ObjDecoder.defaultMapType = null;
function fanx_UsingPod(p) { this.pod = p; }
fanx_UsingPod.prototype.resolve = function(n)
{
return this.pod.findType(n, false);
}
function fanx_UsingType(t,n) { this.type = t; this.name = n; }
fanx_UsingType.prototype.resolve = function(n)
{
return this.name.equals(n) ? this.type : null;
}
function fanx_Token() {}
fanx_Token.EOF              = -1;
fanx_Token.ID               = 0;
fanx_Token.BOOL_LITERAL     = 1;
fanx_Token.STR_LITERAL      = 2;
fanx_Token.INT_LITERAL      = 3;
fanx_Token.FLOAT_LITERAL    = 4;
fanx_Token.DECIMAL_LITERAL  = 5;
fanx_Token.DURATION_LITERAL = 6;
fanx_Token.URI_LITERAL      = 7;
fanx_Token.NULL_LITERAL     = 8;
fanx_Token.DOT              = 9;
fanx_Token.SEMICOLON        = 10;
fanx_Token.COMMA            = 11;
fanx_Token.COLON            = 12;
fanx_Token.DOUBLE_COLON     = 13;
fanx_Token.LBRACE           = 14;
fanx_Token.RBRACE           = 15;
fanx_Token.LPAREN           = 16;
fanx_Token.RPAREN           = 17;
fanx_Token.LBRACKET         = 18;
fanx_Token.RBRACKET         = 19;
fanx_Token.LRBRACKET        = 20;
fanx_Token.EQ               = 21;
fanx_Token.POUND            = 22;
fanx_Token.QUESTION         = 23;
fanx_Token.AS               = 24;
fanx_Token.USING            = 25;
fanx_Token.isLiteral = function(type)
{
return fanx_Token.BOOL_LITERAL <= type && type <= fanx_Token.NULL_LITERAL;
}
fanx_Token.toString = function(type)
{
switch (type)
{
case fanx_Token.EOF:              return "end of file";
case fanx_Token.ID:               return "identifier";
case fanx_Token.BOOL_LITERAL:     return "Bool literal";
case fanx_Token.STR_LITERAL:      return "String literal";
case fanx_Token.INT_LITERAL:      return "Int literal";
case fanx_Token.FLOAT_LITERAL:    return "Float literal";
case fanx_Token.DECIMAL_LITERAL:  return "Decimal literal";
case fanx_Token.DURATION_LITERAL: return "Duration literal";
case fanx_Token.URI_LITERAL:      return "Uri literal";
case fanx_Token.NULL_LITERAL:     return "null";
case fanx_Token.DOT:              return ".";
case fanx_Token.SEMICOLON:        return ";";
case fanx_Token.COMMA:            return ",";
case fanx_Token.COLON:            return ":";
case fanx_Token.DOUBLE_COLON:     return "::";
case fanx_Token.LBRACE:           return "{";
case fanx_Token.RBRACE:           return "}";
case fanx_Token.LPAREN:           return "(";
case fanx_Token.RPAREN:           return ")";
case fanx_Token.LBRACKET:         return "[";
case fanx_Token.RBRACKET:         return "]";
case fanx_Token.LRBRACKET:        return "[]";
case fanx_Token.EQ:               return "=";
case fanx_Token.POUND:            return "#";
case fanx_Token.QUESTION:         return "?";
case fanx_Token.AS:               return "as";
case fanx_Token.USING:            return "using";
default:                          return "Token[" + type + "]";
}
}
function fanx_Tokenizer(input)
{
this.input = null;
this.type  = null;
this.val   = null;
this.line  = 1;
this.$undo = null;
this.cur   = 0;
this.curt  = 0;
this.peek  = 0;
this.peekt = 0;
this.input = input;
this.consume();
this.consume();
}
fanx_Tokenizer.prototype.next = function()
{
if (this.$undo != null) { this.$undo.reset(this); this.$undo = null; return this.type; }
this.val = null;
return this.type = this.doNext();
}
fanx_Tokenizer.prototype.doNext = function()
{
while (true)
{
while (this.curt == fanx_Tokenizer.SPACE) this.consume();
if (this.cur < 0) return fanx_Token.EOF;
if (this.curt == fanx_Tokenizer.ALPHA) return this.id();
if (this.curt == fanx_Tokenizer.DIGIT) return this.number(false);
switch (this.cur)
{
case  43:  this.consume(); return this.number(false);
case  45:  this.consume(); return this.number(true);
case  34:  return this.str();
case  39:  return this.ch();
case  96:  return this.uri();
case  40:  this.consume(); return fanx_Token.LPAREN;
case  41:  this.consume(); return fanx_Token.RPAREN;
case  44:  this.consume(); return fanx_Token.COMMA;
case  59:  this.consume(); return fanx_Token.SEMICOLON;
case  61:  this.consume(); return fanx_Token.EQ;
case  123: this.consume(); return fanx_Token.LBRACE;
case  125: this.consume(); return fanx_Token.RBRACE;
case  35:  this.consume(); return fanx_Token.POUND;
case  63:  this.consume(); return fanx_Token.QUESTION;
case  46:
if (this.peekt == fanx_Tokenizer.DIGIT) return this.number(false);
this.consume();
return fanx_Token.DOT;
case  91:
this.consume();
if (this.cur == 93 ) { this.consume(); return fanx_Token.LRBRACKET; }
return fanx_Token.LBRACKET;
case  93:
this.consume();
return fanx_Token.RBRACKET;
case  58:
this.consume();
if (this.cur == 58 ) { this.consume(); return fanx_Token.DOUBLE_COLON; }
return fanx_Token.COLON;
case  42:
if (this.peek == 42 ) { this.skipCommentSL(); continue; }
break;
case  47:
if (this.peek == 47 ) { this.skipCommentSL(); continue; }
if (this.peek == 42 ) { this.skipCommentML(); continue; }
break;
}
throw this.err("Unexpected symbol: " + this.cur + " (0x" + this.cur.toString(16) + ")");
}
}
fanx_Tokenizer.prototype.id = function()
{
var val = "";
var first = this.cur;
while ((this.curt == fanx_Tokenizer.ALPHA || this.curt == fanx_Tokenizer.DIGIT) && this.cur > 0)
{
val += String.fromCharCode(this.cur);
this.consume();
}
switch (first)
{
case  97:
if (val == "as") { return fanx_Token.AS; }
break;
case  102:
if (val == "false") { this.val = false; return fanx_Token.BOOL_LITERAL; }
break;
case  110:
if (val == "null") { this.val = null; return fanx_Token.NULL_LITERAL; }
break;
case  116:
if (val == "true") { this.val = true; return fanx_Token.BOOL_LITERAL; }
break;
case  117:
if (val == "using") { return fanx_Token.USING; }
break;
}
this.val = val;
return fanx_Token.ID;
}
fanx_Tokenizer.prototype.number = function(neg)
{
if (this.cur == 48 && this.peek == 120/*'x'*/)
return this.hex();
var s = null;
var whole = 0;
var wholeCount = 0;
while (this.curt == fanx_Tokenizer.DIGIT)
{
if (s != null)
{
s += String.fromCharCode(this.cur);
}
else
{
whole = whole*10 + (this.cur - 48);
wholeCount++;
if (wholeCount >= 18) { s = (neg) ? "-" : ""; s += whole; }
}
this.consume();
if (this.cur == 95) this.consume();
}
var floating = false;
if (this.cur == 46 && this.peekt == fanx_Tokenizer.DIGIT)
{
floating = true;
if (s == null) { s = (neg) ? "-" : ""; s += whole; }
s += '.';
this.consume();
while (this.curt == fanx_Tokenizer.DIGIT)
{
s += String.fromCharCode(this.cur);
this.consume();
if (this.cur == 95) this.consume();
}
}
if (this.cur == 101 || this.cur == 69/*'E'*/)
{
floating = true;
if (s == null) { s = (neg) ? "-" : ""; s += whole; }
s += 'e';
this.consume();
if (this.cur == 45 || this.cur == 43/*'+'*/) { s += String.fromCharCode(this.cur); this.consume(); }
if (this.curt != fanx_Tokenizer.DIGIT) throw this.err("Expected exponent digits");
while (this.curt == fanx_Tokenizer.DIGIT)
{
s += String.fromCharCode(this.cur);
this.consume();
if (this.cur == 95) this.consume();
}
}
var floatSuffix  = false;
var decimalSuffix = false;
var dur = -1;
if (100 <= this.cur && this.cur <= 115/*'s'*/)
{
if (this.cur == 110 && this.peek == 115/*'s'*/) { this.consume(); this.consume(); dur = 1; }
if (this.cur == 109 && this.peek == 115/*'s'*/) { this.consume(); this.consume(); dur = 1000000; }
if (this.cur == 115 && this.peek == 101/*'e'*/) { this.consume(); this.consume(); if (this.cur != 99/*'c'*/) throw this.err("Expected 'sec' in Duration literal"); this.consume(); dur = 1000000000; }
if (this.cur == 109 && this.peek == 105/*'i'*/) { this.consume(); this.consume(); if (this.cur != 110/*'n'*/) throw this.err("Expected 'min' in Duration literal"); this.consume(); dur = 60000000000; }
if (this.cur == 104 && this.peek == 114/*'r'*/) { this.consume(); this.consume(); dur = 3600000000000; }
if (this.cur == 100 && this.peek == 97/*'a'*/)  { this.consume(); this.consume(); if (this.cur != 121/*'y'*/) throw this.err("Expected 'day' in Duration literal"); this.consume(); dur = 86400000000000; }
}
if (this.cur == 102 || this.cur == 70/*'F'*/)
{
this.consume();
floatSuffix = true;
}
else if (this.cur == 100 || this.cur == 68/*'D'*/)
{
this.consume();
decimalSuffix = true;
}
if (neg) whole = -whole;
try
{
if (floatSuffix)
{
if (s == null)
this.val = fan.sys.Float.make(whole);
else
this.val = fan.sys.Float.fromStr(s);
return fanx_Token.FLOAT_LITERAL;
}
if (decimalSuffix || floating)
{
var num = (s == null) ? whole : fan.sys.Float.fromStr(s);
if (dur > 0)
{
this.val = fan.sys.Duration.make(num * dur);
return fanx_Token.DURATION_LITERAL;
}
else
{
this.val = fan.sys.Decimal.make(num);
return fanx_Token.DECIMAL_LITERAL;
}
}
var num = (s == null) ? whole : Math.floor(fan.sys.Float.fromStr(s, true));
if (dur > 0)
{
this.val = fan.sys.Duration.make(num*dur);
return fanx_Token.DURATION_LITERAL;
}
else
{
this.val = num;
return fanx_Token.INT_LITERAL;
}
}
catch (e)
{
throw this.err("Invalid numeric literal: " + s);
}
}
fanx_Tokenizer.prototype.hex = function()
{
this.consume();
this.consume();
var type = fanx_Token.INT_LITERAL;
var val = this.$hex(this.cur);
if (val < 0) throw this.err("Expecting hex number");
var str = String.fromCharCode(this.cur);
this.consume();
var nibCount = 1;
while (true)
{
var nib = this.$hex(this.cur);
if (nib < 0)
{
if (this.cur == 95) { this.consume(); continue; }
break;
}
str += String.fromCharCode(this.cur);
nibCount++;
if (nibCount > 16) throw this.err("Hex literal too big");
this.consume();
}
this.val = Long.fromStr(str, 16);
return type;
}
fanx_Tokenizer.prototype.$hex = function(c)
{
if (48 <= c && c <= 57) return c - 48;
if (97 <= c && c <= 102) return c - 97 + 10;
if (65 <= c && c <= 70) return c - 65 + 10;
return -1;
}
fanx_Tokenizer.prototype.str = function()
{
this.consume();
var s = "";
var loop = true;
while (loop)
{
switch (this.cur)
{
case 34:   this.consume(); loop = false; break;
case -1:          throw this.err("Unexpected end of string");
case 36:   throw this.err("Interpolated strings unsupported");
case 92:  s += this.escape(); break;
case 13:  s += '\n'; this.consume(); break;
default:          s += String.fromCharCode(this.cur); this.consume(); break;
}
}
this.val = s;
return fanx_Token.STR_LITERAL;
}
fanx_Tokenizer.prototype.ch = function()
{
this.consume();
var c;
if (this.cur == 92)
{
c = this.escape();
}
else
{
c = this.cur;
this.consume();
}
if (this.cur != 39) throw this.err("Expecting ' close of char literal");
this.consume();
this.val = c;
return fanx_Token.INT_LITERAL;
}
fanx_Tokenizer.prototype.escape = function()
{
if (this.cur != 92) throw this.err("Internal error");
this.consume();
switch (this.cur)
{
case   98:   this.consume(); return '\b';
case   102:  this.consume(); return '\f';
case   110:  this.consume(); return '\n';
case   114:  this.consume(); return '\r';
case   116:  this.consume(); return '\t';
case   36:   this.consume(); return '$';
case   34:   this.consume(); return '"';
case  39:   this.consume(); return '\'';
case   96:   this.consume(); return '`';
case  92:   this.consume(); return '\\';
}
if (this.cur == 117)
{
this.consume();
var n3 = this.$hex(this.cur); this.consume();
var n2 = this.$hex(this.cur); this.consume();
var n1 = this.$hex(this.cur); this.consume();
var n0 = this.$hex(this.cur); this.consume();
if (n3 < 0 || n2 < 0 || n1 < 0 || n0 < 0) throw this.err("Invalid hex value for \\uxxxx");
return String.fromCharCode((n3 << 12) | (n2 << 8) | (n1 << 4) | n0);
}
throw this.err("Invalid escape sequence");
}
fanx_Tokenizer.prototype.uri = function()
{
this.consume();
var s = "";
while (true)
{
if (this.cur < 0) throw this.err("Unexpected end of uri");
if (this.cur == 92)
{
s += this.escape();
}
else
{
if (this.cur == 96) { this.consume(); break; }
s += String.fromCharCode(this.cur);
this.consume();
}
}
this.val = fan.sys.Uri.fromStr(s);
return fanx_Token.URI_LITERAL;
}
fanx_Tokenizer.prototype.skipCommentSL = function()
{
this.consume();
this.consume();
while (true)
{
if (this.cur == 10 || this.cur == 13/*'\r'*/) { this.consume(); break; }
if (this.cur < 0) break;
this.consume();
}
return null;
}
fanx_Tokenizer.prototype.skipCommentML = function()
{
this.consume();
this.consume();
var depth = 1;
while (true)
{
if (this.cur == 42 && this.peek == 47/*'/'*/) { this.consume(); this.consume(); depth--; if (depth <= 0) break; }
if (this.cur == 47 && this.peek == 42/*'*'*/) { this.consume(); this.consume(); depth++; continue; }
if (this.cur < 0) break;
this.consume();
}
return null;
}
fanx_Tokenizer.prototype.err = function(msg)
{
return fanx_ObjDecoder.err(msg, this.line);
}
fanx_Tokenizer.prototype.consume = function()
{
if (this.cur == 10 || this.cur == 13/*'\r'*/) this.line++;
var c = this.input.readChar();
if (c == 10 && this.peek == 13/*'\r'*/) c = this.input.readChar();
if (c == null) c = -1;
this.cur   = this.peek;
this.curt  = this.peekt;
this.peek  = c;
this.peekt = 0 < c && c < 128 ? fanx_Tokenizer.charMap[c] : fanx_Tokenizer.ALPHA;
}
fanx_Tokenizer.prototype.undo = function(type, val, line)
{
if (this.$undo != null) throw new fan.sys.Err.make("only one pushback supported");
this.$undo = new fanx_Undo(type, val, line);
}
fanx_Tokenizer.prototype.reset = function(type, val, line)
{
this.type = type;
this.val  = val;
this.line = line;
return type;
}
fanx_Tokenizer.charMap = [];
fanx_Tokenizer.SPACE = 1;
fanx_Tokenizer.ALPHA = 2;
fanx_Tokenizer.DIGIT = 3;
fanx_Tokenizer.charMap[32 ]  = fanx_Tokenizer.SPACE;
fanx_Tokenizer.charMap[10 ] = fanx_Tokenizer.SPACE;
fanx_Tokenizer.charMap[13 ] = fanx_Tokenizer.SPACE;
fanx_Tokenizer.charMap[9  ] = fanx_Tokenizer.SPACE;
for (var i=97; i<=122/*'z'*/; ++i) fanx_Tokenizer.charMap[i] = fanx_Tokenizer.ALPHA;
for (var i=65; i<=90/*'Z'*/;  ++i) fanx_Tokenizer.charMap[i] = fanx_Tokenizer.ALPHA;
fanx_Tokenizer.charMap[95 ] = fanx_Tokenizer.ALPHA;
for (var i=48; i<=57/*'9'*/; ++i) fanx_Tokenizer.charMap[i] = fanx_Tokenizer.DIGIT;
function fanx_Undo(t, v, l) { this.type = t; this.val = v; this.line = l; }
fanx_Undo.prototype.reset = function(t) { t.reset(this.type, this.val, this.line); }
function fanx_TypeParser(sig, checked)
{
this.sig     = sig;
this.len     = sig.length;
this.pos     = 0;
this.cur     = sig.charAt(this.pos);
this.peek    = sig.charAt(this.pos+1);
this.checked = checked;
}
fanx_TypeParser.prototype.loadTop = function()
{
var type = this.load();
if (this.cur != null) throw this.err();
return type;
}
fanx_TypeParser.prototype.load = function()
{
var type;
if (this.cur == '|')
type = this.loadFunc();
else if (this.cur == '[' && this.sig.indexOf("[java]") != -1)
throw fan.sys.ArgErr.make("Java types not allowed '" + this.sig + "'");
else if (this.cur == '[')
type = this.loadMap();
else
type = this.loadBasic();
if (this.cur == '?')
{
this.consume('?');
type = type.toNullable();
}
while (this.cur == '[')
{
this.consume('[');
this.consume(']');
type = type.toListOf();
}
if (this.cur == '?')
{
this.consume('?');
type = type.toNullable();
}
return type;
}
fanx_TypeParser.prototype.loadMap = function()
{
this.consume('[');
var key = this.load();
this.consume(':');
var val = this.load();
this.consume(']');
return new fan.sys.MapType(key, val);
}
fanx_TypeParser.prototype.loadFunc = function()
{
this.consume('|');
var params = [];
if (this.cur != '-')
{
while (true)
{
params.push(this.load());
if (this.cur == '-') break;
this.consume(',');
}
}
this.consume('-');
this.consume('>');
var ret = this.load();
this.consume('|');
return new fan.sys.FuncType(params, ret);
}
fanx_TypeParser.prototype.loadBasic = function()
{
var podName = this.consumeId();
this.consume(':');
this.consume(':');
var typeName = this.consumeId();
if (typeName.length == 1 && podName == "sys")
{
throw fan.sys.Err.make("TODO - generic paramaters");
}
return fanx_TypeParser.find(podName, typeName, this.checked);
}
fanx_TypeParser.prototype.consumeId = function()
{
var start = this.pos;
while (this.isIdChar(this.cur)) this.$consume();
return this.sig.substring(start, this.pos);
}
fanx_TypeParser.prototype.isIdChar = function(ch)
{
if (ch == null) return false;
return fan.sys.Int.isAlphaNum(ch.charCodeAt(0)) || ch == '_';
}
fanx_TypeParser.prototype.consume = function(expected)
{
if (this.cur != expected) throw this.err();
this.$consume();
}
fanx_TypeParser.prototype.$consume = function()
{
this.cur = this.peek;
this.pos++;
this.peek = this.pos+1 < this.len ? this.sig.charAt(this.pos+1) : null;
}
fanx_TypeParser.prototype.err = function(sig)
{
if (sig == undefined) sig = this.sig;
return fan.sys.ArgErr.make("Invalid type signature '" + sig + "'");
}
fanx_TypeParser.load = function(sig, checked)
{
var type = fanx_TypeParser.cache[sig];
if (type != null) return type;
var len = sig.length;
var last = len > 1 ? sig.charAt(len-1) : 0;
if (last == '?')
{
type = fanx_TypeParser.load(sig.substring(0, len-1), checked).toNullable();
fanx_TypeParser.cache[sig] = type;
return type;
}
if (last != ']' && last != '|')
{
var podName;
var typeName;
try
{
var colon = sig.indexOf(":");
if (sig.charAt(colon+1) != ':') throw new Exception();
podName  = sig.substring(0, colon);
typeName = sig.substring(colon+2);
if (podName.length == 0 || typeName.length == 0) throw fan.sys.Err.make("");
}
catch (err)
{
throw fan.sys.ArgErr.make("Invalid type signature '" + sig + "', use <pod>::<type>");
}
if (podName.charAt(0) == '[')
throw fan.sys.ArgErr.make("Java types not allowed '" + sig + "'");
type = fanx_TypeParser.find(podName, typeName, checked);
fanx_TypeParser.cache[sig] = type;
return type;
}
try
{
type = new fanx_TypeParser(sig, checked).loadTop();
fanx_TypeParser.cache[sig] = type;
return type;
}
catch (err)
{
throw fan.sys.Err.make(err);
}
}
fanx_TypeParser.find = function(podName, typeName, checked)
{
var pod = fan.sys.Pod.find(podName, checked);
if (pod == null) return null;
return pod.findType(typeName, checked);
}
fanx_TypeParser.cache = [];
with (fan.sys.Pod.$add("sys"))
{
$at("Obj",       null);
$at("Num",       "sys::Obj");
$at("Enum",      "sys::Obj");
$at("Bool",      "sys::Obj");
$at("Duration",  "sys::Obj");
$at("Func",      "sys::Obj");
$at("Int",       "sys::Num");
$at("Decimal",   "sys::Num");
$at("Float",     "sys::Num");
$at("List",      "sys::Obj");
$at("Map",       "sys::Obj");
$at("Month",     "sys::Enum");
$at("Pod",       "sys::Obj");
$at("Range",     "sys::Obj");
$at("Str",       "sys::Obj");
$at("StrBuf",    "sys::Obj");
$at("Test",      "sys::Obj");
$at("DateTime",  "sys::Obj");
$at("Date",      "sys::Obj");
$at("Time",      "sys::Obj");
$at("TimeZone",  "sys::Obj");
$at("Type",      "sys::Obj");
$at("Weekday",   "sys::Enum");
$at("Void",      "sys::Obj");
$at("Slot",      "sys::Obj");
$at("Field",     "sys::Slot");
$at("Method",    "sys::Slot");
$at("Param",     "sys::Obj");
$at("Namespace", "sys::Obj");
$at("Charset",   "sys::Obj");
$at("InStream",  "sys::Obj");
$at("OutStream", "sys::Obj");
$at("File",      "sys::Obj");
$at("Buf",       "sys::Obj");
$at("Uri",       "sys::Obj");
$at("Actor",     "sys::Obj");
$at("Log",       "sys::Obj");
$at("Locale",    "sys::Obj");
$at("MimeType",  "sys::Obj");
$at("Err",       "sys::Obj");
$at("ArgErr",    "sys::Err");
$at("IOErr",     "sys::Err");
$at("IndexErr",  "sys::Err");
$at("NullErr",        "sys::Err");
$at("ParseErr",       "sys::Err");
$at("ReadonlyErr",    "sys::Err");
$at("UnknownPodErr",  "sys::Err");
$at("UnknownSlotErr", "sys::Err");
$at("UnknownTypeErr", "sys::Err");
$at("UnresolvedErr",  "sys::Err");
$at("UnsupportedErr", "sys::Err");
};
fan.sys.Float.posInf = fan.sys.Float.make(Number.POSITIVE_INFINITY);
fan.sys.Float.negInf = fan.sys.Float.make(Number.NEGATIVE_INFINITY);
fan.sys.Float.nan    = fan.sys.Float.make(Number.NaN);
fan.sys.Float.e      = fan.sys.Float.make(Math.E);
fan.sys.Float.pi     = fan.sys.Float.make(Math.PI);
fan.sys.Int.maxVal = new Long(0x7fffffff, 0xffffffff);
fan.sys.Int.minVal = new Long(0x80000000, 0x00000000);
fan.sys.Int.defVal = 0;
fan.sys.Int.Chunk  = 4096;
fan.sys.MimeType.imagePng  = fan.sys.MimeType.predefined("image", "png");
fan.sys.MimeType.imageGif  = fan.sys.MimeType.predefined("image", "gif");
fan.sys.MimeType.imageJpeg = fan.sys.MimeType.predefined("image", "jpeg");
fan.sys.MimeType.textPlain = fan.sys.MimeType.predefined("text", "plain");
fan.sys.MimeType.textHtml  = fan.sys.MimeType.predefined("text", "html");
fan.sys.MimeType.textXml   = fan.sys.MimeType.predefined("text", "xml");
fan.sys.MimeType.dir       = fan.sys.MimeType.predefined("x-directory", "normal");
fan.sys.UriPodBase = "/sys/pod/";
fan.sys.Month.values = fan.sys.List.make(fan.sys.Type.find("sys::Month"),
[
fan.sys.Month.jan, fan.sys.Month.feb, fan.sys.Month.mar, fan.sys.Month.apr, fan.sys.Month.may, fan.sys.Month.jun,
fan.sys.Month.jul, fan.sys.Month.aug, fan.sys.Month.sep, fan.sys.Month.oct, fan.sys.Month.nov, fan.sys.Month.dec
]);
var tz,rule;
tz = new fan.sys.TimeZone();
tz.m_name = "Chicago";
tz.m_fullName = "America/Chicago";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 2007;
rule.offset = -21600;
rule.stdAbbr = "CST";
rule.dstOffset = 3600;
rule.dstAbbr = "CDT";
rule.dstStart = new fan.sys.TimeZone$DstTime(2, 62, 0, 8, 7200, 119);
rule.dstEnd = new fan.sys.TimeZone$DstTime(10, 62, 0, 1, 7200, 119);
tz.m_rules.push(rule);
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -21600;
rule.stdAbbr = "CST";
rule.dstOffset = 3600;
rule.dstAbbr = "CDT";
rule.dstStart = new fan.sys.TimeZone$DstTime(3, 62, 0, 1, 7200, 119);
rule.dstEnd = new fan.sys.TimeZone$DstTime(9, 108, 0, 0, 7200, 119);
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["Chicago"] = tz;
fan.sys.TimeZone.cache["America/Chicago"] = tz;
fan.sys.TimeZone.names.push("Chicago");
fan.sys.TimeZone.fullNames.push("America/Chicago");
tz = new fan.sys.TimeZone();
tz.m_name = "Denver";
tz.m_fullName = "America/Denver";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 2007;
rule.offset = -25200;
rule.stdAbbr = "MST";
rule.dstOffset = 3600;
rule.dstAbbr = "MDT";
rule.dstStart = new fan.sys.TimeZone$DstTime(2, 62, 0, 8, 7200, 119);
rule.dstEnd = new fan.sys.TimeZone$DstTime(10, 62, 0, 1, 7200, 119);
tz.m_rules.push(rule);
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -25200;
rule.stdAbbr = "MST";
rule.dstOffset = 3600;
rule.dstAbbr = "MDT";
rule.dstStart = new fan.sys.TimeZone$DstTime(3, 62, 0, 1, 7200, 119);
rule.dstEnd = new fan.sys.TimeZone$DstTime(9, 108, 0, 0, 7200, 119);
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["Denver"] = tz;
fan.sys.TimeZone.cache["America/Denver"] = tz;
fan.sys.TimeZone.names.push("Denver");
fan.sys.TimeZone.fullNames.push("America/Denver");
tz = new fan.sys.TimeZone();
tz.m_name = "Los_Angeles";
tz.m_fullName = "America/Los_Angeles";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 2007;
rule.offset = -28800;
rule.stdAbbr = "PST";
rule.dstOffset = 3600;
rule.dstAbbr = "PDT";
rule.dstStart = new fan.sys.TimeZone$DstTime(2, 62, 0, 8, 7200, 119);
rule.dstEnd = new fan.sys.TimeZone$DstTime(10, 62, 0, 1, 7200, 119);
tz.m_rules.push(rule);
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -28800;
rule.stdAbbr = "PST";
rule.dstOffset = 3600;
rule.dstAbbr = "PDT";
rule.dstStart = new fan.sys.TimeZone$DstTime(3, 62, 0, 1, 7200, 119);
rule.dstEnd = new fan.sys.TimeZone$DstTime(9, 108, 0, 0, 7200, 119);
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["Los_Angeles"] = tz;
fan.sys.TimeZone.cache["America/Los_Angeles"] = tz;
fan.sys.TimeZone.names.push("Los_Angeles");
fan.sys.TimeZone.fullNames.push("America/Los_Angeles");
tz = new fan.sys.TimeZone();
tz.m_name = "New_York";
tz.m_fullName = "America/New_York";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 2007;
rule.offset = -18000;
rule.stdAbbr = "EST";
rule.dstOffset = 3600;
rule.dstAbbr = "EDT";
rule.dstStart = new fan.sys.TimeZone$DstTime(2, 62, 0, 8, 7200, 119);
rule.dstEnd = new fan.sys.TimeZone$DstTime(10, 62, 0, 1, 7200, 119);
tz.m_rules.push(rule);
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -18000;
rule.stdAbbr = "EST";
rule.dstOffset = 3600;
rule.dstAbbr = "EDT";
rule.dstStart = new fan.sys.TimeZone$DstTime(3, 62, 0, 1, 7200, 119);
rule.dstEnd = new fan.sys.TimeZone$DstTime(9, 108, 0, 0, 7200, 119);
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["New_York"] = tz;
fan.sys.TimeZone.cache["America/New_York"] = tz;
fan.sys.TimeZone.names.push("New_York");
fan.sys.TimeZone.fullNames.push("America/New_York");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT";
tz.m_fullName = "Etc/GMT";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 0;
rule.stdAbbr = "GMT";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT"] = tz;
fan.sys.TimeZone.cache["Etc/GMT"] = tz;
fan.sys.TimeZone.names.push("GMT");
fan.sys.TimeZone.fullNames.push("Etc/GMT");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+1";
tz.m_fullName = "Etc/GMT+1";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -3600;
rule.stdAbbr = "GMT+1";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+1"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+1"] = tz;
fan.sys.TimeZone.names.push("GMT+1");
fan.sys.TimeZone.fullNames.push("Etc/GMT+1");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+10";
tz.m_fullName = "Etc/GMT+10";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -36000;
rule.stdAbbr = "GMT+10";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+10"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+10"] = tz;
fan.sys.TimeZone.names.push("GMT+10");
fan.sys.TimeZone.fullNames.push("Etc/GMT+10");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+11";
tz.m_fullName = "Etc/GMT+11";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -39600;
rule.stdAbbr = "GMT+11";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+11"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+11"] = tz;
fan.sys.TimeZone.names.push("GMT+11");
fan.sys.TimeZone.fullNames.push("Etc/GMT+11");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+12";
tz.m_fullName = "Etc/GMT+12";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -43200;
rule.stdAbbr = "GMT+12";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+12"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+12"] = tz;
fan.sys.TimeZone.names.push("GMT+12");
fan.sys.TimeZone.fullNames.push("Etc/GMT+12");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+2";
tz.m_fullName = "Etc/GMT+2";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -7200;
rule.stdAbbr = "GMT+2";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+2"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+2"] = tz;
fan.sys.TimeZone.names.push("GMT+2");
fan.sys.TimeZone.fullNames.push("Etc/GMT+2");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+3";
tz.m_fullName = "Etc/GMT+3";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -10800;
rule.stdAbbr = "GMT+3";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+3"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+3"] = tz;
fan.sys.TimeZone.names.push("GMT+3");
fan.sys.TimeZone.fullNames.push("Etc/GMT+3");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+4";
tz.m_fullName = "Etc/GMT+4";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -14400;
rule.stdAbbr = "GMT+4";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+4"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+4"] = tz;
fan.sys.TimeZone.names.push("GMT+4");
fan.sys.TimeZone.fullNames.push("Etc/GMT+4");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+5";
tz.m_fullName = "Etc/GMT+5";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -18000;
rule.stdAbbr = "GMT+5";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+5"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+5"] = tz;
fan.sys.TimeZone.names.push("GMT+5");
fan.sys.TimeZone.fullNames.push("Etc/GMT+5");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+6";
tz.m_fullName = "Etc/GMT+6";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -21600;
rule.stdAbbr = "GMT+6";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+6"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+6"] = tz;
fan.sys.TimeZone.names.push("GMT+6");
fan.sys.TimeZone.fullNames.push("Etc/GMT+6");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+7";
tz.m_fullName = "Etc/GMT+7";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -25200;
rule.stdAbbr = "GMT+7";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+7"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+7"] = tz;
fan.sys.TimeZone.names.push("GMT+7");
fan.sys.TimeZone.fullNames.push("Etc/GMT+7");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+8";
tz.m_fullName = "Etc/GMT+8";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -28800;
rule.stdAbbr = "GMT+8";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+8"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+8"] = tz;
fan.sys.TimeZone.names.push("GMT+8");
fan.sys.TimeZone.fullNames.push("Etc/GMT+8");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+9";
tz.m_fullName = "Etc/GMT+9";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -32400;
rule.stdAbbr = "GMT+9";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+9"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+9"] = tz;
fan.sys.TimeZone.names.push("GMT+9");
fan.sys.TimeZone.fullNames.push("Etc/GMT+9");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-1";
tz.m_fullName = "Etc/GMT-1";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 3600;
rule.stdAbbr = "GMT-1";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-1"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-1"] = tz;
fan.sys.TimeZone.names.push("GMT-1");
fan.sys.TimeZone.fullNames.push("Etc/GMT-1");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-10";
tz.m_fullName = "Etc/GMT-10";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 36000;
rule.stdAbbr = "GMT-10";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-10"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-10"] = tz;
fan.sys.TimeZone.names.push("GMT-10");
fan.sys.TimeZone.fullNames.push("Etc/GMT-10");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-11";
tz.m_fullName = "Etc/GMT-11";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 39600;
rule.stdAbbr = "GMT-11";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-11"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-11"] = tz;
fan.sys.TimeZone.names.push("GMT-11");
fan.sys.TimeZone.fullNames.push("Etc/GMT-11");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-12";
tz.m_fullName = "Etc/GMT-12";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 43200;
rule.stdAbbr = "GMT-12";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-12"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-12"] = tz;
fan.sys.TimeZone.names.push("GMT-12");
fan.sys.TimeZone.fullNames.push("Etc/GMT-12");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-13";
tz.m_fullName = "Etc/GMT-13";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 46800;
rule.stdAbbr = "GMT-13";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-13"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-13"] = tz;
fan.sys.TimeZone.names.push("GMT-13");
fan.sys.TimeZone.fullNames.push("Etc/GMT-13");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-14";
tz.m_fullName = "Etc/GMT-14";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 50400;
rule.stdAbbr = "GMT-14";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-14"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-14"] = tz;
fan.sys.TimeZone.names.push("GMT-14");
fan.sys.TimeZone.fullNames.push("Etc/GMT-14");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-2";
tz.m_fullName = "Etc/GMT-2";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 7200;
rule.stdAbbr = "GMT-2";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-2"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-2"] = tz;
fan.sys.TimeZone.names.push("GMT-2");
fan.sys.TimeZone.fullNames.push("Etc/GMT-2");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-3";
tz.m_fullName = "Etc/GMT-3";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 10800;
rule.stdAbbr = "GMT-3";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-3"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-3"] = tz;
fan.sys.TimeZone.names.push("GMT-3");
fan.sys.TimeZone.fullNames.push("Etc/GMT-3");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-4";
tz.m_fullName = "Etc/GMT-4";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 14400;
rule.stdAbbr = "GMT-4";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-4"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-4"] = tz;
fan.sys.TimeZone.names.push("GMT-4");
fan.sys.TimeZone.fullNames.push("Etc/GMT-4");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-5";
tz.m_fullName = "Etc/GMT-5";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 18000;
rule.stdAbbr = "GMT-5";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-5"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-5"] = tz;
fan.sys.TimeZone.names.push("GMT-5");
fan.sys.TimeZone.fullNames.push("Etc/GMT-5");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-6";
tz.m_fullName = "Etc/GMT-6";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 21600;
rule.stdAbbr = "GMT-6";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-6"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-6"] = tz;
fan.sys.TimeZone.names.push("GMT-6");
fan.sys.TimeZone.fullNames.push("Etc/GMT-6");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-7";
tz.m_fullName = "Etc/GMT-7";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 25200;
rule.stdAbbr = "GMT-7";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-7"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-7"] = tz;
fan.sys.TimeZone.names.push("GMT-7");
fan.sys.TimeZone.fullNames.push("Etc/GMT-7");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-8";
tz.m_fullName = "Etc/GMT-8";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 28800;
rule.stdAbbr = "GMT-8";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-8"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-8"] = tz;
fan.sys.TimeZone.names.push("GMT-8");
fan.sys.TimeZone.fullNames.push("Etc/GMT-8");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-9";
tz.m_fullName = "Etc/GMT-9";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 32400;
rule.stdAbbr = "GMT-9";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-9"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-9"] = tz;
fan.sys.TimeZone.names.push("GMT-9");
fan.sys.TimeZone.fullNames.push("Etc/GMT-9");
tz = new fan.sys.TimeZone();
tz.m_name = "UTC";
tz.m_fullName = "Etc/UTC";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 0;
rule.stdAbbr = "UTC";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["UTC"] = tz;
fan.sys.TimeZone.cache["Etc/UTC"] = tz;
fan.sys.TimeZone.names.push("UTC");
fan.sys.TimeZone.fullNames.push("Etc/UTC");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT";
tz.m_fullName = "Etc/GMT";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 0;
rule.stdAbbr = "GMT";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT"] = tz;
fan.sys.TimeZone.cache["Etc/GMT"] = tz;
fan.sys.TimeZone.names.push("GMT");
fan.sys.TimeZone.fullNames.push("Etc/GMT");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+1";
tz.m_fullName = "Etc/GMT+1";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -3600;
rule.stdAbbr = "GMT+1";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+1"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+1"] = tz;
fan.sys.TimeZone.names.push("GMT+1");
fan.sys.TimeZone.fullNames.push("Etc/GMT+1");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+10";
tz.m_fullName = "Etc/GMT+10";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -36000;
rule.stdAbbr = "GMT+10";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+10"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+10"] = tz;
fan.sys.TimeZone.names.push("GMT+10");
fan.sys.TimeZone.fullNames.push("Etc/GMT+10");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+11";
tz.m_fullName = "Etc/GMT+11";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -39600;
rule.stdAbbr = "GMT+11";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+11"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+11"] = tz;
fan.sys.TimeZone.names.push("GMT+11");
fan.sys.TimeZone.fullNames.push("Etc/GMT+11");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+12";
tz.m_fullName = "Etc/GMT+12";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -43200;
rule.stdAbbr = "GMT+12";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+12"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+12"] = tz;
fan.sys.TimeZone.names.push("GMT+12");
fan.sys.TimeZone.fullNames.push("Etc/GMT+12");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+2";
tz.m_fullName = "Etc/GMT+2";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -7200;
rule.stdAbbr = "GMT+2";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+2"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+2"] = tz;
fan.sys.TimeZone.names.push("GMT+2");
fan.sys.TimeZone.fullNames.push("Etc/GMT+2");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+3";
tz.m_fullName = "Etc/GMT+3";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -10800;
rule.stdAbbr = "GMT+3";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+3"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+3"] = tz;
fan.sys.TimeZone.names.push("GMT+3");
fan.sys.TimeZone.fullNames.push("Etc/GMT+3");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+4";
tz.m_fullName = "Etc/GMT+4";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -14400;
rule.stdAbbr = "GMT+4";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+4"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+4"] = tz;
fan.sys.TimeZone.names.push("GMT+4");
fan.sys.TimeZone.fullNames.push("Etc/GMT+4");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+5";
tz.m_fullName = "Etc/GMT+5";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -18000;
rule.stdAbbr = "GMT+5";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+5"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+5"] = tz;
fan.sys.TimeZone.names.push("GMT+5");
fan.sys.TimeZone.fullNames.push("Etc/GMT+5");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+6";
tz.m_fullName = "Etc/GMT+6";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -21600;
rule.stdAbbr = "GMT+6";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+6"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+6"] = tz;
fan.sys.TimeZone.names.push("GMT+6");
fan.sys.TimeZone.fullNames.push("Etc/GMT+6");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+7";
tz.m_fullName = "Etc/GMT+7";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -25200;
rule.stdAbbr = "GMT+7";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+7"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+7"] = tz;
fan.sys.TimeZone.names.push("GMT+7");
fan.sys.TimeZone.fullNames.push("Etc/GMT+7");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+8";
tz.m_fullName = "Etc/GMT+8";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -28800;
rule.stdAbbr = "GMT+8";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+8"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+8"] = tz;
fan.sys.TimeZone.names.push("GMT+8");
fan.sys.TimeZone.fullNames.push("Etc/GMT+8");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT+9";
tz.m_fullName = "Etc/GMT+9";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = -32400;
rule.stdAbbr = "GMT+9";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT+9"] = tz;
fan.sys.TimeZone.cache["Etc/GMT+9"] = tz;
fan.sys.TimeZone.names.push("GMT+9");
fan.sys.TimeZone.fullNames.push("Etc/GMT+9");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-1";
tz.m_fullName = "Etc/GMT-1";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 3600;
rule.stdAbbr = "GMT-1";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-1"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-1"] = tz;
fan.sys.TimeZone.names.push("GMT-1");
fan.sys.TimeZone.fullNames.push("Etc/GMT-1");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-10";
tz.m_fullName = "Etc/GMT-10";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 36000;
rule.stdAbbr = "GMT-10";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-10"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-10"] = tz;
fan.sys.TimeZone.names.push("GMT-10");
fan.sys.TimeZone.fullNames.push("Etc/GMT-10");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-11";
tz.m_fullName = "Etc/GMT-11";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 39600;
rule.stdAbbr = "GMT-11";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-11"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-11"] = tz;
fan.sys.TimeZone.names.push("GMT-11");
fan.sys.TimeZone.fullNames.push("Etc/GMT-11");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-12";
tz.m_fullName = "Etc/GMT-12";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 43200;
rule.stdAbbr = "GMT-12";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-12"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-12"] = tz;
fan.sys.TimeZone.names.push("GMT-12");
fan.sys.TimeZone.fullNames.push("Etc/GMT-12");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-13";
tz.m_fullName = "Etc/GMT-13";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 46800;
rule.stdAbbr = "GMT-13";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-13"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-13"] = tz;
fan.sys.TimeZone.names.push("GMT-13");
fan.sys.TimeZone.fullNames.push("Etc/GMT-13");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-14";
tz.m_fullName = "Etc/GMT-14";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 50400;
rule.stdAbbr = "GMT-14";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-14"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-14"] = tz;
fan.sys.TimeZone.names.push("GMT-14");
fan.sys.TimeZone.fullNames.push("Etc/GMT-14");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-2";
tz.m_fullName = "Etc/GMT-2";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 7200;
rule.stdAbbr = "GMT-2";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-2"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-2"] = tz;
fan.sys.TimeZone.names.push("GMT-2");
fan.sys.TimeZone.fullNames.push("Etc/GMT-2");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-3";
tz.m_fullName = "Etc/GMT-3";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 10800;
rule.stdAbbr = "GMT-3";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-3"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-3"] = tz;
fan.sys.TimeZone.names.push("GMT-3");
fan.sys.TimeZone.fullNames.push("Etc/GMT-3");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-4";
tz.m_fullName = "Etc/GMT-4";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 14400;
rule.stdAbbr = "GMT-4";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-4"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-4"] = tz;
fan.sys.TimeZone.names.push("GMT-4");
fan.sys.TimeZone.fullNames.push("Etc/GMT-4");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-5";
tz.m_fullName = "Etc/GMT-5";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 18000;
rule.stdAbbr = "GMT-5";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-5"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-5"] = tz;
fan.sys.TimeZone.names.push("GMT-5");
fan.sys.TimeZone.fullNames.push("Etc/GMT-5");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-6";
tz.m_fullName = "Etc/GMT-6";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 21600;
rule.stdAbbr = "GMT-6";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-6"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-6"] = tz;
fan.sys.TimeZone.names.push("GMT-6");
fan.sys.TimeZone.fullNames.push("Etc/GMT-6");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-7";
tz.m_fullName = "Etc/GMT-7";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 25200;
rule.stdAbbr = "GMT-7";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-7"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-7"] = tz;
fan.sys.TimeZone.names.push("GMT-7");
fan.sys.TimeZone.fullNames.push("Etc/GMT-7");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-8";
tz.m_fullName = "Etc/GMT-8";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 28800;
rule.stdAbbr = "GMT-8";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-8"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-8"] = tz;
fan.sys.TimeZone.names.push("GMT-8");
fan.sys.TimeZone.fullNames.push("Etc/GMT-8");
tz = new fan.sys.TimeZone();
tz.m_name = "GMT-9";
tz.m_fullName = "Etc/GMT-9";
tz.m_rules = [];
rule = new fan.sys.TimeZone$Rule();
rule.startYear = 1995;
rule.offset = 32400;
rule.stdAbbr = "GMT-9";
rule.dstOffset = 0;
tz.m_rules.push(rule);
fan.sys.TimeZone.cache["GMT-9"] = tz;
fan.sys.TimeZone.cache["Etc/GMT-9"] = tz;
fan.sys.TimeZone.names.push("GMT-9");
fan.sys.TimeZone.fullNames.push("Etc/GMT-9");
